// TJC implementation of procedure compileproc_assign_arg
package tjc;
import tcl.lang.*;

public class CompileprocAssignArgCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 3, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "name index");
        }
        setVarScalar(interp, "name", objv[1], compiledLocals, 0);
        setVarScalar(interp, "index", objv[2], compiledLocals, 1);
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: string is integer $index
                TclObject[] objv0 = TJC.grabObjv(interp, 4);
                TclObject tmp1;
                try {
                    // Arg 0 constant: string
                    objv0[0] = const0;
                    // Arg 1 constant: is
                    objv0[1] = const1;
                    // Arg 2 constant: integer
                    objv0[2] = const2;
                    // Arg 3 variable: $index
                    tmp1 = getVarScalar(interp, "index", compiledLocals, 1);
                    tmp1.preserve();
                    objv0[3] = tmp1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv0, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp1 = objv0[3];
                    if ( tmp1 != null ) {
                        tmp1.release();
                    }
                    TJC.releaseObjv(interp, objv0, 4);
                }
            } // End Invoke: string
            TclObject tmp2 = interp.getResult();
            ExprValue tmp3 = evs0;
            if ( tmp2.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp3, tmp2);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp3, tmp2);
            }
            // End Unary operator: !
            boolean tmp4 = ( tmp3.getIntValue() != 0 );
            if ( tmp4 ) {
                { // Invoke: error "..."
                    TclObject[] objv5 = TJC.grabObjv(interp, 2);
                    TclObject tmp6;
                    try {
                        // Arg 0 constant: error
                        objv5[0] = const3;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp7 = new StringBuffer(64);
                        sbtmp7.append("index ");
                        tmp6 = getVarScalar(interp, "index", compiledLocals, 1);
                        sbtmp7.append(tmp6.toString());
                        sbtmp7.append(" is not an integer");
                        tmp6 = TclString.newInstance(sbtmp7);
                        tmp6.preserve();
                        objv5[1] = tmp6;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv5, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp6 = objv5[1];
                        if ( tmp6 != null ) {
                            tmp6.release();
                        }
                        TJC.releaseObjv(interp, objv5, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: if {$index < 1} ...
            // Binary operator: $index < 1
            TclObject tmp8 = getVarScalar(interp, "index", compiledLocals, 1);
            ExprValue tmp9 = evs0;
            TJC.exprInitValue(interp, tmp9, tmp8);
            ExprValue tmp10 = evs1;
            tmp10.setIntValue(1);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp9, tmp10);
            // End Binary operator: <
            boolean tmp11 = ( tmp9.getIntValue() != 0 );
            if ( tmp11 ) {
                { // Invoke: error "..."
                    TclObject[] objv12 = TJC.grabObjv(interp, 2);
                    TclObject tmp13;
                    try {
                        // Arg 0 constant: error
                        objv12[0] = const3;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp14 = new StringBuffer(64);
                        sbtmp14.append("index ");
                        tmp13 = getVarScalar(interp, "index", compiledLocals, 1);
                        sbtmp14.append(tmp13.toString());
                        sbtmp14.append(" must be greater than 0");
                        tmp13 = TclString.newInstance(sbtmp14);
                        tmp13.preserve();
                        objv12[1] = tmp13;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv12, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp13 = objv12[1];
                        if ( tmp13 != null ) {
                            tmp13.release();
                        }
                        TJC.releaseObjv(interp, objv12, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set value ...
            TclObject tmp15;
            StringBuffer sbtmp16 = new StringBuffer(64);
            sbtmp16.append("objv");
            sbtmp16.append("[");
            tmp15 = getVarScalar(interp, "index", compiledLocals, 1);
            sbtmp16.append(tmp15.toString());
            sbtmp16.append("]");
            tmp15 = TclString.newInstance(sbtmp16);
            setVarScalar(interp, "value", tmp15, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: return [...]
            { // Invoke: ... {} $name true $value false
                TclObject[] objv17 = TJC.grabObjv(interp, 6);
                TclObject tmp18;
                try {
                    // Arg 0 constant: ...
                    objv17[0] = const4;
                    // Arg 1 constant: {}
                    objv17[1] = const5;
                    // Arg 2 variable: $name
                    tmp18 = getVarScalar(interp, "name", compiledLocals, 0);
                    tmp18.preserve();
                    objv17[2] = tmp18;
                    // Arg 3 constant: true
                    objv17[3] = const6;
                    // Arg 4 variable: $value
                    tmp18 = getVarScalar(interp, "value", compiledLocals, 2);
                    tmp18.preserve();
                    objv17[4] = tmp18;
                    // Arg 5 constant: false
                    objv17[5] = const7;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv17, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp18 = objv17[2];
                    if ( tmp18 != null ) {
                        tmp18.release();
                    }
                    tmp18 = objv17[4];
                    if ( tmp18 != null ) {
                        tmp18.release();
                    }
                    TJC.releaseObjv(interp, objv17, 6);
                }
            } // End Invoke: ...
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_assign_arg");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("string");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("is");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("integer");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("error");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("compileproc_set_variable");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("true");
        TclBoolean.get(interp, const6);
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("false");
        TclBoolean.get(interp, const7);
        const7.preserve(); const7.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "string";
                break;
            }
            case 2: {
                cmdName = "error";
                break;
            }
            case 3: {
                cmdName = "compileproc_set_variable";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "name",
        "index",
        "value"
    };
} // end class CompileprocAssignArgCmd

