// TJC implementation of procedure compileproc_can_inline_command_append
package tjc;
import tcl.lang.*;

public class CompileprocCanInlineCommandAppendCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 4, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 1);
        } // End Invoke: global
        { // Invoke: set tree [...]
            TclObject tmp0;
            { // Invoke: descend_get_data $key tree
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: descend_get_data
                    objv1[0] = const0;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 constant: tree
                    objv1[2] = const1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: descend_get_data
            tmp0 = interp.getResult();
            setVarScalar(interp, "tree", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set num_args [...]
            TclObject tmp3;
            { // Invoke: llength $tree
                TclObject tmp4 = getVarScalar(interp, "tree", compiledLocals, 2);
                int tmp5 = TclList.getLength(interp, tmp4);
                interp.setResult(tmp5);
            } // End Invoke: llength
            tmp3 = interp.getResult();
            setVarScalar(interp, "num_args", tmp3, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: if {$num_args < 3} ...
            // Binary operator: $num_args < 3
            TclObject tmp6 = getVarScalar(interp, "num_args", compiledLocals, 3);
            ExprValue tmp7 = evs0;
            TJC.exprInitValue(interp, tmp7, tmp6);
            ExprValue tmp8 = evs1;
            tmp8.setIntValue(3);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp7, tmp8);
            // End Binary operator: <
            boolean tmp9 = ( tmp7.getIntValue() != 0 );
            if ( tmp9 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const2);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: ... $key 1
                TclObject[] objv10 = TJC.grabObjv(interp, 3);
                TclObject tmp11;
                try {
                    // Arg 0 constant: ...
                    objv10[0] = const3;
                    // Arg 1 variable: $key
                    tmp11 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp11.preserve();
                    objv10[1] = tmp11;
                    // Arg 2 constant: 1
                    objv10[2] = const4;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv10, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp11 = objv10[1];
                    if ( tmp11 != null ) {
                        tmp11.release();
                    }
                    TJC.releaseObjv(interp, objv10, 3);
                }
            } // End Invoke: ...
            TclObject tmp12 = interp.getResult();
            ExprValue tmp13 = evs0;
            if ( tmp12.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp13, tmp12);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp13, tmp12);
            }
            // End Unary operator: !
            boolean tmp14 = ( tmp13.getIntValue() != 0 );
            if ( tmp14 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const2);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: return 1
            interp.resetResult();
            interp.setResult(const4);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_can_inline_command_append");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("descend_get_data");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("tree");
        const1.preserve(); const1.preserve();
        const2 = TclInteger.newInstance(0);
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("compileproc_can_inline_variable_access");
        const3.preserve(); const3.preserve();
        const4 = TclInteger.newInstance(1);
        const4.preserve(); const4.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_get_data";
                break;
            }
            case 2: {
                cmdName = "compileproc_can_inline_variable_access";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_compileproc",
        "tree",
        "num_args"
    };
} // end class CompileprocCanInlineCommandAppendCmd

