// TJC implementation of procedure compileproc_container_foreach_loop_end
package tjc;
import tcl.lang.*;

public class CompileprocContainerForeachLoopEndCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 4, compiledLocalsNames);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "key list_symbols");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        setVarScalar(interp, "list_symbols", objv[2], compiledLocals, 1);
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: append buffer [...]
            TclObject[] objv0 = TJC.grabObjv(interp, 1);
            TclObject tmp1;
            try {
                // Arg 2 command: [...]
                { // Invoke: ... [...]
                    TclObject[] objv2 = TJC.grabObjv(interp, 2);
                    TclObject tmp3;
                    try {
                        // Arg 0 constant: ...
                        objv2[0] = const1;
                        // Arg 1 command: [...]
                        { // Invoke: ... $key
                            TclObject[] objv4 = TJC.grabObjv(interp, 2);
                            TclObject tmp5;
                            try {
                                // Arg 0 constant: ...
                                objv4[0] = const2;
                                // Arg 1 variable: $key
                                tmp5 = getVarScalar(interp, "key", compiledLocals, 0);
                                tmp5.preserve();
                                objv4[1] = tmp5;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv4, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                tmp5 = objv4[1];
                                if ( tmp5 != null ) {
                                    tmp5.release();
                                }
                                TJC.releaseObjv(interp, objv4, 2);
                            }
                        } // End Invoke: ...
                        tmp3 = interp.getResult();
                        tmp3.preserve();
                        objv2[1] = tmp3;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv2, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp3 = objv2[1];
                        if ( tmp3 != null ) {
                            tmp3.release();
                        }
                        TJC.releaseObjv(interp, objv2, 2);
                    }
                } // End Invoke: ...
                tmp1 = interp.getResult();
                tmp1.preserve();
                objv0[0] = tmp1;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv0, compiledLocals, 2);
            } finally {
                TJC.releaseObjvElems(interp, objv0, 1);
            }
        } // End Invoke: append
        { // Invoke: append buffer [...]
            TclObject[] objv6 = TJC.grabObjv(interp, 1);
            TclObject tmp7;
            try {
                // Arg 2 command: [...]
                { // Invoke: ...
                    TclObject[] objv8 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: ...
                        objv8[0] = const3;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv8, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv8, 1);
                    }
                } // End Invoke: ...
                tmp7 = interp.getResult();
                tmp7.preserve();
                objv6[0] = tmp7;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv6, compiledLocals, 2);
            } finally {
                TJC.releaseObjvElems(interp, objv6, 1);
            }
        } // End Invoke: append
        { // Invoke: foreach list_symbol $list_symbols ...
            TclObject tmp9 = null;
            try {
                tmp9 = getVarScalar(interp, "list_symbols", compiledLocals, 1);
                tmp9.preserve();
                final int tmp9_length = TclList.getLength(interp, tmp9);

                for ( int index10 = 0 ; index10 < tmp9_length ; index10++ ) {
                    TclObject tmp11 = TclList.index(interp, tmp9, index10);
                    try {
                        setVarScalar(interp, "list_symbol", tmp11, compiledLocals, 3);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "list_symbol");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: append buffer [...]
                        TclObject[] objv12 = TJC.grabObjv(interp, 1);
                        TclObject tmp13;
                        try {
                            // Arg 2 command: [...]
                            { // Invoke: ... $list_symbol
                                TclObject[] objv14 = TJC.grabObjv(interp, 2);
                                TclObject tmp15;
                                try {
                                    // Arg 0 constant: ...
                                    objv14[0] = const4;
                                    // Arg 1 variable: $list_symbol
                                    tmp15 = getVarScalar(interp, "list_symbol", compiledLocals, 3);
                                    tmp15.preserve();
                                    objv14[1] = tmp15;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                        ? cmdcache4.cmd : null), objv14, 0);
                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                        updateCmdCache(interp, 4);
                                    }
                                } finally {
                                    tmp15 = objv14[1];
                                    if ( tmp15 != null ) {
                                        tmp15.release();
                                    }
                                    TJC.releaseObjv(interp, objv14, 2);
                                }
                            } // End Invoke: ...
                            tmp13 = interp.getResult();
                            tmp13.preserve();
                            objv12[0] = tmp13;
                            interp.resetResult();
                            appendVarScalar(interp, "buffer", objv12, compiledLocals, 2);
                        } finally {
                            TJC.releaseObjvElems(interp, objv12, 1);
                        }
                    } // End Invoke: append
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp9 != null ) {
                    tmp9.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: append buffer [...]
            TclObject[] objv16 = TJC.grabObjv(interp, 1);
            TclObject tmp17;
            try {
                // Arg 2 command: [...]
                { // Invoke: ...
                    TclObject[] objv18 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: ...
                        objv18[0] = const5;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                            ? cmdcache5.cmd : null), objv18, 0);
                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                            updateCmdCache(interp, 5);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv18, 1);
                    }
                } // End Invoke: ...
                tmp17 = interp.getResult();
                tmp17.preserve();
                objv16[0] = tmp17;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv16, compiledLocals, 2);
            } finally {
                TJC.releaseObjvElems(interp, objv16, 1);
            }
        } // End Invoke: append
        { // Invoke: return $buffer
            TclObject tmp19 = getVarScalar(interp, "buffer", compiledLocals, 2);
            interp.resetResult();
            interp.setResult(tmp19);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_container_foreach_loop_end");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("emitter_container_for_end");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("compileproc_omit_set_result");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("emitter_container_foreach_try_finally");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("emitter_container_foreach_list_release");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("emitter_container_foreach_try_finally_end");
        const5.preserve(); const5.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "compileproc_omit_set_result";
                break;
            }
            case 2: {
                cmdName = "emitter_container_for_end";
                break;
            }
            case 3: {
                cmdName = "emitter_container_foreach_try_finally";
                break;
            }
            case 4: {
                cmdName = "emitter_container_foreach_list_release";
                break;
            }
            case 5: {
                cmdName = "emitter_container_foreach_try_finally_end";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "list_symbols",
        "buffer",
        "list_symbol"
    };
} // end class CompileprocContainerForeachLoopEndCmd

