// TJC implementation of procedure compileproc_emit_array_variable_get
package tjc;
import tcl.lang.*;

public class CompileprocEmitArrayVariableGetCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 8, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 5) {
            throw new TclNumArgsException(interp, 1, objv, "tmpsymbol vname key key_is_string");
        }
        setVarScalar(interp, "tmpsymbol", objv[1], compiledLocals, 0);
        setVarScalar(interp, "vname", objv[2], compiledLocals, 1);
        setVarScalar(interp, "key", objv[3], compiledLocals, 2);
        setVarScalar(interp, "key_is_string", objv[4], compiledLocals, 3);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 4);
        } // End Invoke: global
        { // Invoke: if ... ... else ...
            // Binary operator: () && $_compileproc(...)
            // Binary operator: () && [...]
            // Binary operator: () || ()
            // Binary operator: [...] == ()
            { // Invoke: string first "::" $vname
                String tmp0 = "::";
                TclObject tmp1 = getVarScalar(interp, "vname", compiledLocals, 1);
                String tmp2 = tmp1.toString();
                int tmp3 = tmp2.indexOf(tmp0);
                interp.setResult(tmp3);
            } // End Invoke: string
            TclObject tmp4 = interp.getResult();
            ExprValue tmp5 = evs0;
            TJC.exprInitValue(interp, tmp5, tmp4);
            // Unary operator: - 1
            ExprValue tmp6 = evs1;
            tmp6.setIntValue(-1);
            // End Unary operator: -
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp5, tmp6);
            // End Binary operator: ==
            if (!tmp5.getBooleanValue(interp)) {
            // Binary operator: [...] == "::"
            { // Invoke: string range $vname 0 1
                TclObject tmp7 = getVarScalar(interp, "vname", compiledLocals, 1);
                String tmp8 = tmp7.toString();
                TclObject tmp9 = const0;
                tmp9.preserve();
                TclObject tmp10 = const1;
                TclObject tmp11 = TJC.stringRange(interp, tmp8, tmp9, tmp10);
                interp.setResult(tmp11);
            } // End Invoke: string
            TclObject tmp12 = interp.getResult();
            boolean tmp13 = tmp12.toString().equals("::");
            ExprValue tmp14 = evs1;
            tmp14.setIntValue(tmp13);
            // End Binary operator: ==
            tmp5.setIntValue(tmp14.getBooleanValue(interp));
            } else {
            tmp5.setIntValue(1);
            } // End if: !()
            // End Binary operator: ||
            if (tmp5.getBooleanValue(interp)) {
            { // Invoke: info exists ...
                TclObject[] objv15 = TJC.grabObjv(interp, 3);
                try {
                    // Arg 0 constant: info
                    objv15[0] = const2;
                    // Arg 1 constant: exists
                    objv15[1] = const3;
                    // Arg 2 constant: ...
                    objv15[2] = const4;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv15, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv15, 3);
                }
            } // End Invoke: info
            TclObject tmp16 = interp.getResult();
            ExprValue tmp17 = evs1;
            TJC.exprInitValue(interp, tmp17, tmp16);
            tmp5.setIntValue(tmp17.getBooleanValue(interp));
            } else {
            tmp5.setIntValue(0);
            } // End if: ()
            // End Binary operator: &&
            if (tmp5.getBooleanValue(interp)) {
            TclObject tmp18 = getVarArray(interp, "_compileproc", "options,cache_variables", compiledLocals, 4);
            ExprValue tmp19 = evs1;
            TJC.exprInitValue(interp, tmp19, tmp18);
            tmp5.setIntValue(tmp19.getBooleanValue(interp));
            } else {
            tmp5.setIntValue(0);
            } // End if: ()
            // End Binary operator: &&
            boolean tmp20 = ( tmp5.getIntValue() != 0 );
            if ( tmp20 ) {
                { // Invoke: set symbol [...]
                    TclObject tmp21;
                    { // Invoke: ... $vname
                        TclObject[] objv22 = TJC.grabObjv(interp, 2);
                        TclObject tmp23;
                        try {
                            // Arg 0 constant: ...
                            objv22[0] = const5;
                            // Arg 1 variable: $vname
                            tmp23 = getVarScalar(interp, "vname", compiledLocals, 1);
                            tmp23.preserve();
                            objv22[1] = tmp23;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv22, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp23 = objv22[1];
                            if ( tmp23 != null ) {
                                tmp23.release();
                            }
                            TJC.releaseObjv(interp, objv22, 2);
                        }
                    } // End Invoke: ...
                    tmp21 = interp.getResult();
                    setVarScalar(interp, "symbol", tmp21, compiledLocals, 5);
                } // End Invoke: set
                { // Invoke: set cacheId [...]
                    TclObject tmp24;
                    { // Invoke: ... $symbol
                        TclObject[] objv25 = TJC.grabObjv(interp, 2);
                        TclObject tmp26;
                        try {
                            // Arg 0 constant: ...
                            objv25[0] = const6;
                            // Arg 1 variable: $symbol
                            tmp26 = getVarScalar(interp, "symbol", compiledLocals, 5);
                            tmp26.preserve();
                            objv25[1] = tmp26;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv25, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp26 = objv25[1];
                            if ( tmp26 != null ) {
                                tmp26.release();
                            }
                            TJC.releaseObjv(interp, objv25, 2);
                        }
                    } // End Invoke: ...
                    tmp24 = interp.getResult();
                    setVarScalar(interp, "cacheId", tmp24, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: set buffer ""
                    setVarScalar(interp, "buffer", const7, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: if ... ...
                    // Binary operator: [...] == "::"
                    { // Invoke: string range $vname 0 1
                        TclObject tmp27 = getVarScalar(interp, "vname", compiledLocals, 1);
                        String tmp28 = tmp27.toString();
                        TclObject tmp29 = const0;
                        tmp29.preserve();
                        TclObject tmp30 = const1;
                        TclObject tmp31 = TJC.stringRange(interp, tmp28, tmp29, tmp30);
                        interp.setResult(tmp31);
                    } // End Invoke: string
                    TclObject tmp32 = interp.getResult();
                    boolean tmp33 = tmp32.toString().equals("::");
                    ExprValue tmp34 = evs0;
                    tmp34.setIntValue(tmp33);
                    // End Binary operator: ==
                    boolean tmp35 = ( tmp34.getIntValue() != 0 );
                    if ( tmp35 ) {
                        { // Invoke: append buffer [...]
                            TclObject[] objv36 = TJC.grabObjv(interp, 1);
                            TclObject tmp37;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: ... $vname "compiledLocals" $cacheId
                                    TclObject[] objv38 = TJC.grabObjv(interp, 4);
                                    TclObject tmp39;
                                    try {
                                        // Arg 0 constant: ...
                                        objv38[0] = const8;
                                        // Arg 1 variable: $vname
                                        tmp39 = getVarScalar(interp, "vname", compiledLocals, 1);
                                        tmp39.preserve();
                                        objv38[1] = tmp39;
                                        // Arg 2 constant: "compiledLocals"
                                        objv38[2] = const9;
                                        // Arg 3 variable: $cacheId
                                        tmp39 = getVarScalar(interp, "cacheId", compiledLocals, 6);
                                        tmp39.preserve();
                                        objv38[3] = tmp39;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                            ? cmdcache4.cmd : null), objv38, 0);
                                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                            updateCmdCache(interp, 4);
                                        }
                                    } finally {
                                        tmp39 = objv38[1];
                                        if ( tmp39 != null ) {
                                            tmp39.release();
                                        }
                                        tmp39 = objv38[3];
                                        if ( tmp39 != null ) {
                                            tmp39.release();
                                        }
                                        TJC.releaseObjv(interp, objv38, 4);
                                    }
                                } // End Invoke: ...
                                tmp37 = interp.getResult();
                                tmp37.preserve();
                                objv36[0] = tmp37;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv36, compiledLocals, 7);
                            } finally {
                                TJC.releaseObjvElems(interp, objv36, 1);
                            }
                        } // End Invoke: append
                    }
                } // End Invoke: if
                { // Invoke: append buffer [...]
                    TclObject[] objv40 = TJC.grabObjv(interp, 1);
                    TclObject tmp41;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ... $tmpsymbol $vname $key $key_is_string "compiledLocals" $cacheId
                            TclObject[] objv42 = TJC.grabObjv(interp, 7);
                            TclObject tmp43;
                            try {
                                // Arg 0 constant: ...
                                objv42[0] = const10;
                                // Arg 1 variable: $tmpsymbol
                                tmp43 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
                                tmp43.preserve();
                                objv42[1] = tmp43;
                                // Arg 2 variable: $vname
                                tmp43 = getVarScalar(interp, "vname", compiledLocals, 1);
                                tmp43.preserve();
                                objv42[2] = tmp43;
                                // Arg 3 variable: $key
                                tmp43 = getVarScalar(interp, "key", compiledLocals, 2);
                                tmp43.preserve();
                                objv42[3] = tmp43;
                                // Arg 4 variable: $key_is_string
                                tmp43 = getVarScalar(interp, "key_is_string", compiledLocals, 3);
                                tmp43.preserve();
                                objv42[4] = tmp43;
                                // Arg 5 constant: "compiledLocals"
                                objv42[5] = const9;
                                // Arg 6 variable: $cacheId
                                tmp43 = getVarScalar(interp, "cacheId", compiledLocals, 6);
                                tmp43.preserve();
                                objv42[6] = tmp43;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                    ? cmdcache5.cmd : null), objv42, 0);
                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                    updateCmdCache(interp, 5);
                                }
                            } finally {
                                objv42[0] = null;
                                objv42[5] = null;
                                TJC.releaseObjvElems(interp, objv42, 7);
                            }
                        } // End Invoke: ...
                        tmp41 = interp.getResult();
                        tmp41.preserve();
                        objv40[0] = tmp41;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv40, compiledLocals, 7);
                    } finally {
                        TJC.releaseObjvElems(interp, objv40, 1);
                    }
                } // End Invoke: append
            } else {
                { // Invoke: set buffer [...]
                    TclObject tmp44;
                    { // Invoke: emitter_get_var $tmpsymbol $vname true $key $key_is_string 0
                        TclObject[] objv45 = TJC.grabObjv(interp, 7);
                        TclObject tmp46;
                        try {
                            // Arg 0 constant: emitter_get_var
                            objv45[0] = const11;
                            // Arg 1 variable: $tmpsymbol
                            tmp46 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
                            tmp46.preserve();
                            objv45[1] = tmp46;
                            // Arg 2 variable: $vname
                            tmp46 = getVarScalar(interp, "vname", compiledLocals, 1);
                            tmp46.preserve();
                            objv45[2] = tmp46;
                            // Arg 3 constant: true
                            objv45[3] = const12;
                            // Arg 4 variable: $key
                            tmp46 = getVarScalar(interp, "key", compiledLocals, 2);
                            tmp46.preserve();
                            objv45[4] = tmp46;
                            // Arg 5 variable: $key_is_string
                            tmp46 = getVarScalar(interp, "key_is_string", compiledLocals, 3);
                            tmp46.preserve();
                            objv45[5] = tmp46;
                            // Arg 6 constant: 0
                            objv45[6] = const0;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                ? cmdcache6.cmd : null), objv45, 0);
                            if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                updateCmdCache(interp, 6);
                            }
                        } finally {
                            tmp46 = objv45[1];
                            if ( tmp46 != null ) {
                                tmp46.release();
                            }
                            tmp46 = objv45[2];
                            if ( tmp46 != null ) {
                                tmp46.release();
                            }
                            tmp46 = objv45[4];
                            if ( tmp46 != null ) {
                                tmp46.release();
                            }
                            tmp46 = objv45[5];
                            if ( tmp46 != null ) {
                                tmp46.release();
                            }
                            TJC.releaseObjv(interp, objv45, 7);
                        }
                    } // End Invoke: emitter_get_var
                    tmp44 = interp.getResult();
                    setVarScalar(interp, "buffer", tmp44, compiledLocals, 7);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: return $buffer
            TclObject tmp47 = getVarScalar(interp, "buffer", compiledLocals, 7);
            interp.resetResult();
            interp.setResult(tmp47);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_emit_array_variable_get");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(0);
        const0.preserve(); const0.preserve();
        const1 = TclInteger.newInstance(1);
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("info");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("exists");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("_compileproc(options,cache_variables)");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("compileproc_variable_cache_lookup");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("compileproc_get_variable_cache_id_from_symbol");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("emitter_init_compiled_local_scoped_var");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("compiledLocals");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("emitter_get_compiled_local_array_var");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("emitter_get_var");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("true");
        TclBoolean.get(interp, const12);
        const12.preserve(); const12.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "info";
                break;
            }
            case 2: {
                cmdName = "compileproc_variable_cache_lookup";
                break;
            }
            case 3: {
                cmdName = "compileproc_get_variable_cache_id_from_symbol";
                break;
            }
            case 4: {
                cmdName = "emitter_init_compiled_local_scoped_var";
                break;
            }
            case 5: {
                cmdName = "emitter_get_compiled_local_array_var";
                break;
            }
            case 6: {
                cmdName = "emitter_get_var";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "tmpsymbol",
        "vname",
        "key",
        "key_is_string",
        "_compileproc",
        "symbol",
        "cacheId",
        "buffer"
    };
} // end class CompileprocEmitArrayVariableGetCmd

