// TJC implementation of procedure compileproc_emit_exprvalue_release
package tjc;
import tcl.lang.*;

public class CompileprocEmitExprvalueReleaseCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 4, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "symbol");
        }
        setVarScalar(interp, "symbol", objv[1], compiledLocals, 0);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 1);
        } // End Invoke: global
        { // Invoke: if ... ...
            TclObject tmp0 = getVarArray(interp, "_compileproc", "options,expr_value_stack", compiledLocals, 1);
            ExprValue tmp1 = evs0;
            TJC.exprInitValue(interp, tmp1, tmp0);
            boolean tmp2 = tmp1.getBooleanValue(interp);
            if ( tmp2 ) {
                { // Invoke: set buffer ""
                    setVarScalar(interp, "buffer", const0, compiledLocals, 2);
                } // End Invoke: set
                { // Invoke: if ... ...
                    TclObject tmp3 = getVarArray(interp, "_compileproc", "options,expr_value_stack_null", compiledLocals, 1);
                    ExprValue tmp4 = evs0;
                    TJC.exprInitValue(interp, tmp4, tmp3);
                    boolean tmp5 = tmp4.getBooleanValue(interp);
                    if ( tmp5 ) {
                        { // Invoke: set ev [...]
                            TclObject tmp6;
                            { // Invoke: ... $symbol
                                TclObject[] objv7 = TJC.grabObjv(interp, 2);
                                TclObject tmp8;
                                try {
                                    // Arg 0 constant: ...
                                    objv7[0] = const1;
                                    // Arg 1 variable: $symbol
                                    tmp8 = getVarScalar(interp, "symbol", compiledLocals, 0);
                                    tmp8.preserve();
                                    objv7[1] = tmp8;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                        ? cmdcache1.cmd : null), objv7, 0);
                                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                        updateCmdCache(interp, 1);
                                    }
                                } finally {
                                    tmp8 = objv7[1];
                                    if ( tmp8 != null ) {
                                        tmp8.release();
                                    }
                                    TJC.releaseObjv(interp, objv7, 2);
                                }
                            } // End Invoke: ...
                            tmp6 = interp.getResult();
                            setVarScalar(interp, "ev", tmp6, compiledLocals, 3);
                        } // End Invoke: set
                        { // Invoke: append buffer [...] $ev " = " $symbol ...
                            TclObject[] objv9 = TJC.grabObjv(interp, 5);
                            TclObject tmp10;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: emitter_indent
                                    TclObject[] objv11 = TJC.grabObjv(interp, 1);
                                    try {
                                        // Arg 0 constant: emitter_indent
                                        objv11[0] = const2;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                            ? cmdcache2.cmd : null), objv11, 0);
                                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                            updateCmdCache(interp, 2);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv11, 1);
                                    }
                                } // End Invoke: emitter_indent
                                tmp10 = interp.getResult();
                                tmp10.preserve();
                                objv9[0] = tmp10;
                                // Arg 3 variable: $ev
                                tmp10 = getVarScalar(interp, "ev", compiledLocals, 3);
                                tmp10.preserve();
                                objv9[1] = tmp10;
                                // Arg 4 constant: " = "
                                objv9[2] = const3;
                                // Arg 5 variable: $symbol
                                tmp10 = getVarScalar(interp, "symbol", compiledLocals, 0);
                                tmp10.preserve();
                                objv9[3] = tmp10;
                                // Arg 6 constant: ...
                                objv9[4] = const4;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv9, compiledLocals, 2);
                            } finally {
                                tmp10 = objv9[0];
                                if ( tmp10 != null ) {
                                    tmp10.release();
                                }
                                tmp10 = objv9[1];
                                if ( tmp10 != null ) {
                                    tmp10.release();
                                }
                                tmp10 = objv9[3];
                                if ( tmp10 != null ) {
                                    tmp10.release();
                                }
                                TJC.releaseObjv(interp, objv9, 5);
                            }
                        } // End Invoke: append
                    }
                } // End Invoke: if
                { // Invoke: ... $symbol
                    TclObject[] objv12 = TJC.grabObjv(interp, 2);
                    TclObject tmp13;
                    try {
                        // Arg 0 constant: ...
                        objv12[0] = const5;
                        // Arg 1 variable: $symbol
                        tmp13 = getVarScalar(interp, "symbol", compiledLocals, 0);
                        tmp13.preserve();
                        objv12[1] = tmp13;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv12, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp13 = objv12[1];
                        if ( tmp13 != null ) {
                            tmp13.release();
                        }
                        TJC.releaseObjv(interp, objv12, 2);
                    }
                } // End Invoke: ...
                { // Invoke: return $buffer
                    TclObject tmp14 = getVarScalar(interp, "buffer", compiledLocals, 2);
                    interp.resetResult();
                    interp.setResult(tmp14);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: append buffer [...] ... $symbol ")" ...
            TclObject[] objv15 = TJC.grabObjv(interp, 5);
            TclObject tmp16;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv17 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv17[0] = const2;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv17, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv17, 1);
                    }
                } // End Invoke: emitter_indent
                tmp16 = interp.getResult();
                tmp16.preserve();
                objv15[0] = tmp16;
                // Arg 3 constant: ...
                objv15[1] = const6;
                // Arg 4 variable: $symbol
                tmp16 = getVarScalar(interp, "symbol", compiledLocals, 0);
                tmp16.preserve();
                objv15[2] = tmp16;
                // Arg 5 constant: ")"
                objv15[3] = const7;
                // Arg 6 constant: ...
                objv15[4] = const4;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv15, compiledLocals, 2);
            } finally {
                tmp16 = objv15[0];
                if ( tmp16 != null ) {
                    tmp16.release();
                }
                tmp16 = objv15[2];
                if ( tmp16 != null ) {
                    tmp16.release();
                }
                TJC.releaseObjv(interp, objv15, 5);
            }
        } // End Invoke: append
        { // Invoke: return $buffer
            TclObject tmp18 = getVarScalar(interp, "buffer", compiledLocals, 2);
            interp.resetResult();
            interp.setResult(tmp18);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_emit_exprvalue_release");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("compileproc_expr_value_stack_lookup_alias");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("emitter_indent");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance(" = ");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance(";\n");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("compileproc_expr_value_stack_release");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("TJC.exprReleaseValue(interp, ");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance(")");
        const7.preserve(); const7.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "compileproc_expr_value_stack_lookup_alias";
                break;
            }
            case 2: {
                cmdName = "emitter_indent";
                break;
            }
            case 3: {
                cmdName = "compileproc_expr_value_stack_release";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "symbol",
        "_compileproc",
        "buffer",
        "ev"
    };
} // end class CompileprocEmitExprvalueReleaseCmd

