// TJC implementation of procedure compileproc_emit_inline_command_lindex
package tjc;
import tcl.lang.*;

public class CompileprocEmitInlineCommandLindexCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 21, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 1);
        } // End Invoke: global
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set tree [...]
            TclObject tmp0;
            { // Invoke: descend_get_data $key tree
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: descend_get_data
                    objv1[0] = const1;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 constant: tree
                    objv1[2] = const2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: descend_get_data
            tmp0 = interp.getResult();
            setVarScalar(interp, "tree", tmp0, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set num_args [...]
            TclObject tmp3;
            { // Invoke: llength $tree
                TclObject tmp4 = getVarScalar(interp, "tree", compiledLocals, 3);
                int tmp5 = TclList.getLength(interp, tmp4);
                interp.setResult(tmp5);
            } // End Invoke: llength
            tmp3 = interp.getResult();
            setVarScalar(interp, "num_args", tmp3, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: if {$num_args != 3} ...
            // Binary operator: $num_args != 3
            TclObject tmp6 = getVarScalar(interp, "num_args", compiledLocals, 4);
            ExprValue tmp7 = evs0;
            TJC.exprInitValue(interp, tmp7, tmp6);
            ExprValue tmp8 = evs1;
            tmp8.setIntValue(3);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp7, tmp8);
            // End Binary operator: !=
            boolean tmp9 = ( tmp7.getIntValue() != 0 );
            if ( tmp9 ) {
                { // Invoke: error ...
                    TclObject[] objv10 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv10[0] = const3;
                        // Arg 1 constant: ...
                        objv10[1] = const4;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv10, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv10, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set ... 0
            setVarScalar(interp, "constant_integer_index", const5, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set tuple [...]
            TclObject tmp11;
            { // Invoke: ... $key 2
                TclObject[] objv12 = TJC.grabObjv(interp, 3);
                TclObject tmp13;
                try {
                    // Arg 0 constant: ...
                    objv12[0] = const6;
                    // Arg 1 variable: $key
                    tmp13 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp13.preserve();
                    objv12[1] = tmp13;
                    // Arg 2 constant: 2
                    objv12[2] = const7;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv12, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp13 = objv12[1];
                    if ( tmp13 != null ) {
                        tmp13.release();
                    }
                    TJC.releaseObjv(interp, objv12, 3);
                }
            } // End Invoke: ...
            tmp11 = interp.getResult();
            setVarScalar(interp, "tuple", tmp11, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set type [...]
            TclObject tmp14;
            { // Invoke: lindex $tuple 0
                TclObject tmp15 = getVarScalar(interp, "tuple", compiledLocals, 6);
                tmp15 = TclList.index(interp, tmp15, 0);
                if ( tmp15 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp15);
                }
            } // End Invoke: lindex
            tmp14 = interp.getResult();
            setVarScalar(interp, "type", tmp14, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: set value [...]
            TclObject tmp16;
            { // Invoke: lindex $tuple 1
                TclObject tmp17 = getVarScalar(interp, "tuple", compiledLocals, 6);
                tmp17 = TclList.index(interp, tmp17, 1);
                if ( tmp17 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp17);
                }
            } // End Invoke: lindex
            tmp16 = interp.getResult();
            setVarScalar(interp, "value", tmp16, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: $type == "constant"
            TclObject tmp18 = getVarScalar(interp, "type", compiledLocals, 7);
            boolean tmp19 = tmp18.toString().equals("constant");
            ExprValue tmp20 = evs0;
            tmp20.setIntValue(tmp19);
            // End Binary operator: ==
            boolean tmp21 = ( tmp20.getIntValue() != 0 );
            if ( tmp21 ) {
                { // Invoke: set is_integer [...]
                    TclObject tmp22;
                    { // Invoke: ... $value
                        TclObject[] objv23 = TJC.grabObjv(interp, 2);
                        TclObject tmp24;
                        try {
                            // Arg 0 constant: ...
                            objv23[0] = const8;
                            // Arg 1 variable: $value
                            tmp24 = getVarScalar(interp, "value", compiledLocals, 8);
                            tmp24.preserve();
                            objv23[1] = tmp24;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv23, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            tmp24 = objv23[1];
                            if ( tmp24 != null ) {
                                tmp24.release();
                            }
                            TJC.releaseObjv(interp, objv23, 2);
                        }
                    } // End Invoke: ...
                    tmp22 = interp.getResult();
                    setVarScalar(interp, "is_integer", tmp22, compiledLocals, 9);
                } // End Invoke: set
                { // Invoke: if {$is_integer} ...
                    TclObject tmp25 = getVarScalar(interp, "is_integer", compiledLocals, 9);
                    boolean tmp26 = TJC.getBoolean(interp, tmp25);
                    if ( tmp26 ) {
                        { // Invoke: set tuple [...]
                            TclObject tmp27;
                            { // Invoke: ... $value
                                TclObject[] objv28 = TJC.grabObjv(interp, 2);
                                TclObject tmp29;
                                try {
                                    // Arg 0 constant: ...
                                    objv28[0] = const9;
                                    // Arg 1 variable: $value
                                    tmp29 = getVarScalar(interp, "value", compiledLocals, 8);
                                    tmp29.preserve();
                                    objv28[1] = tmp29;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                        ? cmdcache5.cmd : null), objv28, 0);
                                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                        updateCmdCache(interp, 5);
                                    }
                                } finally {
                                    tmp29 = objv28[1];
                                    if ( tmp29 != null ) {
                                        tmp29.release();
                                    }
                                    TJC.releaseObjv(interp, objv28, 2);
                                }
                            } // End Invoke: ...
                            tmp27 = interp.getResult();
                            setVarScalar(interp, "tuple", tmp27, compiledLocals, 6);
                        } // End Invoke: set
                        { // Invoke: set stringrep_matches [...]
                            TclObject tmp30;
                            { // Invoke: lindex $tuple 0
                                TclObject tmp31 = getVarScalar(interp, "tuple", compiledLocals, 6);
                                tmp31 = TclList.index(interp, tmp31, 0);
                                if ( tmp31 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp31);
                                }
                            } // End Invoke: lindex
                            tmp30 = interp.getResult();
                            setVarScalar(interp, "stringrep_matches", tmp30, compiledLocals, 10);
                        } // End Invoke: set
                        { // Invoke: set parsed_number [...]
                            TclObject tmp32;
                            { // Invoke: lindex $tuple 1
                                TclObject tmp33 = getVarScalar(interp, "tuple", compiledLocals, 6);
                                tmp33 = TclList.index(interp, tmp33, 1);
                                if ( tmp33 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp33);
                                }
                            } // End Invoke: lindex
                            tmp32 = interp.getResult();
                            setVarScalar(interp, "parsed_number", tmp32, compiledLocals, 11);
                        } // End Invoke: set
                        { // Invoke: if {$stringrep_matches} ...
                            TclObject tmp34 = getVarScalar(interp, "stringrep_matches", compiledLocals, 10);
                            boolean tmp35 = TJC.getBoolean(interp, tmp34);
                            if ( tmp35 ) {
                                { // Invoke: set ... 1
                                    setVarScalar(interp, "constant_integer_index", const10, compiledLocals, 5);
                                } // End Invoke: set
                                { // Invoke: set index_symbol $parsed_number
                                    TclObject tmp36;
                                    tmp36 = getVarScalar(interp, "parsed_number", compiledLocals, 11);
                                    setVarScalar(interp, "index_symbol", tmp36, compiledLocals, 12);
                                } // End Invoke: set
                            }
                        } // End Invoke: if
                    }
                } // End Invoke: if
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            TclObject tmp37 = getVarScalar(interp, "constant_integer_index", compiledLocals, 5);
            boolean tmp38 = TJC.getBoolean(interp, tmp37);
            if ( tmp38 ) {
                { // Invoke: set tuple [...]
                    TclObject tmp39;
                    { // Invoke: ... $key 1 true {}
                        TclObject[] objv40 = TJC.grabObjv(interp, 5);
                        TclObject tmp41;
                        try {
                            // Arg 0 constant: ...
                            objv40[0] = const11;
                            // Arg 1 variable: $key
                            tmp41 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp41.preserve();
                            objv40[1] = tmp41;
                            // Arg 2 constant: 1
                            objv40[2] = const10;
                            // Arg 3 constant: true
                            objv40[3] = const12;
                            // Arg 4 constant: {}
                            objv40[4] = const0;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                ? cmdcache6.cmd : null), objv40, 0);
                            if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                updateCmdCache(interp, 6);
                            }
                        } finally {
                            tmp41 = objv40[1];
                            if ( tmp41 != null ) {
                                tmp41.release();
                            }
                            TJC.releaseObjv(interp, objv40, 5);
                        }
                    } // End Invoke: ...
                    tmp39 = interp.getResult();
                    setVarScalar(interp, "tuple", tmp39, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: set value_type [...]
                    TclObject tmp42;
                    { // Invoke: lindex $tuple 0
                        TclObject tmp43 = getVarScalar(interp, "tuple", compiledLocals, 6);
                        tmp43 = TclList.index(interp, tmp43, 0);
                        if ( tmp43 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp43);
                        }
                    } // End Invoke: lindex
                    tmp42 = interp.getResult();
                    setVarScalar(interp, "value_type", tmp42, compiledLocals, 13);
                } // End Invoke: set
                { // Invoke: set value_symbol [...]
                    TclObject tmp44;
                    { // Invoke: lindex $tuple 1
                        TclObject tmp45 = getVarScalar(interp, "tuple", compiledLocals, 6);
                        tmp45 = TclList.index(interp, tmp45, 1);
                        if ( tmp45 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp45);
                        }
                    } // End Invoke: lindex
                    tmp44 = interp.getResult();
                    setVarScalar(interp, "value_symbol", tmp44, compiledLocals, 14);
                } // End Invoke: set
                { // Invoke: set value_buffer [...]
                    TclObject tmp46;
                    { // Invoke: lindex $tuple 2
                        TclObject tmp47 = getVarScalar(interp, "tuple", compiledLocals, 6);
                        tmp47 = TclList.index(interp, tmp47, 2);
                        if ( tmp47 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp47);
                        }
                    } // End Invoke: lindex
                    tmp46 = interp.getResult();
                    setVarScalar(interp, "value_buffer", tmp46, compiledLocals, 15);
                } // End Invoke: set
                { // Invoke: if ... ... else ...
                    // Binary operator: $value_type == "constant"
                    TclObject tmp48 = getVarScalar(interp, "value_type", compiledLocals, 13);
                    boolean tmp49 = tmp48.toString().equals("constant");
                    ExprValue tmp50 = evs0;
                    tmp50.setIntValue(tmp49);
                    // End Binary operator: ==
                    boolean tmp51 = ( tmp50.getIntValue() != 0 );
                    if ( tmp51 ) {
                        { // Invoke: set result_symbol [...]
                            TclObject tmp52;
                            { // Invoke: ...
                                TclObject[] objv53 = TJC.grabObjv(interp, 1);
                                try {
                                    // Arg 0 constant: ...
                                    objv53[0] = const13;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                        ? cmdcache7.cmd : null), objv53, 0);
                                    if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                        updateCmdCache(interp, 7);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv53, 1);
                                }
                            } // End Invoke: ...
                            tmp52 = interp.getResult();
                            setVarScalar(interp, "result_symbol", tmp52, compiledLocals, 16);
                        } // End Invoke: set
                        { // Invoke: set ... 1
                            setVarScalar(interp, "declare_result_symbol", const10, compiledLocals, 17);
                        } // End Invoke: set
                    } else {
                        { // Invoke: append buffer $value_buffer
                            TclObject[] objv54 = TJC.grabObjv(interp, 1);
                            TclObject tmp55;
                            try {
                                // Arg 2 variable: $value_buffer
                                tmp55 = getVarScalar(interp, "value_buffer", compiledLocals, 15);
                                tmp55.preserve();
                                objv54[0] = tmp55;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv54, compiledLocals, 2);
                            } finally {
                                TJC.releaseObjvElems(interp, objv54, 1);
                            }
                        } // End Invoke: append
                        { // Invoke: set result_symbol $value_symbol
                            TclObject tmp56;
                            tmp56 = getVarScalar(interp, "value_symbol", compiledLocals, 14);
                            setVarScalar(interp, "result_symbol", tmp56, compiledLocals, 16);
                        } // End Invoke: set
                        { // Invoke: set ... 0
                            setVarScalar(interp, "declare_result_symbol", const5, compiledLocals, 17);
                        } // End Invoke: set
                    }
                } // End Invoke: if
                { // Invoke: if ... ... else ...
                    TclObject tmp57 = getVarScalar(interp, "declare_result_symbol", compiledLocals, 17);
                    boolean tmp58 = TJC.getBoolean(interp, tmp57);
                    if ( tmp58 ) {
                        { // Invoke: append buffer [...] "TclObject " $result_symbol " = "
                            TclObject[] objv59 = TJC.grabObjv(interp, 4);
                            TclObject tmp60;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: emitter_indent
                                    TclObject[] objv61 = TJC.grabObjv(interp, 1);
                                    try {
                                        // Arg 0 constant: emitter_indent
                                        objv61[0] = const14;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                            ? cmdcache8.cmd : null), objv61, 0);
                                        if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                            updateCmdCache(interp, 8);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv61, 1);
                                    }
                                } // End Invoke: emitter_indent
                                tmp60 = interp.getResult();
                                tmp60.preserve();
                                objv59[0] = tmp60;
                                // Arg 3 constant: "TclObject "
                                objv59[1] = const15;
                                // Arg 4 variable: $result_symbol
                                tmp60 = getVarScalar(interp, "result_symbol", compiledLocals, 16);
                                tmp60.preserve();
                                objv59[2] = tmp60;
                                // Arg 5 constant: " = "
                                objv59[3] = const16;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv59, compiledLocals, 2);
                            } finally {
                                tmp60 = objv59[0];
                                if ( tmp60 != null ) {
                                    tmp60.release();
                                }
                                tmp60 = objv59[2];
                                if ( tmp60 != null ) {
                                    tmp60.release();
                                }
                                TJC.releaseObjv(interp, objv59, 4);
                            }
                        } // End Invoke: append
                    } else {
                        { // Invoke: append buffer [...] $result_symbol " = "
                            TclObject[] objv62 = TJC.grabObjv(interp, 3);
                            TclObject tmp63;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: emitter_indent
                                    TclObject[] objv64 = TJC.grabObjv(interp, 1);
                                    try {
                                        // Arg 0 constant: emitter_indent
                                        objv64[0] = const14;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                            ? cmdcache8.cmd : null), objv64, 0);
                                        if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                            updateCmdCache(interp, 8);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv64, 1);
                                    }
                                } // End Invoke: emitter_indent
                                tmp63 = interp.getResult();
                                tmp63.preserve();
                                objv62[0] = tmp63;
                                // Arg 3 variable: $result_symbol
                                tmp63 = getVarScalar(interp, "result_symbol", compiledLocals, 16);
                                tmp63.preserve();
                                objv62[1] = tmp63;
                                // Arg 4 constant: " = "
                                objv62[2] = const16;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv62, compiledLocals, 2);
                            } finally {
                                tmp63 = objv62[0];
                                if ( tmp63 != null ) {
                                    tmp63.release();
                                }
                                tmp63 = objv62[1];
                                if ( tmp63 != null ) {
                                    tmp63.release();
                                }
                                TJC.releaseObjv(interp, objv62, 3);
                            }
                        } // End Invoke: append
                    }
                } // End Invoke: if
                { // Invoke: append buffer ... $value_symbol ", " $index_symbol ... [...] [...] [...] [...] [...]
                    TclObject[] objv65 = TJC.grabObjv(interp, 10);
                    TclObject tmp66;
                    try {
                        // Arg 2 constant: ...
                        objv65[0] = const17;
                        // Arg 3 variable: $value_symbol
                        tmp66 = getVarScalar(interp, "value_symbol", compiledLocals, 14);
                        tmp66.preserve();
                        objv65[1] = tmp66;
                        // Arg 4 constant: ", "
                        objv65[2] = const18;
                        // Arg 5 variable: $index_symbol
                        tmp66 = getVarScalar(interp, "index_symbol", compiledLocals, 12);
                        tmp66.preserve();
                        objv65[3] = tmp66;
                        // Arg 6 constant: ...
                        objv65[4] = const19;
                        // Arg 7 command: [...]
                        { // Invoke: ... "..."
                            TclObject[] objv67 = TJC.grabObjv(interp, 2);
                            TclObject tmp68;
                            try {
                                // Arg 0 constant: ...
                                objv67[0] = const20;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp69 = new StringBuffer(64);
                                tmp68 = getVarScalar(interp, "result_symbol", compiledLocals, 16);
                                sbtmp69.append(tmp68.toString());
                                sbtmp69.append(" == null");
                                tmp68 = TclString.newInstance(sbtmp69);
                                tmp68.preserve();
                                objv67[1] = tmp68;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                    ? cmdcache9.cmd : null), objv67, 0);
                                if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                    updateCmdCache(interp, 9);
                                }
                            } finally {
                                tmp68 = objv67[1];
                                if ( tmp68 != null ) {
                                    tmp68.release();
                                }
                                TJC.releaseObjv(interp, objv67, 2);
                            }
                        } // End Invoke: ...
                        tmp66 = interp.getResult();
                        tmp66.preserve();
                        objv65[5] = tmp66;
                        // Arg 8 command: [...]
                        { // Invoke: emitter_reset_result
                            TclObject[] objv70 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: emitter_reset_result
                                objv70[0] = const21;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                    ? cmdcache10.cmd : null), objv70, 0);
                                if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                    updateCmdCache(interp, 10);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv70, 1);
                            }
                        } // End Invoke: emitter_reset_result
                        tmp66 = interp.getResult();
                        tmp66.preserve();
                        objv65[6] = tmp66;
                        // Arg 9 command: [...]
                        { // Invoke: ...
                            TclObject[] objv71 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: ...
                                objv71[0] = const22;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                                    ? cmdcache11.cmd : null), objv71, 0);
                                if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                                    updateCmdCache(interp, 11);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv71, 1);
                            }
                        } // End Invoke: ...
                        tmp66 = interp.getResult();
                        tmp66.preserve();
                        objv65[7] = tmp66;
                        // Arg 10 command: [...]
                        { // Invoke: emitter_set_result $result_symbol false
                            TclObject[] objv72 = TJC.grabObjv(interp, 3);
                            TclObject tmp73;
                            try {
                                // Arg 0 constant: emitter_set_result
                                objv72[0] = const23;
                                // Arg 1 variable: $result_symbol
                                tmp73 = getVarScalar(interp, "result_symbol", compiledLocals, 16);
                                tmp73.preserve();
                                objv72[1] = tmp73;
                                // Arg 2 constant: false
                                objv72[2] = const24;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache12_cmdEpoch == cmdcache12.cmdEpoch)
                                    ? cmdcache12.cmd : null), objv72, 0);
                                if ( cmdcache12_cmdEpoch != cmdcache12.cmdEpoch ) {
                                    updateCmdCache(interp, 12);
                                }
                            } finally {
                                tmp73 = objv72[1];
                                if ( tmp73 != null ) {
                                    tmp73.release();
                                }
                                TJC.releaseObjv(interp, objv72, 3);
                            }
                        } // End Invoke: emitter_set_result
                        tmp66 = interp.getResult();
                        tmp66.preserve();
                        objv65[8] = tmp66;
                        // Arg 11 command: [...]
                        { // Invoke: ...
                            TclObject[] objv74 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: ...
                                objv74[0] = const25;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache13_cmdEpoch == cmdcache13.cmdEpoch)
                                    ? cmdcache13.cmd : null), objv74, 0);
                                if ( cmdcache13_cmdEpoch != cmdcache13.cmdEpoch ) {
                                    updateCmdCache(interp, 13);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv74, 1);
                            }
                        } // End Invoke: ...
                        tmp66 = interp.getResult();
                        tmp66.preserve();
                        objv65[9] = tmp66;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv65, compiledLocals, 2);
                    } finally {
                        objv65[0] = null;
                        objv65[2] = null;
                        objv65[4] = null;
                        TJC.releaseObjvElems(interp, objv65, 10);
                    }
                } // End Invoke: append
                { // Invoke: return $buffer
                    TclObject tmp75 = getVarScalar(interp, "buffer", compiledLocals, 2);
                    interp.resetResult();
                    interp.setResult(tmp75);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set list_tmpsymbol [...]
            TclObject tmp76;
            { // Invoke: ...
                TclObject[] objv77 = TJC.grabObjv(interp, 1);
                try {
                    // Arg 0 constant: ...
                    objv77[0] = const13;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                        ? cmdcache7.cmd : null), objv77, 0);
                    if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                        updateCmdCache(interp, 7);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv77, 1);
                }
            } // End Invoke: ...
            tmp76 = interp.getResult();
            setVarScalar(interp, "list_tmpsymbol", tmp76, compiledLocals, 18);
        } // End Invoke: set
        { // Invoke: set index_tmpsymbol [...]
            TclObject tmp78;
            { // Invoke: ...
                TclObject[] objv79 = TJC.grabObjv(interp, 1);
                try {
                    // Arg 0 constant: ...
                    objv79[0] = const13;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                        ? cmdcache7.cmd : null), objv79, 0);
                    if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                        updateCmdCache(interp, 7);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv79, 1);
                }
            } // End Invoke: ...
            tmp78 = interp.getResult();
            setVarScalar(interp, "index_tmpsymbol", tmp78, compiledLocals, 19);
        } // End Invoke: set
        { // Invoke: append buffer [...] [...]
            TclObject[] objv80 = TJC.grabObjv(interp, 2);
            TclObject tmp81;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_statement "..."
                    TclObject[] objv82 = TJC.grabObjv(interp, 2);
                    TclObject tmp83;
                    try {
                        // Arg 0 constant: emitter_statement
                        objv82[0] = const26;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp84 = new StringBuffer(64);
                        sbtmp84.append("TclObject ");
                        tmp83 = getVarScalar(interp, "list_tmpsymbol", compiledLocals, 18);
                        sbtmp84.append(tmp83.toString());
                        sbtmp84.append(" = null");
                        tmp83 = TclString.newInstance(sbtmp84);
                        tmp83.preserve();
                        objv82[1] = tmp83;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache14_cmdEpoch == cmdcache14.cmdEpoch)
                            ? cmdcache14.cmd : null), objv82, 0);
                        if ( cmdcache14_cmdEpoch != cmdcache14.cmdEpoch ) {
                            updateCmdCache(interp, 14);
                        }
                    } finally {
                        tmp83 = objv82[1];
                        if ( tmp83 != null ) {
                            tmp83.release();
                        }
                        TJC.releaseObjv(interp, objv82, 2);
                    }
                } // End Invoke: emitter_statement
                tmp81 = interp.getResult();
                tmp81.preserve();
                objv80[0] = tmp81;
                // Arg 3 command: [...]
                { // Invoke: emitter_statement "..."
                    TclObject[] objv85 = TJC.grabObjv(interp, 2);
                    TclObject tmp86;
                    try {
                        // Arg 0 constant: emitter_statement
                        objv85[0] = const26;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp87 = new StringBuffer(64);
                        sbtmp87.append("TclObject ");
                        tmp86 = getVarScalar(interp, "index_tmpsymbol", compiledLocals, 19);
                        sbtmp87.append(tmp86.toString());
                        tmp86 = TclString.newInstance(sbtmp87);
                        tmp86.preserve();
                        objv85[1] = tmp86;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache14_cmdEpoch == cmdcache14.cmdEpoch)
                            ? cmdcache14.cmd : null), objv85, 0);
                        if ( cmdcache14_cmdEpoch != cmdcache14.cmdEpoch ) {
                            updateCmdCache(interp, 14);
                        }
                    } finally {
                        tmp86 = objv85[1];
                        if ( tmp86 != null ) {
                            tmp86.release();
                        }
                        TJC.releaseObjv(interp, objv85, 2);
                    }
                } // End Invoke: emitter_statement
                tmp81 = interp.getResult();
                tmp81.preserve();
                objv80[1] = tmp81;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv80, compiledLocals, 2);
            } finally {
                TJC.releaseObjvElems(interp, objv80, 2);
            }
        } // End Invoke: append
        { // Invoke: append buffer [...]
            TclObject[] objv88 = TJC.grabObjv(interp, 1);
            TclObject tmp89;
            try {
                // Arg 2 command: [...]
                { // Invoke: ...
                    TclObject[] objv90 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: ...
                        objv90[0] = const27;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache15_cmdEpoch == cmdcache15.cmdEpoch)
                            ? cmdcache15.cmd : null), objv90, 0);
                        if ( cmdcache15_cmdEpoch != cmdcache15.cmdEpoch ) {
                            updateCmdCache(interp, 15);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv90, 1);
                    }
                } // End Invoke: ...
                tmp89 = interp.getResult();
                tmp89.preserve();
                objv88[0] = tmp89;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv88, compiledLocals, 2);
            } finally {
                TJC.releaseObjvElems(interp, objv88, 1);
            }
        } // End Invoke: append
        { // Invoke: set i 1
            setVarScalar(interp, "i", const10, compiledLocals, 20);
        } // End Invoke: set
        { // Invoke: set tuple [...]
            TclObject tmp91;
            { // Invoke: ... $key $i false $list_tmpsymbol
                TclObject[] objv92 = TJC.grabObjv(interp, 5);
                TclObject tmp93;
                try {
                    // Arg 0 constant: ...
                    objv92[0] = const11;
                    // Arg 1 variable: $key
                    tmp93 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp93.preserve();
                    objv92[1] = tmp93;
                    // Arg 2 variable: $i
                    tmp93 = getVarScalar(interp, "i", compiledLocals, 20);
                    tmp93.preserve();
                    objv92[2] = tmp93;
                    // Arg 3 constant: false
                    objv92[3] = const24;
                    // Arg 4 variable: $list_tmpsymbol
                    tmp93 = getVarScalar(interp, "list_tmpsymbol", compiledLocals, 18);
                    tmp93.preserve();
                    objv92[4] = tmp93;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                        ? cmdcache6.cmd : null), objv92, 0);
                    if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                        updateCmdCache(interp, 6);
                    }
                } finally {
                    tmp93 = objv92[1];
                    if ( tmp93 != null ) {
                        tmp93.release();
                    }
                    tmp93 = objv92[2];
                    if ( tmp93 != null ) {
                        tmp93.release();
                    }
                    tmp93 = objv92[4];
                    if ( tmp93 != null ) {
                        tmp93.release();
                    }
                    TJC.releaseObjv(interp, objv92, 5);
                }
            } // End Invoke: ...
            tmp91 = interp.getResult();
            setVarScalar(interp, "tuple", tmp91, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set value_type [...]
            TclObject tmp94;
            { // Invoke: lindex $tuple 0
                TclObject tmp95 = getVarScalar(interp, "tuple", compiledLocals, 6);
                tmp95 = TclList.index(interp, tmp95, 0);
                if ( tmp95 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp95);
                }
            } // End Invoke: lindex
            tmp94 = interp.getResult();
            setVarScalar(interp, "value_type", tmp94, compiledLocals, 13);
        } // End Invoke: set
        { // Invoke: set value_symbol [...]
            TclObject tmp96;
            { // Invoke: lindex $tuple 1
                TclObject tmp97 = getVarScalar(interp, "tuple", compiledLocals, 6);
                tmp97 = TclList.index(interp, tmp97, 1);
                if ( tmp97 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp97);
                }
            } // End Invoke: lindex
            tmp96 = interp.getResult();
            setVarScalar(interp, "value_symbol", tmp96, compiledLocals, 14);
        } // End Invoke: set
        { // Invoke: set value_buffer [...]
            TclObject tmp98;
            { // Invoke: lindex $tuple 2
                TclObject tmp99 = getVarScalar(interp, "tuple", compiledLocals, 6);
                tmp99 = TclList.index(interp, tmp99, 2);
                if ( tmp99 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp99);
                }
            } // End Invoke: lindex
            tmp98 = interp.getResult();
            setVarScalar(interp, "value_buffer", tmp98, compiledLocals, 15);
        } // End Invoke: set
        { // Invoke: if ... ... else ...
            // Binary operator: $value_type == "constant"
            TclObject tmp100 = getVarScalar(interp, "value_type", compiledLocals, 13);
            boolean tmp101 = tmp100.toString().equals("constant");
            ExprValue tmp102 = evs0;
            tmp102.setIntValue(tmp101);
            // End Binary operator: ==
            boolean tmp103 = ( tmp102.getIntValue() != 0 );
            if ( tmp103 ) {
                { // Invoke: append buffer [...]
                    TclObject[] objv104 = TJC.grabObjv(interp, 1);
                    TclObject tmp105;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: emitter_statement "..."
                            TclObject[] objv106 = TJC.grabObjv(interp, 2);
                            TclObject tmp107;
                            try {
                                // Arg 0 constant: emitter_statement
                                objv106[0] = const26;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp108 = new StringBuffer(64);
                                tmp107 = getVarScalar(interp, "list_tmpsymbol", compiledLocals, 18);
                                sbtmp108.append(tmp107.toString());
                                sbtmp108.append(" = ");
                                tmp107 = getVarScalar(interp, "value_symbol", compiledLocals, 14);
                                sbtmp108.append(tmp107.toString());
                                tmp107 = TclString.newInstance(sbtmp108);
                                tmp107.preserve();
                                objv106[1] = tmp107;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache14_cmdEpoch == cmdcache14.cmdEpoch)
                                    ? cmdcache14.cmd : null), objv106, 0);
                                if ( cmdcache14_cmdEpoch != cmdcache14.cmdEpoch ) {
                                    updateCmdCache(interp, 14);
                                }
                            } finally {
                                tmp107 = objv106[1];
                                if ( tmp107 != null ) {
                                    tmp107.release();
                                }
                                TJC.releaseObjv(interp, objv106, 2);
                            }
                        } // End Invoke: emitter_statement
                        tmp105 = interp.getResult();
                        tmp105.preserve();
                        objv104[0] = tmp105;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv104, compiledLocals, 2);
                    } finally {
                        TJC.releaseObjvElems(interp, objv104, 1);
                    }
                } // End Invoke: append
            } else {
                { // Invoke: append buffer $value_buffer
                    TclObject[] objv109 = TJC.grabObjv(interp, 1);
                    TclObject tmp110;
                    try {
                        // Arg 2 variable: $value_buffer
                        tmp110 = getVarScalar(interp, "value_buffer", compiledLocals, 15);
                        tmp110.preserve();
                        objv109[0] = tmp110;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv109, compiledLocals, 2);
                    } finally {
                        TJC.releaseObjvElems(interp, objv109, 1);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: append buffer [...]
            TclObject[] objv111 = TJC.grabObjv(interp, 1);
            TclObject tmp112;
            try {
                // Arg 2 command: [...]
                { // Invoke: ... $list_tmpsymbol
                    TclObject[] objv113 = TJC.grabObjv(interp, 2);
                    TclObject tmp114;
                    try {
                        // Arg 0 constant: ...
                        objv113[0] = const28;
                        // Arg 1 variable: $list_tmpsymbol
                        tmp114 = getVarScalar(interp, "list_tmpsymbol", compiledLocals, 18);
                        tmp114.preserve();
                        objv113[1] = tmp114;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache16_cmdEpoch == cmdcache16.cmdEpoch)
                            ? cmdcache16.cmd : null), objv113, 0);
                        if ( cmdcache16_cmdEpoch != cmdcache16.cmdEpoch ) {
                            updateCmdCache(interp, 16);
                        }
                    } finally {
                        tmp114 = objv113[1];
                        if ( tmp114 != null ) {
                            tmp114.release();
                        }
                        TJC.releaseObjv(interp, objv113, 2);
                    }
                } // End Invoke: ...
                tmp112 = interp.getResult();
                tmp112.preserve();
                objv111[0] = tmp112;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv111, compiledLocals, 2);
            } finally {
                TJC.releaseObjvElems(interp, objv111, 1);
            }
        } // End Invoke: append
        { // Invoke: set i 2
            setVarScalar(interp, "i", const7, compiledLocals, 20);
        } // End Invoke: set
        { // Invoke: set tuple [...]
            TclObject tmp115;
            { // Invoke: ... $key $i false $index_tmpsymbol
                TclObject[] objv116 = TJC.grabObjv(interp, 5);
                TclObject tmp117;
                try {
                    // Arg 0 constant: ...
                    objv116[0] = const11;
                    // Arg 1 variable: $key
                    tmp117 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp117.preserve();
                    objv116[1] = tmp117;
                    // Arg 2 variable: $i
                    tmp117 = getVarScalar(interp, "i", compiledLocals, 20);
                    tmp117.preserve();
                    objv116[2] = tmp117;
                    // Arg 3 constant: false
                    objv116[3] = const24;
                    // Arg 4 variable: $index_tmpsymbol
                    tmp117 = getVarScalar(interp, "index_tmpsymbol", compiledLocals, 19);
                    tmp117.preserve();
                    objv116[4] = tmp117;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                        ? cmdcache6.cmd : null), objv116, 0);
                    if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                        updateCmdCache(interp, 6);
                    }
                } finally {
                    tmp117 = objv116[1];
                    if ( tmp117 != null ) {
                        tmp117.release();
                    }
                    tmp117 = objv116[2];
                    if ( tmp117 != null ) {
                        tmp117.release();
                    }
                    tmp117 = objv116[4];
                    if ( tmp117 != null ) {
                        tmp117.release();
                    }
                    TJC.releaseObjv(interp, objv116, 5);
                }
            } // End Invoke: ...
            tmp115 = interp.getResult();
            setVarScalar(interp, "tuple", tmp115, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set value_type [...]
            TclObject tmp118;
            { // Invoke: lindex $tuple 0
                TclObject tmp119 = getVarScalar(interp, "tuple", compiledLocals, 6);
                tmp119 = TclList.index(interp, tmp119, 0);
                if ( tmp119 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp119);
                }
            } // End Invoke: lindex
            tmp118 = interp.getResult();
            setVarScalar(interp, "value_type", tmp118, compiledLocals, 13);
        } // End Invoke: set
        { // Invoke: set value_symbol [...]
            TclObject tmp120;
            { // Invoke: lindex $tuple 1
                TclObject tmp121 = getVarScalar(interp, "tuple", compiledLocals, 6);
                tmp121 = TclList.index(interp, tmp121, 1);
                if ( tmp121 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp121);
                }
            } // End Invoke: lindex
            tmp120 = interp.getResult();
            setVarScalar(interp, "value_symbol", tmp120, compiledLocals, 14);
        } // End Invoke: set
        { // Invoke: set value_buffer [...]
            TclObject tmp122;
            { // Invoke: lindex $tuple 2
                TclObject tmp123 = getVarScalar(interp, "tuple", compiledLocals, 6);
                tmp123 = TclList.index(interp, tmp123, 2);
                if ( tmp123 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp123);
                }
            } // End Invoke: lindex
            tmp122 = interp.getResult();
            setVarScalar(interp, "value_buffer", tmp122, compiledLocals, 15);
        } // End Invoke: set
        { // Invoke: if ... ... else ...
            // Binary operator: $value_type == "constant"
            TclObject tmp124 = getVarScalar(interp, "value_type", compiledLocals, 13);
            boolean tmp125 = tmp124.toString().equals("constant");
            ExprValue tmp126 = evs0;
            tmp126.setIntValue(tmp125);
            // End Binary operator: ==
            boolean tmp127 = ( tmp126.getIntValue() != 0 );
            if ( tmp127 ) {
                { // Invoke: append buffer [...]
                    TclObject[] objv128 = TJC.grabObjv(interp, 1);
                    TclObject tmp129;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: emitter_statement "..."
                            TclObject[] objv130 = TJC.grabObjv(interp, 2);
                            TclObject tmp131;
                            try {
                                // Arg 0 constant: emitter_statement
                                objv130[0] = const26;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp132 = new StringBuffer(64);
                                tmp131 = getVarScalar(interp, "index_tmpsymbol", compiledLocals, 19);
                                sbtmp132.append(tmp131.toString());
                                sbtmp132.append(" = ");
                                tmp131 = getVarScalar(interp, "value_symbol", compiledLocals, 14);
                                sbtmp132.append(tmp131.toString());
                                tmp131 = TclString.newInstance(sbtmp132);
                                tmp131.preserve();
                                objv130[1] = tmp131;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache14_cmdEpoch == cmdcache14.cmdEpoch)
                                    ? cmdcache14.cmd : null), objv130, 0);
                                if ( cmdcache14_cmdEpoch != cmdcache14.cmdEpoch ) {
                                    updateCmdCache(interp, 14);
                                }
                            } finally {
                                tmp131 = objv130[1];
                                if ( tmp131 != null ) {
                                    tmp131.release();
                                }
                                TJC.releaseObjv(interp, objv130, 2);
                            }
                        } // End Invoke: emitter_statement
                        tmp129 = interp.getResult();
                        tmp129.preserve();
                        objv128[0] = tmp129;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv128, compiledLocals, 2);
                    } finally {
                        TJC.releaseObjvElems(interp, objv128, 1);
                    }
                } // End Invoke: append
            } else {
                { // Invoke: append buffer $value_buffer
                    TclObject[] objv133 = TJC.grabObjv(interp, 1);
                    TclObject tmp134;
                    try {
                        // Arg 2 variable: $value_buffer
                        tmp134 = getVarScalar(interp, "value_buffer", compiledLocals, 15);
                        tmp134.preserve();
                        objv133[0] = tmp134;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv133, compiledLocals, 2);
                    } finally {
                        TJC.releaseObjvElems(interp, objv133, 1);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: append buffer [...]
            TclObject[] objv135 = TJC.grabObjv(interp, 1);
            TclObject tmp136;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_statement "..."
                    TclObject[] objv137 = TJC.grabObjv(interp, 2);
                    TclObject tmp138;
                    try {
                        // Arg 0 constant: emitter_statement
                        objv137[0] = const26;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp139 = new StringBuffer(64);
                        sbtmp139.append("TJC.lindexNonconst(interp, ");
                        tmp138 = getVarScalar(interp, "list_tmpsymbol", compiledLocals, 18);
                        sbtmp139.append(tmp138.toString());
                        sbtmp139.append(", ");
                        tmp138 = getVarScalar(interp, "index_tmpsymbol", compiledLocals, 19);
                        sbtmp139.append(tmp138.toString());
                        sbtmp139.append(")");
                        tmp138 = TclString.newInstance(sbtmp139);
                        tmp138.preserve();
                        objv137[1] = tmp138;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache14_cmdEpoch == cmdcache14.cmdEpoch)
                            ? cmdcache14.cmd : null), objv137, 0);
                        if ( cmdcache14_cmdEpoch != cmdcache14.cmdEpoch ) {
                            updateCmdCache(interp, 14);
                        }
                    } finally {
                        tmp138 = objv137[1];
                        if ( tmp138 != null ) {
                            tmp138.release();
                        }
                        TJC.releaseObjv(interp, objv137, 2);
                    }
                } // End Invoke: emitter_statement
                tmp136 = interp.getResult();
                tmp136.preserve();
                objv135[0] = tmp136;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv135, compiledLocals, 2);
            } finally {
                TJC.releaseObjvElems(interp, objv135, 1);
            }
        } // End Invoke: append
        { // Invoke: append buffer [...] [...] [...] [...] [...]
            TclObject[] objv140 = TJC.grabObjv(interp, 5);
            TclObject tmp141;
            try {
                // Arg 2 command: [...]
                { // Invoke: ...
                    TclObject[] objv142 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: ...
                        objv142[0] = const29;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache17_cmdEpoch == cmdcache17.cmdEpoch)
                            ? cmdcache17.cmd : null), objv142, 0);
                        if ( cmdcache17_cmdEpoch != cmdcache17.cmdEpoch ) {
                            updateCmdCache(interp, 17);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv142, 1);
                    }
                } // End Invoke: ...
                tmp141 = interp.getResult();
                tmp141.preserve();
                objv140[0] = tmp141;
                // Arg 3 command: [...]
                { // Invoke: ... "..."
                    TclObject[] objv143 = TJC.grabObjv(interp, 2);
                    TclObject tmp144;
                    try {
                        // Arg 0 constant: ...
                        objv143[0] = const20;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp145 = new StringBuffer(64);
                        tmp144 = getVarScalar(interp, "list_tmpsymbol", compiledLocals, 18);
                        sbtmp145.append(tmp144.toString());
                        sbtmp145.append(" != null");
                        tmp144 = TclString.newInstance(sbtmp145);
                        tmp144.preserve();
                        objv143[1] = tmp144;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                            ? cmdcache9.cmd : null), objv143, 0);
                        if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                            updateCmdCache(interp, 9);
                        }
                    } finally {
                        tmp144 = objv143[1];
                        if ( tmp144 != null ) {
                            tmp144.release();
                        }
                        TJC.releaseObjv(interp, objv143, 2);
                    }
                } // End Invoke: ...
                tmp141 = interp.getResult();
                tmp141.preserve();
                objv140[1] = tmp141;
                // Arg 4 command: [...]
                { // Invoke: ... $list_tmpsymbol
                    TclObject[] objv146 = TJC.grabObjv(interp, 2);
                    TclObject tmp147;
                    try {
                        // Arg 0 constant: ...
                        objv146[0] = const30;
                        // Arg 1 variable: $list_tmpsymbol
                        tmp147 = getVarScalar(interp, "list_tmpsymbol", compiledLocals, 18);
                        tmp147.preserve();
                        objv146[1] = tmp147;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache18_cmdEpoch == cmdcache18.cmdEpoch)
                            ? cmdcache18.cmd : null), objv146, 0);
                        if ( cmdcache18_cmdEpoch != cmdcache18.cmdEpoch ) {
                            updateCmdCache(interp, 18);
                        }
                    } finally {
                        tmp147 = objv146[1];
                        if ( tmp147 != null ) {
                            tmp147.release();
                        }
                        TJC.releaseObjv(interp, objv146, 2);
                    }
                } // End Invoke: ...
                tmp141 = interp.getResult();
                tmp141.preserve();
                objv140[2] = tmp141;
                // Arg 5 command: [...]
                { // Invoke: ...
                    TclObject[] objv148 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: ...
                        objv148[0] = const25;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache13_cmdEpoch == cmdcache13.cmdEpoch)
                            ? cmdcache13.cmd : null), objv148, 0);
                        if ( cmdcache13_cmdEpoch != cmdcache13.cmdEpoch ) {
                            updateCmdCache(interp, 13);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv148, 1);
                    }
                } // End Invoke: ...
                tmp141 = interp.getResult();
                tmp141.preserve();
                objv140[3] = tmp141;
                // Arg 6 command: [...]
                { // Invoke: ...
                    TclObject[] objv149 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: ...
                        objv149[0] = const31;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache19_cmdEpoch == cmdcache19.cmdEpoch)
                            ? cmdcache19.cmd : null), objv149, 0);
                        if ( cmdcache19_cmdEpoch != cmdcache19.cmdEpoch ) {
                            updateCmdCache(interp, 19);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv149, 1);
                    }
                } // End Invoke: ...
                tmp141 = interp.getResult();
                tmp141.preserve();
                objv140[4] = tmp141;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv140, compiledLocals, 2);
            } finally {
                TJC.releaseObjvElems(interp, objv140, 5);
            }
        } // End Invoke: append
        { // Invoke: return $buffer
            TclObject tmp150 = getVarScalar(interp, "buffer", compiledLocals, 2);
            interp.resetResult();
            interp.setResult(tmp150);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_emit_inline_command_lindex");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;
    TclObject const21;
    TclObject const22;
    TclObject const23;
    TclObject const24;
    TclObject const25;
    TclObject const26;
    TclObject const27;
    TclObject const28;
    TclObject const29;
    TclObject const30;
    TclObject const31;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("descend_get_data");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("tree");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("error");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("expected 3 arguments");
        const4.preserve(); const4.preserve();
        const5 = TclInteger.newInstance(0);
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("compileproc_get_argument_tuple");
        const6.preserve(); const6.preserve();
        const7 = TclInteger.newInstance(2);
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("compileproc_string_is_java_integer");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("compileproc_parse_value");
        const9.preserve(); const9.preserve();
        const10 = TclInteger.newInstance(1);
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("compileproc_emit_argument");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("true");
        TclBoolean.get(interp, const12);
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("compileproc_tmpvar_next");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("emitter_indent");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("TclObject ");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance(" = ");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("TclList.index(interp, ");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance(", ");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance(");\n");
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance("emitter_container_if_start");
        const20.preserve(); const20.preserve();
        const21 = TclString.newInstance("emitter_reset_result");
        const21.preserve(); const21.preserve();
        const22 = TclString.newInstance("emitter_container_if_else");
        const22.preserve(); const22.preserve();
        const23 = TclString.newInstance("emitter_set_result");
        const23.preserve(); const23.preserve();
        const24 = TclString.newInstance("false");
        TclBoolean.get(interp, const24);
        const24.preserve(); const24.preserve();
        const25 = TclString.newInstance("emitter_container_if_end");
        const25.preserve(); const25.preserve();
        const26 = TclString.newInstance("emitter_statement");
        const26.preserve(); const26.preserve();
        const27 = TclString.newInstance("emitter_container_try_start");
        const27.preserve(); const27.preserve();
        const28 = TclString.newInstance("emitter_tclobject_preserve");
        const28.preserve(); const28.preserve();
        const29 = TclString.newInstance("emitter_container_try_finally");
        const29.preserve(); const29.preserve();
        const30 = TclString.newInstance("emitter_tclobject_release");
        const30.preserve(); const30.preserve();
        const31 = TclString.newInstance("emitter_container_try_end");
        const31.preserve(); const31.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;
    WrappedCommand cmdcache10;
    int cmdcache10_cmdEpoch;
    WrappedCommand cmdcache11;
    int cmdcache11_cmdEpoch;
    WrappedCommand cmdcache12;
    int cmdcache12_cmdEpoch;
    WrappedCommand cmdcache13;
    int cmdcache13_cmdEpoch;
    WrappedCommand cmdcache14;
    int cmdcache14_cmdEpoch;
    WrappedCommand cmdcache15;
    int cmdcache15_cmdEpoch;
    WrappedCommand cmdcache16;
    int cmdcache16_cmdEpoch;
    WrappedCommand cmdcache17;
    int cmdcache17_cmdEpoch;
    WrappedCommand cmdcache18;
    int cmdcache18_cmdEpoch;
    WrappedCommand cmdcache19;
    int cmdcache19_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                cmdcache10 = TJC.INVALID_COMMAND_CACHE;
                cmdcache10_cmdEpoch = 0;
                cmdcache11 = TJC.INVALID_COMMAND_CACHE;
                cmdcache11_cmdEpoch = 0;
                cmdcache12 = TJC.INVALID_COMMAND_CACHE;
                cmdcache12_cmdEpoch = 0;
                cmdcache13 = TJC.INVALID_COMMAND_CACHE;
                cmdcache13_cmdEpoch = 0;
                cmdcache14 = TJC.INVALID_COMMAND_CACHE;
                cmdcache14_cmdEpoch = 0;
                cmdcache15 = TJC.INVALID_COMMAND_CACHE;
                cmdcache15_cmdEpoch = 0;
                cmdcache16 = TJC.INVALID_COMMAND_CACHE;
                cmdcache16_cmdEpoch = 0;
                cmdcache17 = TJC.INVALID_COMMAND_CACHE;
                cmdcache17_cmdEpoch = 0;
                cmdcache18 = TJC.INVALID_COMMAND_CACHE;
                cmdcache18_cmdEpoch = 0;
                cmdcache19 = TJC.INVALID_COMMAND_CACHE;
                cmdcache19_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_get_data";
                break;
            }
            case 2: {
                cmdName = "error";
                break;
            }
            case 3: {
                cmdName = "compileproc_get_argument_tuple";
                break;
            }
            case 4: {
                cmdName = "compileproc_string_is_java_integer";
                break;
            }
            case 5: {
                cmdName = "compileproc_parse_value";
                break;
            }
            case 6: {
                cmdName = "compileproc_emit_argument";
                break;
            }
            case 7: {
                cmdName = "compileproc_tmpvar_next";
                break;
            }
            case 8: {
                cmdName = "emitter_indent";
                break;
            }
            case 9: {
                cmdName = "emitter_container_if_start";
                break;
            }
            case 10: {
                cmdName = "emitter_reset_result";
                break;
            }
            case 11: {
                cmdName = "emitter_container_if_else";
                break;
            }
            case 12: {
                cmdName = "emitter_set_result";
                break;
            }
            case 13: {
                cmdName = "emitter_container_if_end";
                break;
            }
            case 14: {
                cmdName = "emitter_statement";
                break;
            }
            case 15: {
                cmdName = "emitter_container_try_start";
                break;
            }
            case 16: {
                cmdName = "emitter_tclobject_preserve";
                break;
            }
            case 17: {
                cmdName = "emitter_container_try_finally";
                break;
            }
            case 18: {
                cmdName = "emitter_tclobject_release";
                break;
            }
            case 19: {
                cmdName = "emitter_container_try_end";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
            case 10: {
                cmdcache10 = lwcmd;
                cmdcache10_cmdEpoch = cmdEpoch;
                break;
            }
            case 11: {
                cmdcache11 = lwcmd;
                cmdcache11_cmdEpoch = cmdEpoch;
                break;
            }
            case 12: {
                cmdcache12 = lwcmd;
                cmdcache12_cmdEpoch = cmdEpoch;
                break;
            }
            case 13: {
                cmdcache13 = lwcmd;
                cmdcache13_cmdEpoch = cmdEpoch;
                break;
            }
            case 14: {
                cmdcache14 = lwcmd;
                cmdcache14_cmdEpoch = cmdEpoch;
                break;
            }
            case 15: {
                cmdcache15 = lwcmd;
                cmdcache15_cmdEpoch = cmdEpoch;
                break;
            }
            case 16: {
                cmdcache16 = lwcmd;
                cmdcache16_cmdEpoch = cmdEpoch;
                break;
            }
            case 17: {
                cmdcache17 = lwcmd;
                cmdcache17_cmdEpoch = cmdEpoch;
                break;
            }
            case 18: {
                cmdcache18 = lwcmd;
                cmdcache18_cmdEpoch = cmdEpoch;
                break;
            }
            case 19: {
                cmdcache19 = lwcmd;
                cmdcache19_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_compileproc",
        "buffer",
        "tree",
        "num_args",
        "constant_integer_index",
        "tuple",
        "type",
        "value",
        "is_integer",
        "stringrep_matches",
        "parsed_number",
        "index_symbol",
        "value_type",
        "value_symbol",
        "value_buffer",
        "result_symbol",
        "declare_result_symbol",
        "list_tmpsymbol",
        "index_tmpsymbol",
        "i"
    };
} // end class CompileprocEmitInlineCommandLindexCmd

