// TJC implementation of procedure compileproc_emit_inline_command_set
package tjc;
import tcl.lang.*;

public class CompileprocEmitInlineCommandSetCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 17, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 1);
        } // End Invoke: global
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set tuple [...]
            TclObject tmp0;
            { // Invoke: ... $key 1
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: ...
                    objv1[0] = const1;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 constant: 1
                    objv1[2] = const2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: ...
            tmp0 = interp.getResult();
            setVarScalar(interp, "tuple", tmp0, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set type [...]
            TclObject tmp3;
            { // Invoke: lindex $tuple 0
                TclObject tmp4 = getVarScalar(interp, "tuple", compiledLocals, 3);
                tmp4 = TclList.index(interp, tmp4, 0);
                if ( tmp4 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp4);
                }
            } // End Invoke: lindex
            tmp3 = interp.getResult();
            setVarScalar(interp, "type", tmp3, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: if ... ... else ...
            // Binary operator: $type == "constant"
            TclObject tmp5 = getVarScalar(interp, "type", compiledLocals, 4);
            boolean tmp6 = tmp5.toString().equals("constant");
            ExprValue tmp7 = evs0;
            tmp7.setIntValue(tmp6);
            // End Binary operator: ==
            boolean tmp8 = ( tmp7.getIntValue() != 0 );
            if ( tmp8 ) {
                { // Invoke: set constant_varname 1
                    setVarScalar(interp, "constant_varname", const2, compiledLocals, 5);
                } // End Invoke: set
                { // Invoke: set varname [...]
                    TclObject tmp9;
                    { // Invoke: lindex $tuple 1
                        TclObject tmp10 = getVarScalar(interp, "tuple", compiledLocals, 3);
                        tmp10 = TclList.index(interp, tmp10, 1);
                        if ( tmp10 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp10);
                        }
                    } // End Invoke: lindex
                    tmp9 = interp.getResult();
                    setVarScalar(interp, "varname", tmp9, compiledLocals, 6);
                } // End Invoke: set
            } else {
                { // Invoke: set constant_varname 0
                    setVarScalar(interp, "constant_varname", const3, compiledLocals, 5);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: set tree [...]
            TclObject tmp11;
            { // Invoke: descend_get_data $key tree
                TclObject[] objv12 = TJC.grabObjv(interp, 3);
                TclObject tmp13;
                try {
                    // Arg 0 constant: descend_get_data
                    objv12[0] = const4;
                    // Arg 1 variable: $key
                    tmp13 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp13.preserve();
                    objv12[1] = tmp13;
                    // Arg 2 constant: tree
                    objv12[2] = const5;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv12, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp13 = objv12[1];
                    if ( tmp13 != null ) {
                        tmp13.release();
                    }
                    TJC.releaseObjv(interp, objv12, 3);
                }
            } // End Invoke: descend_get_data
            tmp11 = interp.getResult();
            setVarScalar(interp, "tree", tmp11, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: set num_args [...]
            TclObject tmp14;
            { // Invoke: llength $tree
                TclObject tmp15 = getVarScalar(interp, "tree", compiledLocals, 7);
                int tmp16 = TclList.getLength(interp, tmp15);
                interp.setResult(tmp16);
            } // End Invoke: llength
            tmp14 = interp.getResult();
            setVarScalar(interp, "num_args", tmp14, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: set omit_result 0
            setVarScalar(interp, "omit_result", const3, compiledLocals, 9);
        } // End Invoke: set
        { // Invoke: if {$num_args == 2} ... elseif {$num_args == 3} ... else ...
            // Binary operator: $num_args == 2
            TclObject tmp17 = getVarScalar(interp, "num_args", compiledLocals, 8);
            ExprValue tmp18 = evs0;
            TJC.exprInitValue(interp, tmp18, tmp17);
            ExprValue tmp19 = evs1;
            tmp19.setIntValue(2);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp18, tmp19);
            // End Binary operator: ==
            boolean tmp20 = ( tmp18.getIntValue() != 0 );
            if ( tmp20 ) {
                { // Invoke: set tmpsymbol [...]
                    TclObject tmp21;
                    { // Invoke: ...
                        TclObject[] objv22 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv22[0] = const6;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv22, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv22, 1);
                        }
                    } // End Invoke: ...
                    tmp21 = interp.getResult();
                    setVarScalar(interp, "tmpsymbol", tmp21, compiledLocals, 10);
                } // End Invoke: set
                { // Invoke: if {$constant_varname} ... else ...
                    TclObject tmp23 = getVarScalar(interp, "constant_varname", compiledLocals, 5);
                    boolean tmp24 = TJC.getBoolean(interp, tmp23);
                    if ( tmp24 ) {
                        { // Invoke: append buffer [...]
                            TclObject[] objv25 = TJC.grabObjv(interp, 1);
                            TclObject tmp26;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: ... "..." $varname true
                                    TclObject[] objv27 = TJC.grabObjv(interp, 4);
                                    TclObject tmp28;
                                    try {
                                        // Arg 0 constant: ...
                                        objv27[0] = const7;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp29 = new StringBuffer(64);
                                        sbtmp29.append("TclObject ");
                                        tmp28 = getVarScalar(interp, "tmpsymbol", compiledLocals, 10);
                                        sbtmp29.append(tmp28.toString());
                                        tmp28 = TclString.newInstance(sbtmp29);
                                        tmp28.preserve();
                                        objv27[1] = tmp28;
                                        // Arg 2 variable: $varname
                                        tmp28 = getVarScalar(interp, "varname", compiledLocals, 6);
                                        tmp28.preserve();
                                        objv27[2] = tmp28;
                                        // Arg 3 constant: true
                                        objv27[3] = const8;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                            ? cmdcache4.cmd : null), objv27, 0);
                                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                            updateCmdCache(interp, 4);
                                        }
                                    } finally {
                                        tmp28 = objv27[1];
                                        if ( tmp28 != null ) {
                                            tmp28.release();
                                        }
                                        tmp28 = objv27[2];
                                        if ( tmp28 != null ) {
                                            tmp28.release();
                                        }
                                        TJC.releaseObjv(interp, objv27, 4);
                                    }
                                } // End Invoke: ...
                                tmp26 = interp.getResult();
                                tmp26.preserve();
                                objv25[0] = tmp26;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv25, compiledLocals, 2);
                            } finally {
                                TJC.releaseObjvElems(interp, objv25, 1);
                            }
                        } // End Invoke: append
                    } else {
                        { // Invoke: append buffer [...]
                            TclObject[] objv30 = TJC.grabObjv(interp, 1);
                            TclObject tmp31;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: emitter_statement "..."
                                    TclObject[] objv32 = TJC.grabObjv(interp, 2);
                                    TclObject tmp33;
                                    try {
                                        // Arg 0 constant: emitter_statement
                                        objv32[0] = const9;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp34 = new StringBuffer(64);
                                        sbtmp34.append("TclObject ");
                                        tmp33 = getVarScalar(interp, "tmpsymbol", compiledLocals, 10);
                                        sbtmp34.append(tmp33.toString());
                                        tmp33 = TclString.newInstance(sbtmp34);
                                        tmp33.preserve();
                                        objv32[1] = tmp33;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                            ? cmdcache5.cmd : null), objv32, 0);
                                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                            updateCmdCache(interp, 5);
                                        }
                                    } finally {
                                        tmp33 = objv32[1];
                                        if ( tmp33 != null ) {
                                            tmp33.release();
                                        }
                                        TJC.releaseObjv(interp, objv32, 2);
                                    }
                                } // End Invoke: emitter_statement
                                tmp31 = interp.getResult();
                                tmp31.preserve();
                                objv30[0] = tmp31;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv30, compiledLocals, 2);
                            } finally {
                                TJC.releaseObjvElems(interp, objv30, 1);
                            }
                        } // End Invoke: append
                        { // Invoke: foreach gs_buffer [...] ...
                            TclObject tmp35 = null;
                            try {
                                { // Invoke: ... $key 1 get $tmpsymbol
                                    TclObject[] objv36 = TJC.grabObjv(interp, 5);
                                    TclObject tmp37;
                                    try {
                                        // Arg 0 constant: ...
                                        objv36[0] = const10;
                                        // Arg 1 variable: $key
                                        tmp37 = getVarScalar(interp, "key", compiledLocals, 0);
                                        tmp37.preserve();
                                        objv36[1] = tmp37;
                                        // Arg 2 constant: 1
                                        objv36[2] = const2;
                                        // Arg 3 constant: get
                                        objv36[3] = const11;
                                        // Arg 4 variable: $tmpsymbol
                                        tmp37 = getVarScalar(interp, "tmpsymbol", compiledLocals, 10);
                                        tmp37.preserve();
                                        objv36[4] = tmp37;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                            ? cmdcache6.cmd : null), objv36, 0);
                                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                            updateCmdCache(interp, 6);
                                        }
                                    } finally {
                                        tmp37 = objv36[1];
                                        if ( tmp37 != null ) {
                                            tmp37.release();
                                        }
                                        tmp37 = objv36[4];
                                        if ( tmp37 != null ) {
                                            tmp37.release();
                                        }
                                        TJC.releaseObjv(interp, objv36, 5);
                                    }
                                } // End Invoke: ...
                                tmp35 = interp.getResult();
                                tmp35.preserve();
                                final int tmp35_length = TclList.getLength(interp, tmp35);

                                for ( int index38 = 0 ; index38 < tmp35_length ; index38++ ) {
                                    TclObject tmp39 = TclList.index(interp, tmp35, index38);
                                    try {
                                        setVarScalar(interp, "gs_buffer", tmp39, compiledLocals, 11);
                                    } catch (TclException ex) {
                                        TJC.foreachVarErr(interp, "gs_buffer");
                                    }

                                    try {
                                    if ( false ) { throw (TclException) null; }
                                    { // Invoke: append buffer $gs_buffer
                                        TclObject[] objv40 = TJC.grabObjv(interp, 1);
                                        TclObject tmp41;
                                        try {
                                            // Arg 2 variable: $gs_buffer
                                            tmp41 = getVarScalar(interp, "gs_buffer", compiledLocals, 11);
                                            tmp41.preserve();
                                            objv40[0] = tmp41;
                                            interp.resetResult();
                                            appendVarScalar(interp, "buffer", objv40, compiledLocals, 2);
                                        } finally {
                                            TJC.releaseObjvElems(interp, objv40, 1);
                                        }
                                    } // End Invoke: append
                                    } catch (TclException ex) {
                                        int type = ex.getCompletionCode();
                                        if (type == TCL.BREAK) {
                                            break;
                                        } else if (type == TCL.CONTINUE) {
                                            continue;
                                        } else {
                                            throw ex;
                                        }
                                    }
                                }
                            } finally {
                                if ( tmp35 != null ) {
                                    tmp35.release();
                                }
                            }
                        } // End Invoke: foreach
                    }
                } // End Invoke: if
            } else {
                // Binary operator: $num_args == 3
                TclObject tmp42 = getVarScalar(interp, "num_args", compiledLocals, 8);
                ExprValue tmp43 = evs0;
                TJC.exprInitValue(interp, tmp43, tmp42);
                ExprValue tmp44 = evs1;
                tmp44.setIntValue(3);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp43, tmp44);
                // End Binary operator: ==
                boolean tmp45 = ( tmp43.getIntValue() != 0 );
                if ( tmp45 ) {
                    { // Invoke: set omit_result [...]
                        TclObject tmp46;
                        { // Invoke: ... $key
                            TclObject[] objv47 = TJC.grabObjv(interp, 2);
                            TclObject tmp48;
                            try {
                                // Arg 0 constant: ...
                                objv47[0] = const12;
                                // Arg 1 variable: $key
                                tmp48 = getVarScalar(interp, "key", compiledLocals, 0);
                                tmp48.preserve();
                                objv47[1] = tmp48;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                    ? cmdcache7.cmd : null), objv47, 0);
                                if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                    updateCmdCache(interp, 7);
                                }
                            } finally {
                                tmp48 = objv47[1];
                                if ( tmp48 != null ) {
                                    tmp48.release();
                                }
                                TJC.releaseObjv(interp, objv47, 2);
                            }
                        } // End Invoke: ...
                        tmp46 = interp.getResult();
                        setVarScalar(interp, "omit_result", tmp46, compiledLocals, 9);
                    } // End Invoke: set
                    { // Invoke: if {$omit_result} ... else ...
                        TclObject tmp49 = getVarScalar(interp, "omit_result", compiledLocals, 9);
                        boolean tmp50 = TJC.getBoolean(interp, tmp49);
                        if ( tmp50 ) {
                            { // Invoke: set tuple [...]
                                TclObject tmp51;
                                { // Invoke: ... $key 2
                                    TclObject[] objv52 = TJC.grabObjv(interp, 3);
                                    TclObject tmp53;
                                    try {
                                        // Arg 0 constant: ...
                                        objv52[0] = const1;
                                        // Arg 1 variable: $key
                                        tmp53 = getVarScalar(interp, "key", compiledLocals, 0);
                                        tmp53.preserve();
                                        objv52[1] = tmp53;
                                        // Arg 2 constant: 2
                                        objv52[2] = const13;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv52, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        tmp53 = objv52[1];
                                        if ( tmp53 != null ) {
                                            tmp53.release();
                                        }
                                        TJC.releaseObjv(interp, objv52, 3);
                                    }
                                } // End Invoke: ...
                                tmp51 = interp.getResult();
                                setVarScalar(interp, "tuple", tmp51, compiledLocals, 3);
                            } // End Invoke: set
                            { // Invoke: set type [...]
                                TclObject tmp54;
                                { // Invoke: lindex $tuple 0
                                    TclObject tmp55 = getVarScalar(interp, "tuple", compiledLocals, 3);
                                    tmp55 = TclList.index(interp, tmp55, 0);
                                    if ( tmp55 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp55);
                                    }
                                } // End Invoke: lindex
                                tmp54 = interp.getResult();
                                setVarScalar(interp, "type", tmp54, compiledLocals, 4);
                            } // End Invoke: set
                            { // Invoke: if ... ... else ...
                                // Binary operator: $type == "constant"
                                TclObject tmp56 = getVarScalar(interp, "type", compiledLocals, 4);
                                boolean tmp57 = tmp56.toString().equals("constant");
                                ExprValue tmp58 = evs0;
                                tmp58.setIntValue(tmp57);
                                // End Binary operator: ==
                                boolean tmp59 = ( tmp58.getIntValue() != 0 );
                                if ( tmp59 ) {
                                    { // Invoke: set tmpsymbol {}
                                        setVarScalar(interp, "tmpsymbol", const0, compiledLocals, 10);
                                    } // End Invoke: set
                                } else {
                                    { // Invoke: set tmpsymbol [...]
                                        TclObject tmp60;
                                        { // Invoke: ...
                                            TclObject[] objv61 = TJC.grabObjv(interp, 1);
                                            try {
                                                // Arg 0 constant: ...
                                                objv61[0] = const6;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                                    ? cmdcache3.cmd : null), objv61, 0);
                                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                                    updateCmdCache(interp, 3);
                                                }
                                            } finally {
                                                TJC.releaseObjv(interp, objv61, 1);
                                            }
                                        } // End Invoke: ...
                                        tmp60 = interp.getResult();
                                        setVarScalar(interp, "tmpsymbol", tmp60, compiledLocals, 10);
                                    } // End Invoke: set
                                }
                            } // End Invoke: if
                        } else {
                            { // Invoke: set tmpsymbol [...]
                                TclObject tmp62;
                                { // Invoke: ...
                                    TclObject[] objv63 = TJC.grabObjv(interp, 1);
                                    try {
                                        // Arg 0 constant: ...
                                        objv63[0] = const6;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                            ? cmdcache3.cmd : null), objv63, 0);
                                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                            updateCmdCache(interp, 3);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv63, 1);
                                    }
                                } // End Invoke: ...
                                tmp62 = interp.getResult();
                                setVarScalar(interp, "tmpsymbol", tmp62, compiledLocals, 10);
                            } // End Invoke: set
                        }
                    } // End Invoke: if
                    { // Invoke: if {$tmpsymbol != {}} ...
                        // Binary operator: $tmpsymbol != ""
                        TclObject tmp64 = getVarScalar(interp, "tmpsymbol", compiledLocals, 10);
                        ExprValue tmp65 = evs0;
                        TJC.exprEqualsEmptyString(tmp65, tmp64, true);
                        // End Binary operator: !=
                        boolean tmp66 = ( tmp65.getIntValue() != 0 );
                        if ( tmp66 ) {
                            { // Invoke: append buffer [...]
                                TclObject[] objv67 = TJC.grabObjv(interp, 1);
                                TclObject tmp68;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: emitter_statement "..."
                                        TclObject[] objv69 = TJC.grabObjv(interp, 2);
                                        TclObject tmp70;
                                        try {
                                            // Arg 0 constant: emitter_statement
                                            objv69[0] = const9;
                                            // Arg 1 word: "..."
                                            StringBuffer sbtmp71 = new StringBuffer(64);
                                            sbtmp71.append("TclObject ");
                                            tmp70 = getVarScalar(interp, "tmpsymbol", compiledLocals, 10);
                                            sbtmp71.append(tmp70.toString());
                                            tmp70 = TclString.newInstance(sbtmp71);
                                            tmp70.preserve();
                                            objv69[1] = tmp70;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                                ? cmdcache5.cmd : null), objv69, 0);
                                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                                updateCmdCache(interp, 5);
                                            }
                                        } finally {
                                            tmp70 = objv69[1];
                                            if ( tmp70 != null ) {
                                                tmp70.release();
                                            }
                                            TJC.releaseObjv(interp, objv69, 2);
                                        }
                                    } // End Invoke: emitter_statement
                                    tmp68 = interp.getResult();
                                    tmp68.preserve();
                                    objv67[0] = tmp68;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv67, compiledLocals, 2);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv67, 1);
                                }
                            } // End Invoke: append
                        }
                    } // End Invoke: if
                    { // Invoke: set tuple [...]
                        TclObject tmp72;
                        { // Invoke: ... $key 2 false $tmpsymbol
                            TclObject[] objv73 = TJC.grabObjv(interp, 5);
                            TclObject tmp74;
                            try {
                                // Arg 0 constant: ...
                                objv73[0] = const14;
                                // Arg 1 variable: $key
                                tmp74 = getVarScalar(interp, "key", compiledLocals, 0);
                                tmp74.preserve();
                                objv73[1] = tmp74;
                                // Arg 2 constant: 2
                                objv73[2] = const13;
                                // Arg 3 constant: false
                                objv73[3] = const15;
                                // Arg 4 variable: $tmpsymbol
                                tmp74 = getVarScalar(interp, "tmpsymbol", compiledLocals, 10);
                                tmp74.preserve();
                                objv73[4] = tmp74;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                    ? cmdcache8.cmd : null), objv73, 0);
                                if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                    updateCmdCache(interp, 8);
                                }
                            } finally {
                                tmp74 = objv73[1];
                                if ( tmp74 != null ) {
                                    tmp74.release();
                                }
                                tmp74 = objv73[4];
                                if ( tmp74 != null ) {
                                    tmp74.release();
                                }
                                TJC.releaseObjv(interp, objv73, 5);
                            }
                        } // End Invoke: ...
                        tmp72 = interp.getResult();
                        setVarScalar(interp, "tuple", tmp72, compiledLocals, 3);
                    } // End Invoke: set
                    { // Invoke: set value_type [...]
                        TclObject tmp75;
                        { // Invoke: lindex $tuple 0
                            TclObject tmp76 = getVarScalar(interp, "tuple", compiledLocals, 3);
                            tmp76 = TclList.index(interp, tmp76, 0);
                            if ( tmp76 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp76);
                            }
                        } // End Invoke: lindex
                        tmp75 = interp.getResult();
                        setVarScalar(interp, "value_type", tmp75, compiledLocals, 12);
                    } // End Invoke: set
                    { // Invoke: set value_symbol [...]
                        TclObject tmp77;
                        { // Invoke: lindex $tuple 1
                            TclObject tmp78 = getVarScalar(interp, "tuple", compiledLocals, 3);
                            tmp78 = TclList.index(interp, tmp78, 1);
                            if ( tmp78 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp78);
                            }
                        } // End Invoke: lindex
                        tmp77 = interp.getResult();
                        setVarScalar(interp, "value_symbol", tmp77, compiledLocals, 13);
                    } // End Invoke: set
                    { // Invoke: set value_buffer [...]
                        TclObject tmp79;
                        { // Invoke: lindex $tuple 2
                            TclObject tmp80 = getVarScalar(interp, "tuple", compiledLocals, 3);
                            tmp80 = TclList.index(interp, tmp80, 2);
                            if ( tmp80 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp80);
                            }
                        } // End Invoke: lindex
                        tmp79 = interp.getResult();
                        setVarScalar(interp, "value_buffer", tmp79, compiledLocals, 14);
                    } // End Invoke: set
                    { // Invoke: if ... ... else ...
                        // Binary operator: $value_type == "constant"
                        TclObject tmp81 = getVarScalar(interp, "value_type", compiledLocals, 12);
                        boolean tmp82 = tmp81.toString().equals("constant");
                        ExprValue tmp83 = evs0;
                        tmp83.setIntValue(tmp82);
                        // End Binary operator: ==
                        boolean tmp84 = ( tmp83.getIntValue() != 0 );
                        if ( tmp84 ) {
                            { // Invoke: set value $value_symbol
                                TclObject tmp85;
                                tmp85 = getVarScalar(interp, "value_symbol", compiledLocals, 13);
                                setVarScalar(interp, "value", tmp85, compiledLocals, 15);
                            } // End Invoke: set
                        } else {
                            { // Invoke: set value $tmpsymbol
                                TclObject tmp86;
                                tmp86 = getVarScalar(interp, "tmpsymbol", compiledLocals, 10);
                                setVarScalar(interp, "value", tmp86, compiledLocals, 15);
                            } // End Invoke: set
                        }
                    } // End Invoke: if
                    { // Invoke: if {$constant_varname} ... else ...
                        TclObject tmp87 = getVarScalar(interp, "constant_varname", compiledLocals, 5);
                        boolean tmp88 = TJC.getBoolean(interp, tmp87);
                        if ( tmp88 ) {
                            { // Invoke: append buffer $value_buffer
                                TclObject[] objv89 = TJC.grabObjv(interp, 1);
                                TclObject tmp90;
                                try {
                                    // Arg 2 variable: $value_buffer
                                    tmp90 = getVarScalar(interp, "value_buffer", compiledLocals, 14);
                                    tmp90.preserve();
                                    objv89[0] = tmp90;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv89, compiledLocals, 2);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv89, 1);
                                }
                            } // End Invoke: append
                            { // Invoke: if {$omit_result} ...
                                TclObject tmp91 = getVarScalar(interp, "omit_result", compiledLocals, 9);
                                boolean tmp92 = TJC.getBoolean(interp, tmp91);
                                if ( tmp92 ) {
                                    { // Invoke: set tmpsymbol {}
                                        setVarScalar(interp, "tmpsymbol", const0, compiledLocals, 10);
                                    } // End Invoke: set
                                }
                            } // End Invoke: if
                            { // Invoke: append buffer [...]
                                TclObject[] objv93 = TJC.grabObjv(interp, 1);
                                TclObject tmp94;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: ... $tmpsymbol $varname true $value 0
                                        TclObject[] objv95 = TJC.grabObjv(interp, 6);
                                        TclObject tmp96;
                                        try {
                                            // Arg 0 constant: ...
                                            objv95[0] = const16;
                                            // Arg 1 variable: $tmpsymbol
                                            tmp96 = getVarScalar(interp, "tmpsymbol", compiledLocals, 10);
                                            tmp96.preserve();
                                            objv95[1] = tmp96;
                                            // Arg 2 variable: $varname
                                            tmp96 = getVarScalar(interp, "varname", compiledLocals, 6);
                                            tmp96.preserve();
                                            objv95[2] = tmp96;
                                            // Arg 3 constant: true
                                            objv95[3] = const8;
                                            // Arg 4 variable: $value
                                            tmp96 = getVarScalar(interp, "value", compiledLocals, 15);
                                            tmp96.preserve();
                                            objv95[4] = tmp96;
                                            // Arg 5 constant: 0
                                            objv95[5] = const3;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                                ? cmdcache9.cmd : null), objv95, 0);
                                            if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                                updateCmdCache(interp, 9);
                                            }
                                        } finally {
                                            tmp96 = objv95[1];
                                            if ( tmp96 != null ) {
                                                tmp96.release();
                                            }
                                            tmp96 = objv95[2];
                                            if ( tmp96 != null ) {
                                                tmp96.release();
                                            }
                                            tmp96 = objv95[4];
                                            if ( tmp96 != null ) {
                                                tmp96.release();
                                            }
                                            TJC.releaseObjv(interp, objv95, 6);
                                        }
                                    } // End Invoke: ...
                                    tmp94 = interp.getResult();
                                    tmp94.preserve();
                                    objv93[0] = tmp94;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv93, compiledLocals, 2);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv93, 1);
                                }
                            } // End Invoke: append
                        } else {
                            { // Invoke: set gs_buffers [...]
                                TclObject tmp97;
                                { // Invoke: ... $key 1 set $tmpsymbol true $value
                                    TclObject[] objv98 = TJC.grabObjv(interp, 7);
                                    TclObject tmp99;
                                    try {
                                        // Arg 0 constant: ...
                                        objv98[0] = const10;
                                        // Arg 1 variable: $key
                                        tmp99 = getVarScalar(interp, "key", compiledLocals, 0);
                                        tmp99.preserve();
                                        objv98[1] = tmp99;
                                        // Arg 2 constant: 1
                                        objv98[2] = const2;
                                        // Arg 3 constant: set
                                        objv98[3] = const17;
                                        // Arg 4 variable: $tmpsymbol
                                        tmp99 = getVarScalar(interp, "tmpsymbol", compiledLocals, 10);
                                        tmp99.preserve();
                                        objv98[4] = tmp99;
                                        // Arg 5 constant: true
                                        objv98[5] = const8;
                                        // Arg 6 variable: $value
                                        tmp99 = getVarScalar(interp, "value", compiledLocals, 15);
                                        tmp99.preserve();
                                        objv98[6] = tmp99;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                            ? cmdcache6.cmd : null), objv98, 0);
                                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                            updateCmdCache(interp, 6);
                                        }
                                    } finally {
                                        tmp99 = objv98[1];
                                        if ( tmp99 != null ) {
                                            tmp99.release();
                                        }
                                        tmp99 = objv98[4];
                                        if ( tmp99 != null ) {
                                            tmp99.release();
                                        }
                                        tmp99 = objv98[6];
                                        if ( tmp99 != null ) {
                                            tmp99.release();
                                        }
                                        TJC.releaseObjv(interp, objv98, 7);
                                    }
                                } // End Invoke: ...
                                tmp97 = interp.getResult();
                                setVarScalar(interp, "gs_buffers", tmp97, compiledLocals, 16);
                            } // End Invoke: set
                            { // Invoke: append buffer [...] $value_buffer [...]
                                TclObject[] objv100 = TJC.grabObjv(interp, 3);
                                TclObject tmp101;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: lindex $gs_buffers 0
                                        TclObject tmp102 = getVarScalar(interp, "gs_buffers", compiledLocals, 16);
                                        tmp102 = TclList.index(interp, tmp102, 0);
                                        if ( tmp102 == null ) {
                                            interp.resetResult();
                                        } else {
                                            interp.setResult(tmp102);
                                        }
                                    } // End Invoke: lindex
                                    tmp101 = interp.getResult();
                                    tmp101.preserve();
                                    objv100[0] = tmp101;
                                    // Arg 3 variable: $value_buffer
                                    tmp101 = getVarScalar(interp, "value_buffer", compiledLocals, 14);
                                    tmp101.preserve();
                                    objv100[1] = tmp101;
                                    // Arg 4 command: [...]
                                    { // Invoke: lindex $gs_buffers 1
                                        TclObject tmp103 = getVarScalar(interp, "gs_buffers", compiledLocals, 16);
                                        tmp103 = TclList.index(interp, tmp103, 1);
                                        if ( tmp103 == null ) {
                                            interp.resetResult();
                                        } else {
                                            interp.setResult(tmp103);
                                        }
                                    } // End Invoke: lindex
                                    tmp101 = interp.getResult();
                                    tmp101.preserve();
                                    objv100[2] = tmp101;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv100, compiledLocals, 2);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv100, 3);
                                }
                            } // End Invoke: append
                        }
                    } // End Invoke: if
                } else {
                    { // Invoke: error ...
                        TclObject[] objv104 = TJC.grabObjv(interp, 2);
                        try {
                            // Arg 0 constant: error
                            objv104[0] = const18;
                            // Arg 1 constant: ...
                            objv104[1] = const19;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                ? cmdcache10.cmd : null), objv104, 0);
                            if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                updateCmdCache(interp, 10);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv104, 2);
                        }
                    } // End Invoke: error
                }
            }
        } // End Invoke: if
        { // Invoke: if {!$omit_result} ...
            // Unary operator: ! $omit_result
            TclObject tmp105 = getVarScalar(interp, "omit_result", compiledLocals, 9);
            ExprValue tmp106 = evs0;
            if ( tmp105.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp106, tmp105);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp106, tmp105);
            }
            // End Unary operator: !
            boolean tmp107 = ( tmp106.getIntValue() != 0 );
            if ( tmp107 ) {
                { // Invoke: append buffer [...]
                    TclObject[] objv108 = TJC.grabObjv(interp, 1);
                    TclObject tmp109;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: emitter_set_result $tmpsymbol false
                            TclObject[] objv110 = TJC.grabObjv(interp, 3);
                            TclObject tmp111;
                            try {
                                // Arg 0 constant: emitter_set_result
                                objv110[0] = const20;
                                // Arg 1 variable: $tmpsymbol
                                tmp111 = getVarScalar(interp, "tmpsymbol", compiledLocals, 10);
                                tmp111.preserve();
                                objv110[1] = tmp111;
                                // Arg 2 constant: false
                                objv110[2] = const15;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                                    ? cmdcache11.cmd : null), objv110, 0);
                                if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                                    updateCmdCache(interp, 11);
                                }
                            } finally {
                                tmp111 = objv110[1];
                                if ( tmp111 != null ) {
                                    tmp111.release();
                                }
                                TJC.releaseObjv(interp, objv110, 3);
                            }
                        } // End Invoke: emitter_set_result
                        tmp109 = interp.getResult();
                        tmp109.preserve();
                        objv108[0] = tmp109;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv108, compiledLocals, 2);
                    } finally {
                        TJC.releaseObjvElems(interp, objv108, 1);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: return $buffer
            TclObject tmp112 = getVarScalar(interp, "buffer", compiledLocals, 2);
            interp.resetResult();
            interp.setResult(tmp112);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_emit_inline_command_set");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("compileproc_get_argument_tuple");
        const1.preserve(); const1.preserve();
        const2 = TclInteger.newInstance(1);
        const2.preserve(); const2.preserve();
        const3 = TclInteger.newInstance(0);
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("descend_get_data");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("tree");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("compileproc_tmpvar_next");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("compileproc_get_variable");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("true");
        TclBoolean.get(interp, const8);
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("emitter_statement");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("compileproc_get_set_nonconstant_array_variable");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("get");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("compileproc_omit_set_result");
        const12.preserve(); const12.preserve();
        const13 = TclInteger.newInstance(2);
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("compileproc_emit_argument");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("false");
        TclBoolean.get(interp, const15);
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("compileproc_set_variable");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("set");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("error");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance("expected 2 or 3 arguments to set");
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance("emitter_set_result");
        const20.preserve(); const20.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;
    WrappedCommand cmdcache10;
    int cmdcache10_cmdEpoch;
    WrappedCommand cmdcache11;
    int cmdcache11_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                cmdcache10 = TJC.INVALID_COMMAND_CACHE;
                cmdcache10_cmdEpoch = 0;
                cmdcache11 = TJC.INVALID_COMMAND_CACHE;
                cmdcache11_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "compileproc_get_argument_tuple";
                break;
            }
            case 2: {
                cmdName = "descend_get_data";
                break;
            }
            case 3: {
                cmdName = "compileproc_tmpvar_next";
                break;
            }
            case 4: {
                cmdName = "compileproc_get_variable";
                break;
            }
            case 5: {
                cmdName = "emitter_statement";
                break;
            }
            case 6: {
                cmdName = "compileproc_get_set_nonconstant_array_variable";
                break;
            }
            case 7: {
                cmdName = "compileproc_omit_set_result";
                break;
            }
            case 8: {
                cmdName = "compileproc_emit_argument";
                break;
            }
            case 9: {
                cmdName = "compileproc_set_variable";
                break;
            }
            case 10: {
                cmdName = "error";
                break;
            }
            case 11: {
                cmdName = "emitter_set_result";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
            case 10: {
                cmdcache10 = lwcmd;
                cmdcache10_cmdEpoch = cmdEpoch;
                break;
            }
            case 11: {
                cmdcache11 = lwcmd;
                cmdcache11_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_compileproc",
        "buffer",
        "tuple",
        "type",
        "constant_varname",
        "varname",
        "tree",
        "num_args",
        "omit_result",
        "tmpsymbol",
        "gs_buffer",
        "value_type",
        "value_symbol",
        "value_buffer",
        "value",
        "gs_buffers"
    };
} // end class CompileprocEmitInlineCommandSetCmd

