// TJC implementation of procedure compileproc_entry_point
package tjc;
import tcl.lang.*;

public class CompileprocEntryPointCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 15, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "filename proc_tuple");
        }
        setVarScalar(interp, "filename", objv[1], compiledLocals, 0);
        setVarScalar(interp, "proc_tuple", objv[2], compiledLocals, 1);
        { // Invoke: set proc_name [...]
            TclObject tmp0;
            { // Invoke: lindex $proc_tuple 0
                TclObject tmp1 = getVarScalar(interp, "proc_tuple", compiledLocals, 1);
                tmp1 = TclList.index(interp, tmp1, 0);
                if ( tmp1 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp1);
                }
            } // End Invoke: lindex
            tmp0 = interp.getResult();
            setVarScalar(interp, "proc_name", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set package [...]
            TclObject tmp2;
            { // Invoke: module_query PACKAGE
                TclObject[] objv3 = TJC.grabObjv(interp, 2);
                try {
                    // Arg 0 constant: module_query
                    objv3[0] = const0;
                    // Arg 1 constant: PACKAGE
                    objv3[1] = const1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv3, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv3, 2);
                }
            } // End Invoke: module_query
            tmp2 = interp.getResult();
            setVarScalar(interp, "package", tmp2, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set compile_option [...]
            TclObject tmp4;
            { // Invoke: module_option_value compile
                TclObject[] objv5 = TJC.grabObjv(interp, 2);
                try {
                    // Arg 0 constant: module_option_value
                    objv5[0] = const2;
                    // Arg 1 constant: compile
                    objv5[1] = const3;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv5, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv5, 2);
                }
            } // End Invoke: module_option_value
            tmp4 = interp.getResult();
            setVarScalar(interp, "compile_option", tmp4, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set class_name [...]
            TclObject tmp6;
            { // Invoke: lindex $proc_tuple 1
                TclObject tmp7 = getVarScalar(interp, "proc_tuple", compiledLocals, 1);
                tmp7 = TclList.index(interp, tmp7, 1);
                if ( tmp7 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp7);
                }
            } // End Invoke: lindex
            tmp6 = interp.getResult();
            setVarScalar(interp, "class_name", tmp6, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set proc [...]
            TclObject tmp8;
            { // Invoke: lindex $proc_tuple 2
                TclObject tmp9 = getVarScalar(interp, "proc_tuple", compiledLocals, 1);
                tmp9 = TclList.index(interp, tmp9, 2);
                if ( tmp9 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp9);
                }
            } // End Invoke: lindex
            tmp8 = interp.getResult();
            setVarScalar(interp, "proc", tmp8, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set proc_list [...]
            TclObject tmp10;
            { // Invoke: lrange $proc 1 end
                TclObject[] objv11 = TJC.grabObjv(interp, 4);
                TclObject tmp12;
                try {
                    // Arg 0 constant: lrange
                    objv11[0] = const4;
                    // Arg 1 variable: $proc
                    tmp12 = getVarScalar(interp, "proc", compiledLocals, 6);
                    tmp12.preserve();
                    objv11[1] = tmp12;
                    // Arg 2 constant: 1
                    objv11[2] = const5;
                    // Arg 3 constant: end
                    objv11[3] = const6;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv11, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp12 = objv11[1];
                    if ( tmp12 != null ) {
                        tmp12.release();
                    }
                    TJC.releaseObjv(interp, objv11, 4);
                }
            } // End Invoke: lrange
            tmp10 = interp.getResult();
            setVarScalar(interp, "proc_list", tmp10, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: set proc_compile_option [...]
            TclObject tmp13;
            { // Invoke: module_option_value compile $proc_name
                TclObject[] objv14 = TJC.grabObjv(interp, 3);
                TclObject tmp15;
                try {
                    // Arg 0 constant: module_option_value
                    objv14[0] = const2;
                    // Arg 1 constant: compile
                    objv14[1] = const3;
                    // Arg 2 variable: $proc_name
                    tmp15 = getVarScalar(interp, "proc_name", compiledLocals, 2);
                    tmp15.preserve();
                    objv14[2] = tmp15;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv14, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp15 = objv14[2];
                    if ( tmp15 != null ) {
                        tmp15.release();
                    }
                    TJC.releaseObjv(interp, objv14, 3);
                }
            } // End Invoke: module_option_value
            tmp13 = interp.getResult();
            setVarScalar(interp, "proc_compile_option", tmp13, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: $proc_compile_option == ""
            TclObject tmp16 = getVarScalar(interp, "proc_compile_option", compiledLocals, 8);
            ExprValue tmp17 = evs0;
            TJC.exprEqualsEmptyString(tmp17, tmp16, false);
            // End Binary operator: ==
            boolean tmp18 = ( tmp17.getIntValue() != 0 );
            if ( tmp18 ) {
                { // Invoke: set proc_compile_option $compile_option
                    TclObject tmp19;
                    tmp19 = getVarScalar(interp, "compile_option", compiledLocals, 4);
                    setVarScalar(interp, "proc_compile_option", tmp19, compiledLocals, 8);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: if ... ... else ...
            TclObject tmp20 = getVarScalar(interp, "proc_compile_option", compiledLocals, 8);
            boolean tmp21 = TJC.getBoolean(interp, tmp20);
            if ( tmp21 ) {
                { // Invoke: if ... ...
                    { // Invoke: catch ... err
                        int code22 = TCL.OK;
                        try {
                        if ( false ) { throw (TclException) null; }
                        { // Invoke: set class_data [...]
                            TclObject tmp23;
                            { // Invoke: compileproc_compile $proc_list $class_name ...
                                TclObject[] objv24 = TJC.grabObjv(interp, 4);
                                TclObject tmp25;
                                try {
                                    // Arg 0 constant: compileproc_compile
                                    objv24[0] = const7;
                                    // Arg 1 variable: $proc_list
                                    tmp25 = getVarScalar(interp, "proc_list", compiledLocals, 7);
                                    tmp25.preserve();
                                    objv24[1] = tmp25;
                                    // Arg 2 variable: $class_name
                                    tmp25 = getVarScalar(interp, "class_name", compiledLocals, 5);
                                    tmp25.preserve();
                                    objv24[2] = tmp25;
                                    // Arg 3 constant: ...
                                    objv24[3] = const8;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                        ? cmdcache4.cmd : null), objv24, 0);
                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                        updateCmdCache(interp, 4);
                                    }
                                } finally {
                                    tmp25 = objv24[1];
                                    if ( tmp25 != null ) {
                                        tmp25.release();
                                    }
                                    tmp25 = objv24[2];
                                    if ( tmp25 != null ) {
                                        tmp25.release();
                                    }
                                    TJC.releaseObjv(interp, objv24, 4);
                                }
                            } // End Invoke: compileproc_compile
                            tmp23 = interp.getResult();
                            tmp23 = setVarScalar(interp, "class_data", tmp23, compiledLocals, 9);
                            interp.setResult(tmp23);
                        } // End Invoke: set
                        } catch (TclException ex) {
                            code22 = ex.getCompletionCode();
                        }
                        TclObject result = interp.getResult();
                        try {
                            setVarScalar(interp, "err", result, compiledLocals, 10);
                        } catch (TclException ex) {
                            TJC.catchVarErr(interp);
                        }
                        interp.resetResult();
                        interp.setResult(code22);
                    } // End Invoke: catch
                    TclObject tmp26 = interp.getResult();
                    ExprValue tmp27 = evs0;
                    TJC.exprInitValue(interp, tmp27, tmp26);
                    boolean tmp28 = tmp27.getBooleanValue(interp);
                    if ( tmp28 ) {
                        { // Invoke: global _tjc
                            TJC.makeGlobalLinkVar(interp, "_tjc", "_tjc", 11);
                        } // End Invoke: global
                        { // Invoke: if ... ... else ...
                            // Binary operator: () || ()
                            // Unary operator: ! [...]
                            { // Invoke: info exists _tjc(parse_error)
                                TclObject[] objv29 = TJC.grabObjv(interp, 3);
                                try {
                                    // Arg 0 constant: info
                                    objv29[0] = const9;
                                    // Arg 1 constant: exists
                                    objv29[1] = const10;
                                    // Arg 2 constant: _tjc(parse_error)
                                    objv29[2] = const11;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                        ? cmdcache5.cmd : null), objv29, 0);
                                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                        updateCmdCache(interp, 5);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv29, 3);
                                }
                            } // End Invoke: info
                            TclObject tmp30 = interp.getResult();
                            ExprValue tmp31 = evs0;
                            if ( tmp30.isIntType() ) {
                                TJC.exprUnaryNotOperatorKnownInt(tmp31, tmp30);
                            } else {
                                TJC.exprUnaryNotOperator(interp, tmp31, tmp30);
                            }
                            // End Unary operator: !
                            if (!tmp31.getBooleanValue(interp)) {
                            // Binary operator: $_tjc(...) == ""
                            TclObject tmp32 = getVarArray(interp, "_tjc", "parse_error", compiledLocals, 11);
                            ExprValue tmp33 = evs1;
                            TJC.exprEqualsEmptyString(tmp33, tmp32, false);
                            // End Binary operator: ==
                            tmp31.setIntValue(tmp33.getBooleanValue(interp));
                            } else {
                            tmp31.setIntValue(1);
                            } // End if: !()
                            // End Binary operator: ||
                            boolean tmp34 = ( tmp31.getIntValue() != 0 );
                            if ( tmp34 ) {
                                { // Invoke: puts stderr "..."
                                    TclObject[] objv35 = TJC.grabObjv(interp, 3);
                                    TclObject tmp36;
                                    try {
                                        // Arg 0 constant: puts
                                        objv35[0] = const12;
                                        // Arg 1 constant: stderr
                                        objv35[1] = const13;
                                        // Arg 2 word: "..."
                                        StringBuffer sbtmp37 = new StringBuffer(64);
                                        sbtmp37.append("Interal error while compiling proc ");
                                        sbtmp37.append("\"");
                                        tmp36 = getVarScalar(interp, "proc_name", compiledLocals, 2);
                                        sbtmp37.append(tmp36.toString());
                                        sbtmp37.append("\"");
                                        sbtmp37.append(" in file ");
                                        tmp36 = getVarScalar(interp, "filename", compiledLocals, 0);
                                        sbtmp37.append(tmp36.toString());
                                        tmp36 = TclString.newInstance(sbtmp37);
                                        tmp36.preserve();
                                        objv35[2] = tmp36;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                            ? cmdcache6.cmd : null), objv35, 0);
                                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                            updateCmdCache(interp, 6);
                                        }
                                    } finally {
                                        tmp36 = objv35[2];
                                        if ( tmp36 != null ) {
                                            tmp36.release();
                                        }
                                        TJC.releaseObjv(interp, objv35, 3);
                                    }
                                } // End Invoke: puts
                                { // Invoke: set lines [...]
                                    TclObject tmp38;
                                    { // Invoke: split $::errorInfo ...
                                        TclObject[] objv39 = TJC.grabObjv(interp, 3);
                                        TclObject tmp40;
                                        try {
                                            // Arg 0 constant: split
                                            objv39[0] = const14;
                                            // Arg 1 variable: $::errorInfo
                                            initVarScoped(interp, "::errorInfo", compiledLocals, 12);
                                            tmp40 = getVarScalar(interp, "::errorInfo", compiledLocals, 12);
                                            tmp40.preserve();
                                            objv39[1] = tmp40;
                                            // Arg 2 constant: ...
                                            objv39[2] = const15;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                                ? cmdcache7.cmd : null), objv39, 0);
                                            if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                                updateCmdCache(interp, 7);
                                            }
                                        } finally {
                                            tmp40 = objv39[1];
                                            if ( tmp40 != null ) {
                                                tmp40.release();
                                            }
                                            TJC.releaseObjv(interp, objv39, 3);
                                        }
                                    } // End Invoke: split
                                    tmp38 = interp.getResult();
                                    setVarScalar(interp, "lines", tmp38, compiledLocals, 13);
                                } // End Invoke: set
                                { // Invoke: foreach line $lines ...
                                    TclObject tmp41 = null;
                                    try {
                                        tmp41 = getVarScalar(interp, "lines", compiledLocals, 13);
                                        tmp41.preserve();
                                        final int tmp41_length = TclList.getLength(interp, tmp41);

                                        for ( int index42 = 0 ; index42 < tmp41_length ; index42++ ) {
                                            TclObject tmp43 = TclList.index(interp, tmp41, index42);
                                            try {
                                                setVarScalar(interp, "line", tmp43, compiledLocals, 14);
                                            } catch (TclException ex) {
                                                TJC.foreachVarErr(interp, "line");
                                            }

                                            try {
                                            if ( false ) { throw (TclException) null; }
                                            { // Invoke: puts stderr $line
                                                TclObject[] objv44 = TJC.grabObjv(interp, 3);
                                                TclObject tmp45;
                                                try {
                                                    // Arg 0 constant: puts
                                                    objv44[0] = const12;
                                                    // Arg 1 constant: stderr
                                                    objv44[1] = const13;
                                                    // Arg 2 variable: $line
                                                    tmp45 = getVarScalar(interp, "line", compiledLocals, 14);
                                                    tmp45.preserve();
                                                    objv44[2] = tmp45;
                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                        updateCmdCache(interp, 0);
                                                    }
                                                    TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                                        ? cmdcache6.cmd : null), objv44, 0);
                                                    if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                                        updateCmdCache(interp, 6);
                                                    }
                                                } finally {
                                                    tmp45 = objv44[2];
                                                    if ( tmp45 != null ) {
                                                        tmp45.release();
                                                    }
                                                    TJC.releaseObjv(interp, objv44, 3);
                                                }
                                            } // End Invoke: puts
                                            { // Invoke: if ... ...
                                                // Binary operator: [...] != ()
                                                { // Invoke: string first ... $line
                                                    String tmp46 = "compileproc_compile";
                                                    TclObject tmp47 = getVarScalar(interp, "line", compiledLocals, 14);
                                                    String tmp48 = tmp47.toString();
                                                    int tmp49 = tmp48.indexOf(tmp46);
                                                    interp.setResult(tmp49);
                                                } // End Invoke: string
                                                TclObject tmp50 = interp.getResult();
                                                ExprValue tmp51 = evs0;
                                                TJC.exprInitValue(interp, tmp51, tmp50);
                                                // Unary operator: - 1
                                                ExprValue tmp52 = evs1;
                                                tmp52.setIntValue(-1);
                                                // End Unary operator: -
                                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp51, tmp52);
                                                // End Binary operator: !=
                                                boolean tmp53 = ( tmp51.getIntValue() != 0 );
                                                if ( tmp53 ) {
                                                    { // Invoke: break
                                                        if ( true ) { break; }
                                                    } // End Invoke: break
                                                }
                                            } // End Invoke: if
                                            } catch (TclException ex) {
                                                int type = ex.getCompletionCode();
                                                if (type == TCL.BREAK) {
                                                    break;
                                                } else if (type == TCL.CONTINUE) {
                                                    continue;
                                                } else {
                                                    throw ex;
                                                }
                                            }
                                        }
                                    } finally {
                                        if ( tmp41 != null ) {
                                            tmp41.release();
                                        }
                                    }
                                } // End Invoke: foreach
                            } else {
                                { // Invoke: puts stderr "..."
                                    TclObject[] objv54 = TJC.grabObjv(interp, 3);
                                    TclObject tmp55;
                                    try {
                                        // Arg 0 constant: puts
                                        objv54[0] = const12;
                                        // Arg 1 constant: stderr
                                        objv54[1] = const13;
                                        // Arg 2 word: "..."
                                        StringBuffer sbtmp56 = new StringBuffer(64);
                                        sbtmp56.append("Parse error while compiling proc ");
                                        sbtmp56.append("\"");
                                        tmp55 = getVarScalar(interp, "proc_name", compiledLocals, 2);
                                        sbtmp56.append(tmp55.toString());
                                        sbtmp56.append("\"");
                                        sbtmp56.append(" in file ");
                                        tmp55 = getVarScalar(interp, "filename", compiledLocals, 0);
                                        sbtmp56.append(tmp55.toString());
                                        tmp55 = TclString.newInstance(sbtmp56);
                                        tmp55.preserve();
                                        objv54[2] = tmp55;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                            ? cmdcache6.cmd : null), objv54, 0);
                                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                            updateCmdCache(interp, 6);
                                        }
                                    } finally {
                                        tmp55 = objv54[2];
                                        if ( tmp55 != null ) {
                                            tmp55.release();
                                        }
                                        TJC.releaseObjv(interp, objv54, 3);
                                    }
                                } // End Invoke: puts
                                { // Invoke: puts stderr $_tjc(parse_error)
                                    TclObject[] objv57 = TJC.grabObjv(interp, 3);
                                    TclObject tmp58;
                                    try {
                                        // Arg 0 constant: puts
                                        objv57[0] = const12;
                                        // Arg 1 constant: stderr
                                        objv57[1] = const13;
                                        // Arg 2 variable: $_tjc(parse_error)
                                        tmp58 = getVarArray(interp, "_tjc", "parse_error", compiledLocals, 11);
                                        tmp58.preserve();
                                        objv57[2] = tmp58;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                            ? cmdcache6.cmd : null), objv57, 0);
                                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                            updateCmdCache(interp, 6);
                                        }
                                    } finally {
                                        tmp58 = objv57[2];
                                        if ( tmp58 != null ) {
                                            tmp58.release();
                                        }
                                        TJC.releaseObjv(interp, objv57, 3);
                                    }
                                } // End Invoke: puts
                                { // Invoke: puts stderr ...
                                    TclObject[] objv59 = TJC.grabObjv(interp, 3);
                                    try {
                                        // Arg 0 constant: puts
                                        objv59[0] = const12;
                                        // Arg 1 constant: stderr
                                        objv59[1] = const13;
                                        // Arg 2 constant: ...
                                        objv59[2] = const16;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                            ? cmdcache6.cmd : null), objv59, 0);
                                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                            updateCmdCache(interp, 6);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv59, 3);
                                    }
                                } // End Invoke: puts
                                { // Invoke: puts stderr $_tjc(parse_script)
                                    TclObject[] objv60 = TJC.grabObjv(interp, 3);
                                    TclObject tmp61;
                                    try {
                                        // Arg 0 constant: puts
                                        objv60[0] = const12;
                                        // Arg 1 constant: stderr
                                        objv60[1] = const13;
                                        // Arg 2 variable: $_tjc(parse_script)
                                        tmp61 = getVarArray(interp, "_tjc", "parse_script", compiledLocals, 11);
                                        tmp61.preserve();
                                        objv60[2] = tmp61;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                            ? cmdcache6.cmd : null), objv60, 0);
                                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                            updateCmdCache(interp, 6);
                                        }
                                    } finally {
                                        tmp61 = objv60[2];
                                        if ( tmp61 != null ) {
                                            tmp61.release();
                                        }
                                        TJC.releaseObjv(interp, objv60, 3);
                                    }
                                } // End Invoke: puts
                            }
                        } // End Invoke: if
                        { // Invoke: return "ERROR"
                            interp.resetResult();
                            interp.setResult(const17);
                            if ( true ) { return; }
                        } // End Invoke: return
                    }
                } // End Invoke: if
                { // Invoke: return [...]
                    { // Invoke: list $filename $proc_name $class_name $class_data
                        TclObject tmp62 = TclList.newInstance();
                        TclObject tmp63;
                        try {
                            tmp63 = getVarScalar(interp, "filename", compiledLocals, 0);
                            TclList.append(interp, tmp62, tmp63);
                            tmp63 = getVarScalar(interp, "proc_name", compiledLocals, 2);
                            TclList.append(interp, tmp62, tmp63);
                            tmp63 = getVarScalar(interp, "class_name", compiledLocals, 5);
                            TclList.append(interp, tmp62, tmp63);
                            tmp63 = getVarScalar(interp, "class_data", compiledLocals, 9);
                            TclList.append(interp, tmp62, tmp63);
                        } catch (TclException ex) {
                            tmp62.release();
                            throw ex;
                        }
                        interp.setResult(tmp62);
                    } // End Invoke: list
                    if ( true ) { return; }
                } // End Invoke: return
            } else {
                { // Invoke: if ... ...
                    { // Invoke: catch ... err
                        int code64 = TCL.OK;
                        try {
                        if ( false ) { throw (TclException) null; }
                        { // Invoke: set class_data [...]
                            TclObject tmp65;
                            { // Invoke: ... $proc_list $class_name
                                TclObject[] objv66 = TJC.grabObjv(interp, 3);
                                TclObject tmp67;
                                try {
                                    // Arg 0 constant: ...
                                    objv66[0] = const18;
                                    // Arg 1 variable: $proc_list
                                    tmp67 = getVarScalar(interp, "proc_list", compiledLocals, 7);
                                    tmp67.preserve();
                                    objv66[1] = tmp67;
                                    // Arg 2 variable: $class_name
                                    tmp67 = getVarScalar(interp, "class_name", compiledLocals, 5);
                                    tmp67.preserve();
                                    objv66[2] = tmp67;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                        ? cmdcache8.cmd : null), objv66, 0);
                                    if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                        updateCmdCache(interp, 8);
                                    }
                                } finally {
                                    tmp67 = objv66[1];
                                    if ( tmp67 != null ) {
                                        tmp67.release();
                                    }
                                    tmp67 = objv66[2];
                                    if ( tmp67 != null ) {
                                        tmp67.release();
                                    }
                                    TJC.releaseObjv(interp, objv66, 3);
                                }
                            } // End Invoke: ...
                            tmp65 = interp.getResult();
                            tmp65 = setVarScalar(interp, "class_data", tmp65, compiledLocals, 9);
                            interp.setResult(tmp65);
                        } // End Invoke: set
                        } catch (TclException ex) {
                            code64 = ex.getCompletionCode();
                        }
                        TclObject result = interp.getResult();
                        try {
                            setVarScalar(interp, "err", result, compiledLocals, 10);
                        } catch (TclException ex) {
                            TJC.catchVarErr(interp);
                        }
                        interp.resetResult();
                        interp.setResult(code64);
                    } // End Invoke: catch
                    TclObject tmp68 = interp.getResult();
                    ExprValue tmp69 = evs0;
                    TJC.exprInitValue(interp, tmp69, tmp68);
                    boolean tmp70 = tmp69.getBooleanValue(interp);
                    if ( tmp70 ) {
                        { // Invoke: puts stderr "..."
                            TclObject[] objv71 = TJC.grabObjv(interp, 3);
                            TclObject tmp72;
                            try {
                                // Arg 0 constant: puts
                                objv71[0] = const12;
                                // Arg 1 constant: stderr
                                objv71[1] = const13;
                                // Arg 2 word: "..."
                                StringBuffer sbtmp73 = new StringBuffer(64);
                                sbtmp73.append("Interal error while generating proc ");
                                sbtmp73.append("\"");
                                tmp72 = getVarScalar(interp, "proc_name", compiledLocals, 2);
                                sbtmp73.append(tmp72.toString());
                                sbtmp73.append("\"");
                                sbtmp73.append(" in file ");
                                tmp72 = getVarScalar(interp, "filename", compiledLocals, 0);
                                sbtmp73.append(tmp72.toString());
                                tmp72 = TclString.newInstance(sbtmp73);
                                tmp72.preserve();
                                objv71[2] = tmp72;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                    ? cmdcache6.cmd : null), objv71, 0);
                                if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                    updateCmdCache(interp, 6);
                                }
                            } finally {
                                tmp72 = objv71[2];
                                if ( tmp72 != null ) {
                                    tmp72.release();
                                }
                                TJC.releaseObjv(interp, objv71, 3);
                            }
                        } // End Invoke: puts
                        { // Invoke: puts stderr "$err"
                            TclObject[] objv74 = TJC.grabObjv(interp, 3);
                            TclObject tmp75;
                            try {
                                // Arg 0 constant: puts
                                objv74[0] = const12;
                                // Arg 1 constant: stderr
                                objv74[1] = const13;
                                // Arg 2 word: "$err"
                                tmp75 = getVarScalar(interp, "err", compiledLocals, 10);
                                tmp75.preserve();
                                objv74[2] = tmp75;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                    ? cmdcache6.cmd : null), objv74, 0);
                                if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                    updateCmdCache(interp, 6);
                                }
                            } finally {
                                tmp75 = objv74[2];
                                if ( tmp75 != null ) {
                                    tmp75.release();
                                }
                                TJC.releaseObjv(interp, objv74, 3);
                            }
                        } // End Invoke: puts
                        { // Invoke: return "ERROR"
                            interp.resetResult();
                            interp.setResult(const17);
                            if ( true ) { return; }
                        } // End Invoke: return
                    }
                } // End Invoke: if
                { // Invoke: return [...]
                    { // Invoke: list $filename $proc_name $class_name $class_data
                        TclObject tmp76 = TclList.newInstance();
                        TclObject tmp77;
                        try {
                            tmp77 = getVarScalar(interp, "filename", compiledLocals, 0);
                            TclList.append(interp, tmp76, tmp77);
                            tmp77 = getVarScalar(interp, "proc_name", compiledLocals, 2);
                            TclList.append(interp, tmp76, tmp77);
                            tmp77 = getVarScalar(interp, "class_name", compiledLocals, 5);
                            TclList.append(interp, tmp76, tmp77);
                            tmp77 = getVarScalar(interp, "class_data", compiledLocals, 9);
                            TclList.append(interp, tmp76, tmp77);
                        } catch (TclException ex) {
                            tmp76.release();
                            throw ex;
                        }
                        interp.setResult(tmp76);
                    } // End Invoke: list
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_entry_point");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("module_query");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("PACKAGE");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("module_option_value");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("compile");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("lrange");
        const4.preserve(); const4.preserve();
        const5 = TclInteger.newInstance(1);
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("end");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("compileproc_compile");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("compileproc_query_module_flags");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("info");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("exists");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("_tjc(parse_error)");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("puts");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("stderr");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("split");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("\n");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("While parsing script text:");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("ERROR");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("compileproc_nocompile");
        const18.preserve(); const18.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "module_query";
                break;
            }
            case 2: {
                cmdName = "module_option_value";
                break;
            }
            case 3: {
                cmdName = "lrange";
                break;
            }
            case 4: {
                cmdName = "compileproc_compile";
                break;
            }
            case 5: {
                cmdName = "info";
                break;
            }
            case 6: {
                cmdName = "puts";
                break;
            }
            case 7: {
                cmdName = "split";
                break;
            }
            case 8: {
                cmdName = "compileproc_nocompile";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "filename",
        "proc_tuple",
        "proc_name",
        "package",
        "compile_option",
        "class_name",
        "proc",
        "proc_list",
        "proc_compile_option",
        "class_data",
        "err",
        "_tjc",
        "::errorInfo",
        "lines",
        "line"
    };
} // end class CompileprocEntryPointCmd

