// TJC implementation of procedure compileproc_query_module_flags
package tjc;
import tcl.lang.*;

public class CompileprocQueryModuleFlagsCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 12, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "proc_name");
        }
        setVarScalar(interp, "proc_name", objv[1], compiledLocals, 0);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 1);
        } // End Invoke: global
        { // Invoke: set ... [...]
            TclObject tmp0;
            { // Invoke: module_option_value inline-containers $proc_name
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: module_option_value
                    objv1[0] = const0;
                    // Arg 1 constant: inline-containers
                    objv1[1] = const1;
                    // Arg 2 variable: $proc_name
                    tmp2 = getVarScalar(interp, "proc_name", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[2] = tmp2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[2];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: module_option_value
            tmp0 = interp.getResult();
            setVarScalar(interp, "inline_containers_option", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: $inline_containers_option == ""
            TclObject tmp3 = getVarScalar(interp, "inline_containers_option", compiledLocals, 2);
            ExprValue tmp4 = evs0;
            TJC.exprEqualsEmptyString(tmp4, tmp3, false);
            // End Binary operator: ==
            boolean tmp5 = ( tmp4.getIntValue() != 0 );
            if ( tmp5 ) {
                { // Invoke: set ... [...]
                    TclObject tmp6;
                    { // Invoke: module_option_value inline-containers
                        TclObject[] objv7 = TJC.grabObjv(interp, 2);
                        try {
                            // Arg 0 constant: module_option_value
                            objv7[0] = const0;
                            // Arg 1 constant: inline-containers
                            objv7[1] = const1;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv7, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv7, 2);
                        }
                    } // End Invoke: module_option_value
                    tmp6 = interp.getResult();
                    setVarScalar(interp, "inline_containers_option", tmp6, compiledLocals, 2);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: if ... ... else ...
            TclObject tmp8 = getVarScalar(interp, "inline_containers_option", compiledLocals, 2);
            boolean tmp9 = TJC.getBoolean(interp, tmp8);
            if ( tmp9 ) {
                { // Invoke: set ... all
                    setVarArray(interp, "_compileproc", "options,inline_containers", const2, compiledLocals, 1);
                } // End Invoke: set
            } else {
                { // Invoke: if ... ...
                    // Binary operator: $_compileproc(...) != ""
                    TclObject tmp10 = getVarArray(interp, "_compileproc", "options,inline_containers", compiledLocals, 1);
                    ExprValue tmp11 = evs0;
                    TJC.exprEqualsEmptyString(tmp11, tmp10, true);
                    // End Binary operator: !=
                    boolean tmp12 = ( tmp11.getIntValue() != 0 );
                    if ( tmp12 ) {
                        { // Invoke: error "..."
                            TclObject[] objv13 = TJC.grabObjv(interp, 2);
                            TclObject tmp14;
                            try {
                                // Arg 0 constant: error
                                objv13[0] = const3;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp15 = new StringBuffer(64);
                                sbtmp15.append("inline_containers option set to  ");
                                sbtmp15.append("\"");
                                tmp14 = getVarArray(interp, "_compileproc", "options,inline_containers", compiledLocals, 1);
                                sbtmp15.append(tmp14.toString());
                                sbtmp15.append("\"");
                                sbtmp15.append(", expected empty string");
                                tmp14 = TclString.newInstance(sbtmp15);
                                tmp14.preserve();
                                objv13[1] = tmp14;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv13, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                tmp14 = objv13[1];
                                if ( tmp14 != null ) {
                                    tmp14.release();
                                }
                                TJC.releaseObjv(interp, objv13, 2);
                            }
                        } // End Invoke: error
                    }
                } // End Invoke: if
            }
        } // End Invoke: if
        { // Invoke: set ... [...]
            TclObject tmp16;
            { // Invoke: module_option_value inline-controls $proc_name
                TclObject[] objv17 = TJC.grabObjv(interp, 3);
                TclObject tmp18;
                try {
                    // Arg 0 constant: module_option_value
                    objv17[0] = const0;
                    // Arg 1 constant: inline-controls
                    objv17[1] = const4;
                    // Arg 2 variable: $proc_name
                    tmp18 = getVarScalar(interp, "proc_name", compiledLocals, 0);
                    tmp18.preserve();
                    objv17[2] = tmp18;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv17, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp18 = objv17[2];
                    if ( tmp18 != null ) {
                        tmp18.release();
                    }
                    TJC.releaseObjv(interp, objv17, 3);
                }
            } // End Invoke: module_option_value
            tmp16 = interp.getResult();
            setVarScalar(interp, "inline_controls_option", tmp16, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: $inline_controls_option == ""
            TclObject tmp19 = getVarScalar(interp, "inline_controls_option", compiledLocals, 3);
            ExprValue tmp20 = evs0;
            TJC.exprEqualsEmptyString(tmp20, tmp19, false);
            // End Binary operator: ==
            boolean tmp21 = ( tmp20.getIntValue() != 0 );
            if ( tmp21 ) {
                { // Invoke: set ... [...]
                    TclObject tmp22;
                    { // Invoke: module_option_value inline-controls
                        TclObject[] objv23 = TJC.grabObjv(interp, 2);
                        try {
                            // Arg 0 constant: module_option_value
                            objv23[0] = const0;
                            // Arg 1 constant: inline-controls
                            objv23[1] = const4;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv23, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv23, 2);
                        }
                    } // End Invoke: module_option_value
                    tmp22 = interp.getResult();
                    setVarScalar(interp, "inline_controls_option", tmp22, compiledLocals, 3);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            TclObject tmp24 = getVarScalar(interp, "inline_controls_option", compiledLocals, 3);
            boolean tmp25 = TJC.getBoolean(interp, tmp24);
            if ( tmp25 ) {
                { // Invoke: set ... 1
                    setVarArray(interp, "_compileproc", "options,inline_controls", const5, compiledLocals, 1);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: set ... [...]
            TclObject tmp26;
            { // Invoke: module_option_value cache-commands $proc_name
                TclObject[] objv27 = TJC.grabObjv(interp, 3);
                TclObject tmp28;
                try {
                    // Arg 0 constant: module_option_value
                    objv27[0] = const0;
                    // Arg 1 constant: cache-commands
                    objv27[1] = const6;
                    // Arg 2 variable: $proc_name
                    tmp28 = getVarScalar(interp, "proc_name", compiledLocals, 0);
                    tmp28.preserve();
                    objv27[2] = tmp28;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv27, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp28 = objv27[2];
                    if ( tmp28 != null ) {
                        tmp28.release();
                    }
                    TJC.releaseObjv(interp, objv27, 3);
                }
            } // End Invoke: module_option_value
            tmp26 = interp.getResult();
            setVarScalar(interp, "cache_commands_option", tmp26, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: $cache_commands_option == ""
            TclObject tmp29 = getVarScalar(interp, "cache_commands_option", compiledLocals, 4);
            ExprValue tmp30 = evs0;
            TJC.exprEqualsEmptyString(tmp30, tmp29, false);
            // End Binary operator: ==
            boolean tmp31 = ( tmp30.getIntValue() != 0 );
            if ( tmp31 ) {
                { // Invoke: set ... [...]
                    TclObject tmp32;
                    { // Invoke: module_option_value cache-commands
                        TclObject[] objv33 = TJC.grabObjv(interp, 2);
                        try {
                            // Arg 0 constant: module_option_value
                            objv33[0] = const0;
                            // Arg 1 constant: cache-commands
                            objv33[1] = const6;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv33, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv33, 2);
                        }
                    } // End Invoke: module_option_value
                    tmp32 = interp.getResult();
                    setVarScalar(interp, "cache_commands_option", tmp32, compiledLocals, 4);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            TclObject tmp34 = getVarScalar(interp, "cache_commands_option", compiledLocals, 4);
            boolean tmp35 = TJC.getBoolean(interp, tmp34);
            if ( tmp35 ) {
                { // Invoke: set ... 1
                    setVarArray(interp, "_compileproc", "options,cache_commands", const5, compiledLocals, 1);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: set ... [...]
            TclObject tmp36;
            { // Invoke: module_option_value constant-increment $proc_name
                TclObject[] objv37 = TJC.grabObjv(interp, 3);
                TclObject tmp38;
                try {
                    // Arg 0 constant: module_option_value
                    objv37[0] = const0;
                    // Arg 1 constant: constant-increment
                    objv37[1] = const7;
                    // Arg 2 variable: $proc_name
                    tmp38 = getVarScalar(interp, "proc_name", compiledLocals, 0);
                    tmp38.preserve();
                    objv37[2] = tmp38;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv37, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp38 = objv37[2];
                    if ( tmp38 != null ) {
                        tmp38.release();
                    }
                    TJC.releaseObjv(interp, objv37, 3);
                }
            } // End Invoke: module_option_value
            tmp36 = interp.getResult();
            setVarScalar(interp, "constant_increment_option", tmp36, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: $constant_increment_option == ""
            TclObject tmp39 = getVarScalar(interp, "constant_increment_option", compiledLocals, 5);
            ExprValue tmp40 = evs0;
            TJC.exprEqualsEmptyString(tmp40, tmp39, false);
            // End Binary operator: ==
            boolean tmp41 = ( tmp40.getIntValue() != 0 );
            if ( tmp41 ) {
                { // Invoke: set ... [...]
                    TclObject tmp42;
                    { // Invoke: module_option_value constant-increment
                        TclObject[] objv43 = TJC.grabObjv(interp, 2);
                        try {
                            // Arg 0 constant: module_option_value
                            objv43[0] = const0;
                            // Arg 1 constant: constant-increment
                            objv43[1] = const7;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv43, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv43, 2);
                        }
                    } // End Invoke: module_option_value
                    tmp42 = interp.getResult();
                    setVarScalar(interp, "constant_increment_option", tmp42, compiledLocals, 5);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Binary operator: $constant_increment_option == 0
            TclObject tmp44 = getVarScalar(interp, "constant_increment_option", compiledLocals, 5);
            ExprValue tmp45 = evs0;
            TJC.exprInitValue(interp, tmp45, tmp44);
            ExprValue tmp46 = evs1;
            tmp46.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp45, tmp46);
            // End Binary operator: ==
            boolean tmp47 = ( tmp45.getIntValue() != 0 );
            if ( tmp47 ) {
                { // Invoke: set ... 1
                    setVarArray(interp, "_compileproc", "options,skip_constant_increment", const5, compiledLocals, 1);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: set ... [...]
            TclObject tmp48;
            { // Invoke: module_option_value cache-variables $proc_name
                TclObject[] objv49 = TJC.grabObjv(interp, 3);
                TclObject tmp50;
                try {
                    // Arg 0 constant: module_option_value
                    objv49[0] = const0;
                    // Arg 1 constant: cache-variables
                    objv49[1] = const8;
                    // Arg 2 variable: $proc_name
                    tmp50 = getVarScalar(interp, "proc_name", compiledLocals, 0);
                    tmp50.preserve();
                    objv49[2] = tmp50;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv49, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp50 = objv49[2];
                    if ( tmp50 != null ) {
                        tmp50.release();
                    }
                    TJC.releaseObjv(interp, objv49, 3);
                }
            } // End Invoke: module_option_value
            tmp48 = interp.getResult();
            setVarScalar(interp, "cache_variables_option", tmp48, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: $cache_variables_option == ""
            TclObject tmp51 = getVarScalar(interp, "cache_variables_option", compiledLocals, 6);
            ExprValue tmp52 = evs0;
            TJC.exprEqualsEmptyString(tmp52, tmp51, false);
            // End Binary operator: ==
            boolean tmp53 = ( tmp52.getIntValue() != 0 );
            if ( tmp53 ) {
                { // Invoke: set ... [...]
                    TclObject tmp54;
                    { // Invoke: module_option_value cache-variables
                        TclObject[] objv55 = TJC.grabObjv(interp, 2);
                        try {
                            // Arg 0 constant: module_option_value
                            objv55[0] = const0;
                            // Arg 1 constant: cache-variables
                            objv55[1] = const8;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv55, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv55, 2);
                        }
                    } // End Invoke: module_option_value
                    tmp54 = interp.getResult();
                    setVarScalar(interp, "cache_variables_option", tmp54, compiledLocals, 6);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            TclObject tmp56 = getVarScalar(interp, "cache_variables_option", compiledLocals, 6);
            boolean tmp57 = TJC.getBoolean(interp, tmp56);
            if ( tmp57 ) {
                { // Invoke: set ... 1
                    setVarArray(interp, "_compileproc", "options,cache_variables", const5, compiledLocals, 1);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: set ... [...]
            TclObject tmp58;
            { // Invoke: module_option_value inline-commands $proc_name
                TclObject[] objv59 = TJC.grabObjv(interp, 3);
                TclObject tmp60;
                try {
                    // Arg 0 constant: module_option_value
                    objv59[0] = const0;
                    // Arg 1 constant: inline-commands
                    objv59[1] = const9;
                    // Arg 2 variable: $proc_name
                    tmp60 = getVarScalar(interp, "proc_name", compiledLocals, 0);
                    tmp60.preserve();
                    objv59[2] = tmp60;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv59, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp60 = objv59[2];
                    if ( tmp60 != null ) {
                        tmp60.release();
                    }
                    TJC.releaseObjv(interp, objv59, 3);
                }
            } // End Invoke: module_option_value
            tmp58 = interp.getResult();
            setVarScalar(interp, "inline_commands_option", tmp58, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: $inline_commands_option == ""
            TclObject tmp61 = getVarScalar(interp, "inline_commands_option", compiledLocals, 7);
            ExprValue tmp62 = evs0;
            TJC.exprEqualsEmptyString(tmp62, tmp61, false);
            // End Binary operator: ==
            boolean tmp63 = ( tmp62.getIntValue() != 0 );
            if ( tmp63 ) {
                { // Invoke: set ... [...]
                    TclObject tmp64;
                    { // Invoke: module_option_value inline-commands
                        TclObject[] objv65 = TJC.grabObjv(interp, 2);
                        try {
                            // Arg 0 constant: module_option_value
                            objv65[0] = const0;
                            // Arg 1 constant: inline-commands
                            objv65[1] = const9;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv65, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv65, 2);
                        }
                    } // End Invoke: module_option_value
                    tmp64 = interp.getResult();
                    setVarScalar(interp, "inline_commands_option", tmp64, compiledLocals, 7);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            TclObject tmp66 = getVarScalar(interp, "inline_commands_option", compiledLocals, 7);
            boolean tmp67 = TJC.getBoolean(interp, tmp66);
            if ( tmp67 ) {
                { // Invoke: set ... 1
                    setVarArray(interp, "_compileproc", "options,inline_commands", const5, compiledLocals, 1);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: set omit_results_option [...]
            TclObject tmp68;
            { // Invoke: module_option_value omit-results $proc_name
                TclObject[] objv69 = TJC.grabObjv(interp, 3);
                TclObject tmp70;
                try {
                    // Arg 0 constant: module_option_value
                    objv69[0] = const0;
                    // Arg 1 constant: omit-results
                    objv69[1] = const10;
                    // Arg 2 variable: $proc_name
                    tmp70 = getVarScalar(interp, "proc_name", compiledLocals, 0);
                    tmp70.preserve();
                    objv69[2] = tmp70;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv69, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp70 = objv69[2];
                    if ( tmp70 != null ) {
                        tmp70.release();
                    }
                    TJC.releaseObjv(interp, objv69, 3);
                }
            } // End Invoke: module_option_value
            tmp68 = interp.getResult();
            setVarScalar(interp, "omit_results_option", tmp68, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: $omit_results_option == ""
            TclObject tmp71 = getVarScalar(interp, "omit_results_option", compiledLocals, 8);
            ExprValue tmp72 = evs0;
            TJC.exprEqualsEmptyString(tmp72, tmp71, false);
            // End Binary operator: ==
            boolean tmp73 = ( tmp72.getIntValue() != 0 );
            if ( tmp73 ) {
                { // Invoke: set omit_results_option [...]
                    TclObject tmp74;
                    { // Invoke: module_option_value omit-results
                        TclObject[] objv75 = TJC.grabObjv(interp, 2);
                        try {
                            // Arg 0 constant: module_option_value
                            objv75[0] = const0;
                            // Arg 1 constant: omit-results
                            objv75[1] = const10;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv75, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv75, 2);
                        }
                    } // End Invoke: module_option_value
                    tmp74 = interp.getResult();
                    setVarScalar(interp, "omit_results_option", tmp74, compiledLocals, 8);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            TclObject tmp76 = getVarScalar(interp, "omit_results_option", compiledLocals, 8);
            boolean tmp77 = TJC.getBoolean(interp, tmp76);
            if ( tmp77 ) {
                { // Invoke: set ... 1
                    setVarArray(interp, "_compileproc", "options,omit_results", const5, compiledLocals, 1);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: set inline_expr_option [...]
            TclObject tmp78;
            { // Invoke: module_option_value inline-expr $proc_name
                TclObject[] objv79 = TJC.grabObjv(interp, 3);
                TclObject tmp80;
                try {
                    // Arg 0 constant: module_option_value
                    objv79[0] = const0;
                    // Arg 1 constant: inline-expr
                    objv79[1] = const11;
                    // Arg 2 variable: $proc_name
                    tmp80 = getVarScalar(interp, "proc_name", compiledLocals, 0);
                    tmp80.preserve();
                    objv79[2] = tmp80;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv79, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp80 = objv79[2];
                    if ( tmp80 != null ) {
                        tmp80.release();
                    }
                    TJC.releaseObjv(interp, objv79, 3);
                }
            } // End Invoke: module_option_value
            tmp78 = interp.getResult();
            setVarScalar(interp, "inline_expr_option", tmp78, compiledLocals, 9);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: $inline_expr_option == ""
            TclObject tmp81 = getVarScalar(interp, "inline_expr_option", compiledLocals, 9);
            ExprValue tmp82 = evs0;
            TJC.exprEqualsEmptyString(tmp82, tmp81, false);
            // End Binary operator: ==
            boolean tmp83 = ( tmp82.getIntValue() != 0 );
            if ( tmp83 ) {
                { // Invoke: set inline_expr_option [...]
                    TclObject tmp84;
                    { // Invoke: module_option_value inline-expr
                        TclObject[] objv85 = TJC.grabObjv(interp, 2);
                        try {
                            // Arg 0 constant: module_option_value
                            objv85[0] = const0;
                            // Arg 1 constant: inline-expr
                            objv85[1] = const11;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv85, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv85, 2);
                        }
                    } // End Invoke: module_option_value
                    tmp84 = interp.getResult();
                    setVarScalar(interp, "inline_expr_option", tmp84, compiledLocals, 9);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            TclObject tmp86 = getVarScalar(interp, "inline_expr_option", compiledLocals, 9);
            boolean tmp87 = TJC.getBoolean(interp, tmp86);
            if ( tmp87 ) {
                { // Invoke: set ... 1
                    setVarArray(interp, "_compileproc", "options,expr_inline_operators", const5, compiledLocals, 1);
                } // End Invoke: set
                { // Invoke: set ... [...]
                    TclObject tmp88;
                    { // Invoke: module_option_value ... $proc_name
                        TclObject[] objv89 = TJC.grabObjv(interp, 3);
                        TclObject tmp90;
                        try {
                            // Arg 0 constant: module_option_value
                            objv89[0] = const0;
                            // Arg 1 constant: ...
                            objv89[1] = const12;
                            // Arg 2 variable: $proc_name
                            tmp90 = getVarScalar(interp, "proc_name", compiledLocals, 0);
                            tmp90.preserve();
                            objv89[2] = tmp90;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv89, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            tmp90 = objv89[2];
                            if ( tmp90 != null ) {
                                tmp90.release();
                            }
                            TJC.releaseObjv(interp, objv89, 3);
                        }
                    } // End Invoke: module_option_value
                    tmp88 = interp.getResult();
                    setVarScalar(interp, "inline_expr_value_stack_option", tmp88, compiledLocals, 10);
                } // End Invoke: set
                { // Invoke: if ... ...
                    // Binary operator: $inline_expr_value_stack_option == ""
                    TclObject tmp91 = getVarScalar(interp, "inline_expr_value_stack_option", compiledLocals, 10);
                    ExprValue tmp92 = evs0;
                    TJC.exprEqualsEmptyString(tmp92, tmp91, false);
                    // End Binary operator: ==
                    boolean tmp93 = ( tmp92.getIntValue() != 0 );
                    if ( tmp93 ) {
                        { // Invoke: set ... [...]
                            TclObject tmp94;
                            { // Invoke: module_option_value ...
                                TclObject[] objv95 = TJC.grabObjv(interp, 2);
                                try {
                                    // Arg 0 constant: module_option_value
                                    objv95[0] = const0;
                                    // Arg 1 constant: ...
                                    objv95[1] = const12;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                        ? cmdcache1.cmd : null), objv95, 0);
                                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                        updateCmdCache(interp, 1);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv95, 2);
                                }
                            } // End Invoke: module_option_value
                            tmp94 = interp.getResult();
                            setVarScalar(interp, "inline_expr_value_stack_option", tmp94, compiledLocals, 10);
                        } // End Invoke: set
                    }
                } // End Invoke: if
                { // Invoke: set ... $...
                    TclObject tmp96;
                    tmp96 = getVarScalar(interp, "inline_expr_value_stack_option", compiledLocals, 10);
                    setVarArray(interp, "_compileproc", "options,expr_value_stack", tmp96, compiledLocals, 1);
                } // End Invoke: set
                { // Invoke: set ... [...]
                    TclObject tmp97;
                    { // Invoke: module_option_value ... $proc_name
                        TclObject[] objv98 = TJC.grabObjv(interp, 3);
                        TclObject tmp99;
                        try {
                            // Arg 0 constant: module_option_value
                            objv98[0] = const0;
                            // Arg 1 constant: ...
                            objv98[1] = const13;
                            // Arg 2 variable: $proc_name
                            tmp99 = getVarScalar(interp, "proc_name", compiledLocals, 0);
                            tmp99.preserve();
                            objv98[2] = tmp99;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv98, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            tmp99 = objv98[2];
                            if ( tmp99 != null ) {
                                tmp99.release();
                            }
                            TJC.releaseObjv(interp, objv98, 3);
                        }
                    } // End Invoke: module_option_value
                    tmp97 = interp.getResult();
                    setVarScalar(interp, "inline_expr_value_stack_null_option", tmp97, compiledLocals, 11);
                } // End Invoke: set
                { // Invoke: if ... ...
                    // Binary operator: $inline_expr_value_stack_null_option == ""
                    TclObject tmp100 = getVarScalar(interp, "inline_expr_value_stack_null_option", compiledLocals, 11);
                    ExprValue tmp101 = evs0;
                    TJC.exprEqualsEmptyString(tmp101, tmp100, false);
                    // End Binary operator: ==
                    boolean tmp102 = ( tmp101.getIntValue() != 0 );
                    if ( tmp102 ) {
                        { // Invoke: set ... [...]
                            TclObject tmp103;
                            { // Invoke: module_option_value ...
                                TclObject[] objv104 = TJC.grabObjv(interp, 2);
                                try {
                                    // Arg 0 constant: module_option_value
                                    objv104[0] = const0;
                                    // Arg 1 constant: ...
                                    objv104[1] = const13;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                        ? cmdcache1.cmd : null), objv104, 0);
                                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                        updateCmdCache(interp, 1);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv104, 2);
                                }
                            } // End Invoke: module_option_value
                            tmp103 = interp.getResult();
                            setVarScalar(interp, "inline_expr_value_stack_null_option", tmp103, compiledLocals, 11);
                        } // End Invoke: set
                    }
                } // End Invoke: if
                { // Invoke: set ... $...
                    TclObject tmp105;
                    tmp105 = getVarScalar(interp, "inline_expr_value_stack_null_option", compiledLocals, 11);
                    setVarArray(interp, "_compileproc", "options,expr_value_stack_null", tmp105, compiledLocals, 1);
                } // End Invoke: set
                { // Invoke: set ... 1
                    TclObject tmp106;
                    tmp106 = setVarArray(interp, "_compileproc", "options,expr_inline_set_result", const5, compiledLocals, 1);
                    interp.setResult(tmp106);
                } // End Invoke: set
            } else {
                interp.resetResult();
            }
        } // End Invoke: if
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_query_module_flags");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("module_option_value");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("inline-containers");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("all");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("error");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("inline-controls");
        const4.preserve(); const4.preserve();
        const5 = TclInteger.newInstance(1);
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("cache-commands");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("constant-increment");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("cache-variables");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("inline-commands");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("omit-results");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("inline-expr");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("inline-expr-value-stack");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("inline-expr-value-stack-null");
        const13.preserve(); const13.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "module_option_value";
                break;
            }
            case 2: {
                cmdName = "error";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "proc_name",
        "_compileproc",
        "inline_containers_option",
        "inline_controls_option",
        "cache_commands_option",
        "constant_increment_option",
        "cache_variables_option",
        "inline_commands_option",
        "omit_results_option",
        "inline_expr_option",
        "inline_expr_value_stack_option",
        "inline_expr_value_stack_null_option"
    };
} // end class CompileprocQueryModuleFlagsCmd

