// TJC implementation of procedure compileproc_scan_variable
package tjc;
import tcl.lang.*;

public class CompileprocScanVariableCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 8, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 4) {
            throw new TclNumArgsException(interp, 1, objv, "key script vstree");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        setVarScalar(interp, "script", objv[2], compiledLocals, 1);
        setVarScalar(interp, "vstree", objv[3], compiledLocals, 2);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 3);
        } // End Invoke: global
        { // Invoke: if ... ... else ...
            { // Invoke: ... $vstree
                TclObject[] objv0 = TJC.grabObjv(interp, 2);
                TclObject tmp1;
                try {
                    // Arg 0 constant: ...
                    objv0[0] = const0;
                    // Arg 1 variable: $vstree
                    tmp1 = getVarScalar(interp, "vstree", compiledLocals, 2);
                    tmp1.preserve();
                    objv0[1] = tmp1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv0, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp1 = objv0[1];
                    if ( tmp1 != null ) {
                        tmp1.release();
                    }
                    TJC.releaseObjv(interp, objv0, 2);
                }
            } // End Invoke: ...
            TclObject tmp2 = interp.getResult();
            ExprValue tmp3 = evs0;
            TJC.exprInitValue(interp, tmp3, tmp2);
            boolean tmp4 = tmp3.getBooleanValue(interp);
            if ( tmp4 ) {
                { // Invoke: set vname [...]
                    TclObject tmp5;
                    { // Invoke: ... $script $vstree
                        TclObject[] objv6 = TJC.grabObjv(interp, 3);
                        TclObject tmp7;
                        try {
                            // Arg 0 constant: ...
                            objv6[0] = const1;
                            // Arg 1 variable: $script
                            tmp7 = getVarScalar(interp, "script", compiledLocals, 1);
                            tmp7.preserve();
                            objv6[1] = tmp7;
                            // Arg 2 variable: $vstree
                            tmp7 = getVarScalar(interp, "vstree", compiledLocals, 2);
                            tmp7.preserve();
                            objv6[2] = tmp7;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv6, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp7 = objv6[1];
                            if ( tmp7 != null ) {
                                tmp7.release();
                            }
                            tmp7 = objv6[2];
                            if ( tmp7 != null ) {
                                tmp7.release();
                            }
                            TJC.releaseObjv(interp, objv6, 3);
                        }
                    } // End Invoke: ...
                    tmp5 = interp.getResult();
                    setVarScalar(interp, "vname", tmp5, compiledLocals, 4);
                } // End Invoke: set
                { // Invoke: set vinfo [...]
                    TclObject tmp8;
                    { // Invoke: list scalar $vname
                        TclObject tmp9 = TclList.newInstance();
                        TclObject tmp10;
                        try {
                            TclList.append(interp, tmp9, const2);
                            tmp10 = getVarScalar(interp, "vname", compiledLocals, 4);
                            TclList.append(interp, tmp9, tmp10);
                        } catch (TclException ex) {
                            tmp9.release();
                            throw ex;
                        }
                        interp.setResult(tmp9);
                    } // End Invoke: list
                    tmp8 = interp.getResult();
                    setVarScalar(interp, "vinfo", tmp8, compiledLocals, 5);
                } // End Invoke: set
            } else {
                { // Invoke: set saved_var_scan_key $...
                    TclObject tmp11;
                    tmp11 = getVarArray(interp, "_compileproc", "var_scan_key", compiledLocals, 3);
                    setVarScalar(interp, "saved_var_scan_key", tmp11, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: set ... $...
                    TclObject tmp12;
                    tmp12 = getVarArray(interp, "_compileproc", "var_scan_results", compiledLocals, 3);
                    setVarScalar(interp, "saved_var_scan_results", tmp12, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: set ... $key
                    TclObject tmp13;
                    tmp13 = getVarScalar(interp, "key", compiledLocals, 0);
                    setVarArray(interp, "_compileproc", "var_scan_key", tmp13, compiledLocals, 3);
                } // End Invoke: set
                { // Invoke: set ... {}
                    setVarArray(interp, "_compileproc", "var_scan_results", const3, compiledLocals, 3);
                } // End Invoke: set
                { // Invoke: ... $script $vstree ...
                    TclObject[] objv14 = TJC.grabObjv(interp, 4);
                    TclObject tmp15;
                    try {
                        // Arg 0 constant: ...
                        objv14[0] = const4;
                        // Arg 1 variable: $script
                        tmp15 = getVarScalar(interp, "script", compiledLocals, 1);
                        tmp15.preserve();
                        objv14[1] = tmp15;
                        // Arg 2 variable: $vstree
                        tmp15 = getVarScalar(interp, "vstree", compiledLocals, 2);
                        tmp15.preserve();
                        objv14[2] = tmp15;
                        // Arg 3 constant: ...
                        objv14[3] = const5;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv14, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp15 = objv14[1];
                        if ( tmp15 != null ) {
                            tmp15.release();
                        }
                        tmp15 = objv14[2];
                        if ( tmp15 != null ) {
                            tmp15.release();
                        }
                        TJC.releaseObjv(interp, objv14, 4);
                    }
                } // End Invoke: ...
                { // Invoke: set vinfo $...
                    TclObject tmp16;
                    tmp16 = getVarArray(interp, "_compileproc", "var_scan_results", compiledLocals, 3);
                    setVarScalar(interp, "vinfo", tmp16, compiledLocals, 5);
                } // End Invoke: set
                { // Invoke: set ... $saved_var_scan_key
                    TclObject tmp17;
                    tmp17 = getVarScalar(interp, "saved_var_scan_key", compiledLocals, 6);
                    setVarArray(interp, "_compileproc", "var_scan_key", tmp17, compiledLocals, 3);
                } // End Invoke: set
                { // Invoke: set ... $...
                    TclObject tmp18;
                    tmp18 = getVarScalar(interp, "saved_var_scan_results", compiledLocals, 7);
                    setVarArray(interp, "_compileproc", "var_scan_results", tmp18, compiledLocals, 3);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: return $vinfo
            TclObject tmp19 = getVarScalar(interp, "vinfo", compiledLocals, 5);
            interp.resetResult();
            interp.setResult(tmp19);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_scan_variable");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("parse_is_scalar_variable");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("parse_get_scalar_variable");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("scalar");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("parse_variable_iterate");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("_compileproc_scan_variable_iterator");
        const5.preserve(); const5.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "parse_is_scalar_variable";
                break;
            }
            case 2: {
                cmdName = "parse_get_scalar_variable";
                break;
            }
            case 3: {
                cmdName = "parse_variable_iterate";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "script",
        "vstree",
        "_compileproc",
        "vname",
        "vinfo",
        "saved_var_scan_key",
        "saved_var_scan_results"
    };
} // end class CompileprocScanVariableCmd

