// TJC implementation of procedure compileproc_tjcextension
package tjc;
import tcl.lang.*;

public class CompileprocTjcextensionCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 10, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        ExprValue evs2 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 4) {
            throw new TclNumArgsException(interp, 1, objv, "package tcl_files init_file");
        }
        setVarScalar(interp, "package", objv[1], compiledLocals, 0);
        setVarScalar(interp, "tcl_files", objv[2], compiledLocals, 1);
        setVarScalar(interp, "init_file", objv[3], compiledLocals, 2);
        { // Invoke: if ... ...
            // Binary operator: [...] == 0
            { // Invoke: llength $tcl_files
                TclObject tmp0 = getVarScalar(interp, "tcl_files", compiledLocals, 1);
                int tmp1 = TclList.getLength(interp, tmp0);
                interp.setResult(tmp1);
            } // End Invoke: llength
            TclObject tmp2 = interp.getResult();
            ExprValue tmp3 = evs0;
            TJC.exprInitValue(interp, tmp3, tmp2);
            ExprValue tmp4 = evs1;
            tmp4.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp3, tmp4);
            // End Binary operator: ==
            boolean tmp5 = ( tmp3.getIntValue() != 0 );
            if ( tmp5 ) {
                { // Invoke: error ...
                    TclObject[] objv6 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv6[0] = const0;
                        // Arg 1 constant: ...
                        objv6[1] = const1;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv6, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv6, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: if {$init_file == ""} ...
            // Binary operator: $init_file == ""
            TclObject tmp7 = getVarScalar(interp, "init_file", compiledLocals, 2);
            ExprValue tmp8 = evs0;
            TJC.exprEqualsEmptyString(tmp8, tmp7, false);
            // End Binary operator: ==
            boolean tmp9 = ( tmp8.getIntValue() != 0 );
            if ( tmp9 ) {
                { // Invoke: error ...
                    TclObject[] objv10 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv10[0] = const0;
                        // Arg 1 constant: ...
                        objv10[1] = const2;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv10, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv10, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const3, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: append buffer [...]
            TclObject[] objv11 = TJC.grabObjv(interp, 1);
            TclObject tmp12;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_package_name $package
                    TclObject[] objv13 = TJC.grabObjv(interp, 2);
                    TclObject tmp14;
                    try {
                        // Arg 0 constant: emitter_package_name
                        objv13[0] = const4;
                        // Arg 1 variable: $package
                        tmp14 = getVarScalar(interp, "package", compiledLocals, 0);
                        tmp14.preserve();
                        objv13[1] = tmp14;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv13, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp14 = objv13[1];
                        if ( tmp14 != null ) {
                            tmp14.release();
                        }
                        TJC.releaseObjv(interp, objv13, 2);
                    }
                } // End Invoke: emitter_package_name
                tmp12 = interp.getResult();
                tmp12.preserve();
                objv11[0] = tmp12;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv11, compiledLocals, 3);
            } finally {
                TJC.releaseObjvElems(interp, objv11, 1);
            }
        } // End Invoke: append
        { // Invoke: append buffer [...]
            TclObject[] objv15 = TJC.grabObjv(interp, 1);
            TclObject tmp16;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_import_tcl
                    TclObject[] objv17 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_import_tcl
                        objv17[0] = const5;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv17, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv17, 1);
                    }
                } // End Invoke: emitter_import_tcl
                tmp16 = interp.getResult();
                tmp16.preserve();
                objv15[0] = tmp16;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv15, compiledLocals, 3);
            } finally {
                TJC.releaseObjvElems(interp, objv15, 1);
            }
        } // End Invoke: append
        { // Invoke: if ... ... else ...
            // Binary operator: $package == "default"
            TclObject tmp18 = getVarScalar(interp, "package", compiledLocals, 0);
            boolean tmp19 = tmp18.toString().equals("default");
            ExprValue tmp20 = evs0;
            tmp20.setIntValue(tmp19);
            // End Binary operator: ==
            boolean tmp21 = ( tmp20.getIntValue() != 0 );
            if ( tmp21 ) {
                { // Invoke: set prefix "/library/"
                    setVarScalar(interp, "prefix", const6, compiledLocals, 4);
                } // End Invoke: set
            } else {
                { // Invoke: set prefix "/"
                    setVarScalar(interp, "prefix", const7, compiledLocals, 4);
                } // End Invoke: set
                { // Invoke: foreach elem [...] ...
                    TclObject tmp22 = null;
                    try {
                        { // Invoke: split $package .
                            TclObject[] objv23 = TJC.grabObjv(interp, 3);
                            TclObject tmp24;
                            try {
                                // Arg 0 constant: split
                                objv23[0] = const8;
                                // Arg 1 variable: $package
                                tmp24 = getVarScalar(interp, "package", compiledLocals, 0);
                                tmp24.preserve();
                                objv23[1] = tmp24;
                                // Arg 2 constant: .
                                objv23[2] = const9;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv23, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                tmp24 = objv23[1];
                                if ( tmp24 != null ) {
                                    tmp24.release();
                                }
                                TJC.releaseObjv(interp, objv23, 3);
                            }
                        } // End Invoke: split
                        tmp22 = interp.getResult();
                        tmp22.preserve();
                        final int tmp22_length = TclList.getLength(interp, tmp22);

                        for ( int index25 = 0 ; index25 < tmp22_length ; index25++ ) {
                            TclObject tmp26 = TclList.index(interp, tmp22, index25);
                            try {
                                setVarScalar(interp, "elem", tmp26, compiledLocals, 5);
                            } catch (TclException ex) {
                                TJC.foreachVarErr(interp, "elem");
                            }

                            try {
                            if ( false ) { throw (TclException) null; }
                            { // Invoke: append prefix $elem "/"
                                TclObject[] objv27 = TJC.grabObjv(interp, 2);
                                TclObject tmp28;
                                try {
                                    // Arg 2 variable: $elem
                                    tmp28 = getVarScalar(interp, "elem", compiledLocals, 5);
                                    tmp28.preserve();
                                    objv27[0] = tmp28;
                                    // Arg 3 constant: "/"
                                    objv27[1] = const7;
                                    interp.resetResult();
                                    appendVarScalar(interp, "prefix", objv27, compiledLocals, 4);
                                } finally {
                                    tmp28 = objv27[0];
                                    if ( tmp28 != null ) {
                                        tmp28.release();
                                    }
                                    TJC.releaseObjv(interp, objv27, 2);
                                }
                            } // End Invoke: append
                            } catch (TclException ex) {
                                int type = ex.getCompletionCode();
                                if (type == TCL.BREAK) {
                                    break;
                                } else if (type == TCL.CONTINUE) {
                                    continue;
                                } else {
                                    throw ex;
                                }
                            }
                        }
                    } finally {
                        if ( tmp22 != null ) {
                            tmp22.release();
                        }
                    }
                } // End Invoke: foreach
                { // Invoke: append prefix "library/"
                    TclObject[] objv29 = TJC.grabObjv(interp, 1);
                    TclObject tmp30;
                    try {
                        // Arg 2 constant: "library/"
                        objv29[0] = const10;
                        interp.resetResult();
                        appendVarScalar(interp, "prefix", objv29, compiledLocals, 4);
                    } finally {
                        TJC.releaseObjv(interp, objv29, 1);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: append buffer "..."
            TclObject[] objv31 = TJC.grabObjv(interp, 1);
            TclObject tmp32;
            try {
                // Arg 2 word: "..."
                StringBuffer sbtmp33 = new StringBuffer(64);
                sbtmp33.append("\npublic class TJCExtension extends Extension ");
                sbtmp33.append("{");
                sbtmp33.append("\n    public void init(Interp interp)\n            throws TclException\n    ");
                sbtmp33.append("{");
                sbtmp33.append("\n        String init_file = ");
                sbtmp33.append("\"");
                tmp32 = getVarScalar(interp, "init_file", compiledLocals, 2);
                sbtmp33.append(tmp32.toString());
                sbtmp33.append("\"");
                sbtmp33.append(";\n        String");
                sbtmp33.append("[");
                sbtmp33.append("]");
                sbtmp33.append(" files = ");
                sbtmp33.append("{");
                sbtmp33.append("\n");
                tmp32 = TclString.newInstance(sbtmp33);
                tmp32.preserve();
                objv31[0] = tmp32;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv31, compiledLocals, 3);
            } finally {
                TJC.releaseObjvElems(interp, objv31, 1);
            }
        } // End Invoke: append
        { // Invoke: for ... {$i < $len} {incr i} ...
            { // Invoke: set len [...]
                TclObject tmp34;
                { // Invoke: llength $tcl_files
                    TclObject tmp35 = getVarScalar(interp, "tcl_files", compiledLocals, 1);
                    int tmp36 = TclList.getLength(interp, tmp35);
                    interp.setResult(tmp36);
                } // End Invoke: llength
                tmp34 = interp.getResult();
                setVarScalar(interp, "len", tmp34, compiledLocals, 6);
            } // End Invoke: set
            { // Invoke: set i 0
                setVarScalar(interp, "i", const11, compiledLocals, 7);
            } // End Invoke: set
            for ( boolean skip42 = true ; true ; ) {
                if ( skip42 ) {
                    skip42 = false;
                } else {
                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: incr i
                        interp.resetResult();
                        incrVarScalar(interp, "i", 1, compiledLocals, 7);
                    } // End Invoke: incr
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else {
                            throw ex;
                        }
                    }
                }

                // Binary operator: $i < $len
                TclObject tmp37 = getVarScalar(interp, "i", compiledLocals, 7);
                ExprValue tmp38 = evs0;
                TJC.exprInitValue(interp, tmp38, tmp37);
                TclObject tmp39 = getVarScalar(interp, "len", compiledLocals, 6);
                ExprValue tmp40 = evs1;
                TJC.exprInitValue(interp, tmp40, tmp39);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp38, tmp40);
                // End Binary operator: <
                boolean tmp41 = ( tmp38.getIntValue() != 0 );
                if ( ! tmp41 ) { break; }

                try {
                if ( false ) { throw (TclException) null; }
                { // Invoke: set fname [...]
                    TclObject tmp43;
                    { // Invoke: lindex $tcl_files $i
                        TclObject tmp44 = null;
                        TclObject tmp45;
                        try {
                            tmp44 = getVarScalar(interp, "tcl_files", compiledLocals, 1);
                            tmp44.preserve();
                            tmp45 = getVarScalar(interp, "i", compiledLocals, 7);
                            TJC.lindexNonconst(interp, tmp44, tmp45);
                        } finally {
                            if ( tmp44 != null ) {
                                tmp44.release();
                            }
                        }
                    } // End Invoke: lindex
                    tmp43 = interp.getResult();
                    setVarScalar(interp, "fname", tmp43, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: append buffer "            " ... $fname ...
                    TclObject[] objv46 = TJC.grabObjv(interp, 4);
                    TclObject tmp47;
                    try {
                        // Arg 2 constant: "            "
                        objv46[0] = const12;
                        // Arg 3 constant: ...
                        objv46[1] = const13;
                        // Arg 4 variable: $fname
                        tmp47 = getVarScalar(interp, "fname", compiledLocals, 8);
                        tmp47.preserve();
                        objv46[2] = tmp47;
                        // Arg 5 constant: ...
                        objv46[3] = const13;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv46, compiledLocals, 3);
                    } finally {
                        tmp47 = objv46[2];
                        if ( tmp47 != null ) {
                            tmp47.release();
                        }
                        TJC.releaseObjv(interp, objv46, 4);
                    }
                } // End Invoke: append
                { // Invoke: if {$i == ($len - 1)} ... else ...
                    // Binary operator: $i == ()
                    TclObject tmp48 = getVarScalar(interp, "i", compiledLocals, 7);
                    ExprValue tmp49 = evs0;
                    TJC.exprInitValue(interp, tmp49, tmp48);
                    // Binary operator: $len - 1
                    TclObject tmp50 = getVarScalar(interp, "len", compiledLocals, 6);
                    ExprValue tmp51 = evs1;
                    TJC.exprInitValue(interp, tmp51, tmp50);
                    ExprValue tmp52 = evs2;
                    tmp52.setIntValue(1);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp51, tmp52);
                    // End Binary operator: -
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp49, tmp51);
                    // End Binary operator: ==
                    boolean tmp53 = ( tmp49.getIntValue() != 0 );
                    if ( tmp53 ) {
                    } else {
                        { // Invoke: append buffer ","
                            TclObject[] objv54 = TJC.grabObjv(interp, 1);
                            TclObject tmp55;
                            try {
                                // Arg 2 constant: ","
                                objv54[0] = const14;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv54, compiledLocals, 3);
                            } finally {
                                TJC.releaseObjv(interp, objv54, 1);
                            }
                        } // End Invoke: append
                    }
                } // End Invoke: if
                { // Invoke: append buffer ...
                    TclObject[] objv56 = TJC.grabObjv(interp, 1);
                    TclObject tmp57;
                    try {
                        // Arg 2 constant: ...
                        objv56[0] = const15;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv56, compiledLocals, 3);
                    } finally {
                        TJC.releaseObjv(interp, objv56, 1);
                    }
                } // End Invoke: append
                } catch (TclException ex) {
                    int type = ex.getCompletionCode();
                    if (type == TCL.BREAK) {
                        break;
                    } else if (type == TCL.CONTINUE) {
                        continue;
                    } else {
                        throw ex;
                    }
                }
            }
        } // End Invoke: for
        { // Invoke: append buffer "..."
            TclObject[] objv58 = TJC.grabObjv(interp, 1);
            TclObject tmp59;
            try {
                // Arg 2 word: "..."
                StringBuffer sbtmp60 = new StringBuffer(64);
                sbtmp60.append("        ");
                sbtmp60.append("}");
                sbtmp60.append(";");
                sbtmp60.append("\n        String prefix = ");
                sbtmp60.append("\"");
                tmp59 = getVarScalar(interp, "prefix", compiledLocals, 4);
                sbtmp60.append(tmp59.toString());
                sbtmp60.append("\"");
                sbtmp60.append(";");
                sbtmp60.append("\n\n        TJC.sourceInitFile(interp, init_file, files, prefix)");
                sbtmp60.append(";");
                sbtmp60.append("\n    ");
                sbtmp60.append("}");
                sbtmp60.append("\n");
                sbtmp60.append("}");
                sbtmp60.append("\n");
                tmp59 = TclString.newInstance(sbtmp60);
                tmp59.preserve();
                objv58[0] = tmp59;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv58, compiledLocals, 3);
            } finally {
                TJC.releaseObjvElems(interp, objv58, 1);
            }
        } // End Invoke: append
        { // Invoke: if ... ... else ...
            // Binary operator: $package == "default"
            TclObject tmp61 = getVarScalar(interp, "package", compiledLocals, 0);
            boolean tmp62 = tmp61.toString().equals("default");
            ExprValue tmp63 = evs0;
            tmp63.setIntValue(tmp62);
            // End Binary operator: ==
            boolean tmp64 = ( tmp63.getIntValue() != 0 );
            if ( tmp64 ) {
                { // Invoke: set full_classname "TJCExtension"
                    setVarScalar(interp, "full_classname", const16, compiledLocals, 9);
                } // End Invoke: set
            } else {
                { // Invoke: set full_classname "..."
                    TclObject tmp65;
                    StringBuffer sbtmp66 = new StringBuffer(64);
                    tmp65 = getVarScalar(interp, "package", compiledLocals, 0);
                    sbtmp66.append(tmp65.toString());
                    sbtmp66.append(".TJCExtension");
                    tmp65 = TclString.newInstance(sbtmp66);
                    setVarScalar(interp, "full_classname", tmp65, compiledLocals, 9);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: return [...]
            { // Invoke: list $full_classname $buffer
                TclObject tmp67 = TclList.newInstance();
                TclObject tmp68;
                try {
                    tmp68 = getVarScalar(interp, "full_classname", compiledLocals, 9);
                    TclList.append(interp, tmp67, tmp68);
                    tmp68 = getVarScalar(interp, "buffer", compiledLocals, 3);
                    TclList.append(interp, tmp67, tmp68);
                } catch (TclException ex) {
                    tmp67.release();
                    throw ex;
                }
                interp.setResult(tmp67);
            } // End Invoke: list
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_tjcextension");
        } finally {
            TJC.exprReleaseValue(interp, evs2);
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("error");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("empty tcl_files argument to compileproc_tjcextension");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("empty string init_file argument to compileproc_tjcextension");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("emitter_package_name");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("emitter_import_tcl");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("/library/");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("/");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("split");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance(".");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("library/");
        const10.preserve(); const10.preserve();
        const11 = TclInteger.newInstance(0);
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("            ");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("\"");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance(",");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("\n");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("TJCExtension");
        const16.preserve(); const16.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "error";
                break;
            }
            case 2: {
                cmdName = "emitter_package_name";
                break;
            }
            case 3: {
                cmdName = "emitter_import_tcl";
                break;
            }
            case 4: {
                cmdName = "split";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "package",
        "tcl_files",
        "init_file",
        "buffer",
        "prefix",
        "elem",
        "len",
        "i",
        "fname",
        "full_classname"
    };
} // end class CompileprocTjcextensionCmd

