// TJC implementation of procedure compileproc_tmpvar_reset
package tjc;
import tcl.lang.*;

public class CompileprocTmpvarResetCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 1, compiledLocalsNames);
        try {
        if (objv.length != 1) {
            throw new TclNumArgsException(interp, 1, objv, "");
        }
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 0);
        } // End Invoke: global
        { // Invoke: set ... 0
            TclObject tmp0;
            tmp0 = setVarArray(interp, "_compileproc", "local_counter", const0, compiledLocals, 0);
            interp.setResult(tmp0);
        } // End Invoke: set
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_tmpvar_reset");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(0);
        const0.preserve(); const0.preserve();
    }

    String[] compiledLocalsNames = {
        "_compileproc"
    };
} // end class CompileprocTmpvarResetCmd

