// TJC implementation of procedure descend_check_nested_commands
package tjc;
import tcl.lang.*;

public class DescendCheckNestedCommandsCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 9, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _descend
            TJC.makeGlobalLinkVar(interp, "_descend", "_descend", 1);
        } // End Invoke: global
        { // Invoke: set script [...]
            TclObject tmp0;
            { // Invoke: descend_get_data $key script
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: descend_get_data
                    objv1[0] = const0;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 constant: script
                    objv1[2] = const1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: descend_get_data
            tmp0 = interp.getResult();
            setVarScalar(interp, "script", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set tree [...]
            TclObject tmp3;
            { // Invoke: descend_get_data $key tree
                TclObject[] objv4 = TJC.grabObjv(interp, 3);
                TclObject tmp5;
                try {
                    // Arg 0 constant: descend_get_data
                    objv4[0] = const0;
                    // Arg 1 variable: $key
                    tmp5 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp5.preserve();
                    objv4[1] = tmp5;
                    // Arg 2 constant: tree
                    objv4[2] = const2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv4, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp5 = objv4[1];
                    if ( tmp5 != null ) {
                        tmp5.release();
                    }
                    TJC.releaseObjv(interp, objv4, 3);
                }
            } // End Invoke: descend_get_data
            tmp3 = interp.getResult();
            setVarScalar(interp, "tree", tmp3, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set num_args [...]
            TclObject tmp6;
            { // Invoke: llength $tree
                TclObject tmp7 = getVarScalar(interp, "tree", compiledLocals, 3);
                int tmp8 = TclList.getLength(interp, tmp7);
                interp.setResult(tmp8);
            } // End Invoke: llength
            tmp6 = interp.getResult();
            setVarScalar(interp, "num_args", tmp6, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set argument_keys [...]
            TclObject tmp9;
            { // Invoke: list
                TclObject tmp10 = TclList.newInstance();
                interp.setResult(tmp10);
            } // End Invoke: list
            tmp9 = interp.getResult();
            setVarScalar(interp, "argument_keys", tmp9, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: for {set i 0} {$i < $num_args} {incr i} ...
            { // Invoke: set i 0
                setVarScalar(interp, "i", const3, compiledLocals, 6);
            } // End Invoke: set
            for ( boolean skip16 = true ; true ; ) {
                if ( skip16 ) {
                    skip16 = false;
                } else {
                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: incr i
                        interp.resetResult();
                        incrVarScalar(interp, "i", 1, compiledLocals, 6);
                    } // End Invoke: incr
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else {
                            throw ex;
                        }
                    }
                }

                // Binary operator: $i < $num_args
                TclObject tmp11 = getVarScalar(interp, "i", compiledLocals, 6);
                ExprValue tmp12 = evs0;
                TJC.exprInitValue(interp, tmp12, tmp11);
                TclObject tmp13 = getVarScalar(interp, "num_args", compiledLocals, 4);
                ExprValue tmp14 = evs1;
                TJC.exprInitValue(interp, tmp14, tmp13);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp12, tmp14);
                // End Binary operator: <
                boolean tmp15 = ( tmp12.getIntValue() != 0 );
                if ( ! tmp15 ) { break; }

                try {
                if ( false ) { throw (TclException) null; }
                { // Invoke: ...
                    TclObject[] objv17 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: ...
                        objv17[0] = const4;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv17, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv17, 1);
                    }
                } // End Invoke: ...
                { // Invoke: set stree [...]
                    TclObject tmp18;
                    { // Invoke: lindex $tree $i
                        TclObject tmp19 = null;
                        TclObject tmp20;
                        try {
                            tmp19 = getVarScalar(interp, "tree", compiledLocals, 3);
                            tmp19.preserve();
                            tmp20 = getVarScalar(interp, "i", compiledLocals, 6);
                            TJC.lindexNonconst(interp, tmp19, tmp20);
                        } finally {
                            if ( tmp19 != null ) {
                                tmp19.release();
                            }
                        }
                    } // End Invoke: lindex
                    tmp18 = interp.getResult();
                    setVarScalar(interp, "stree", tmp18, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: if ... ... elseif ... ... elseif ... ...
                    { // Invoke: ... $stree
                        TclObject[] objv21 = TJC.grabObjv(interp, 2);
                        TclObject tmp22;
                        try {
                            // Arg 0 constant: ...
                            objv21[0] = const5;
                            // Arg 1 variable: $stree
                            tmp22 = getVarScalar(interp, "stree", compiledLocals, 7);
                            tmp22.preserve();
                            objv21[1] = tmp22;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv21, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp22 = objv21[1];
                            if ( tmp22 != null ) {
                                tmp22.release();
                            }
                            TJC.releaseObjv(interp, objv21, 2);
                        }
                    } // End Invoke: ...
                    TclObject tmp23 = interp.getResult();
                    ExprValue tmp24 = evs0;
                    TJC.exprInitValue(interp, tmp24, tmp23);
                    boolean tmp25 = tmp24.getBooleanValue(interp);
                    if ( tmp25 ) {
                        { // Invoke: ... $script $stree
                            TclObject[] objv26 = TJC.grabObjv(interp, 3);
                            TclObject tmp27;
                            try {
                                // Arg 0 constant: ...
                                objv26[0] = const6;
                                // Arg 1 variable: $script
                                tmp27 = getVarScalar(interp, "script", compiledLocals, 2);
                                tmp27.preserve();
                                objv26[1] = tmp27;
                                // Arg 2 variable: $stree
                                tmp27 = getVarScalar(interp, "stree", compiledLocals, 7);
                                tmp27.preserve();
                                objv26[2] = tmp27;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv26, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                tmp27 = objv26[1];
                                if ( tmp27 != null ) {
                                    tmp27.release();
                                }
                                tmp27 = objv26[2];
                                if ( tmp27 != null ) {
                                    tmp27.release();
                                }
                                TJC.releaseObjv(interp, objv26, 3);
                            }
                        } // End Invoke: ...
                    } else {
                        { // Invoke: ... $stree
                            TclObject[] objv28 = TJC.grabObjv(interp, 2);
                            TclObject tmp29;
                            try {
                                // Arg 0 constant: ...
                                objv28[0] = const7;
                                // Arg 1 variable: $stree
                                tmp29 = getVarScalar(interp, "stree", compiledLocals, 7);
                                tmp29.preserve();
                                objv28[1] = tmp29;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                    ? cmdcache5.cmd : null), objv28, 0);
                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                    updateCmdCache(interp, 5);
                                }
                            } finally {
                                tmp29 = objv28[1];
                                if ( tmp29 != null ) {
                                    tmp29.release();
                                }
                                TJC.releaseObjv(interp, objv28, 2);
                            }
                        } // End Invoke: ...
                        TclObject tmp30 = interp.getResult();
                        ExprValue tmp31 = evs0;
                        TJC.exprInitValue(interp, tmp31, tmp30);
                        boolean tmp32 = tmp31.getBooleanValue(interp);
                        if ( tmp32 ) {
                            { // Invoke: set var_subtree [...]
                                TclObject tmp33;
                                { // Invoke: lindex $stree 2 0
                                    TclObject[] objv34 = TJC.grabObjv(interp, 4);
                                    TclObject tmp35;
                                    try {
                                        // Arg 0 constant: lindex
                                        objv34[0] = const8;
                                        // Arg 1 variable: $stree
                                        tmp35 = getVarScalar(interp, "stree", compiledLocals, 7);
                                        tmp35.preserve();
                                        objv34[1] = tmp35;
                                        // Arg 2 constant: 2
                                        objv34[2] = const9;
                                        // Arg 3 constant: 0
                                        objv34[3] = const3;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                            ? cmdcache6.cmd : null), objv34, 0);
                                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                            updateCmdCache(interp, 6);
                                        }
                                    } finally {
                                        tmp35 = objv34[1];
                                        if ( tmp35 != null ) {
                                            tmp35.release();
                                        }
                                        TJC.releaseObjv(interp, objv34, 4);
                                    }
                                } // End Invoke: lindex
                                tmp33 = interp.getResult();
                                setVarScalar(interp, "var_subtree", tmp33, compiledLocals, 8);
                            } // End Invoke: set
                            { // Invoke: ... $script $var_subtree
                                TclObject[] objv36 = TJC.grabObjv(interp, 3);
                                TclObject tmp37;
                                try {
                                    // Arg 0 constant: ...
                                    objv36[0] = const10;
                                    // Arg 1 variable: $script
                                    tmp37 = getVarScalar(interp, "script", compiledLocals, 2);
                                    tmp37.preserve();
                                    objv36[1] = tmp37;
                                    // Arg 2 variable: $var_subtree
                                    tmp37 = getVarScalar(interp, "var_subtree", compiledLocals, 8);
                                    tmp37.preserve();
                                    objv36[2] = tmp37;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                        ? cmdcache7.cmd : null), objv36, 0);
                                    if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                        updateCmdCache(interp, 7);
                                    }
                                } finally {
                                    tmp37 = objv36[1];
                                    if ( tmp37 != null ) {
                                        tmp37.release();
                                    }
                                    tmp37 = objv36[2];
                                    if ( tmp37 != null ) {
                                        tmp37.release();
                                    }
                                    TJC.releaseObjv(interp, objv36, 3);
                                }
                            } // End Invoke: ...
                        } else {
                            { // Invoke: parse_is_word $stree
                                TclObject[] objv38 = TJC.grabObjv(interp, 2);
                                TclObject tmp39;
                                try {
                                    // Arg 0 constant: parse_is_word
                                    objv38[0] = const11;
                                    // Arg 1 variable: $stree
                                    tmp39 = getVarScalar(interp, "stree", compiledLocals, 7);
                                    tmp39.preserve();
                                    objv38[1] = tmp39;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                        ? cmdcache8.cmd : null), objv38, 0);
                                    if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                        updateCmdCache(interp, 8);
                                    }
                                } finally {
                                    tmp39 = objv38[1];
                                    if ( tmp39 != null ) {
                                        tmp39.release();
                                    }
                                    TJC.releaseObjv(interp, objv38, 2);
                                }
                            } // End Invoke: parse_is_word
                            TclObject tmp40 = interp.getResult();
                            ExprValue tmp41 = evs0;
                            TJC.exprInitValue(interp, tmp41, tmp40);
                            boolean tmp42 = tmp41.getBooleanValue(interp);
                            if ( tmp42 ) {
                                { // Invoke: ... $script $stree
                                    TclObject[] objv43 = TJC.grabObjv(interp, 3);
                                    TclObject tmp44;
                                    try {
                                        // Arg 0 constant: ...
                                        objv43[0] = const12;
                                        // Arg 1 variable: $script
                                        tmp44 = getVarScalar(interp, "script", compiledLocals, 2);
                                        tmp44.preserve();
                                        objv43[1] = tmp44;
                                        // Arg 2 variable: $stree
                                        tmp44 = getVarScalar(interp, "stree", compiledLocals, 7);
                                        tmp44.preserve();
                                        objv43[2] = tmp44;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                            ? cmdcache9.cmd : null), objv43, 0);
                                        if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                            updateCmdCache(interp, 9);
                                        }
                                    } finally {
                                        tmp44 = objv43[1];
                                        if ( tmp44 != null ) {
                                            tmp44.release();
                                        }
                                        tmp44 = objv43[2];
                                        if ( tmp44 != null ) {
                                            tmp44.release();
                                        }
                                        TJC.releaseObjv(interp, objv43, 3);
                                    }
                                } // End Invoke: ...
                            }
                        }
                    }
                } // End Invoke: if
                { // Invoke: lappend argument_keys [...]
                    TclObject[] objv45 = TJC.grabObjv(interp, 1);
                    TclObject tmp46;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ...
                            TclObject[] objv47 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: ...
                                objv47[0] = const13;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                    ? cmdcache10.cmd : null), objv47, 0);
                                if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                    updateCmdCache(interp, 10);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv47, 1);
                            }
                        } // End Invoke: ...
                        tmp46 = interp.getResult();
                        tmp46.preserve();
                        objv45[0] = tmp46;
                        interp.resetResult();
                        lappendVarScalar(interp, "argument_keys", objv45, compiledLocals, 5);
                    } finally {
                        TJC.releaseObjvElems(interp, objv45, 1);
                    }
                } // End Invoke: lappend
                } catch (TclException ex) {
                    int type = ex.getCompletionCode();
                    if (type == TCL.BREAK) {
                        break;
                    } else if (type == TCL.CONTINUE) {
                        continue;
                    } else {
                        throw ex;
                    }
                }
            }
        } // End Invoke: for
        { // Invoke: set "..." $argument_keys
            TclObject tmp48;
            String tmp49;
            StringBuffer sbtmp50 = new StringBuffer(64);
            tmp48 = getVarScalar(interp, "key", compiledLocals, 0);
            sbtmp50.append(tmp48.toString());
            sbtmp50.append(",commands");
            tmp49 = sbtmp50.toString();
            tmp48 = getVarScalar(interp, "argument_keys", compiledLocals, 5);
            tmp48 = setVarArray(interp, "_descend", tmp49, tmp48, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: return
            interp.resetResult();
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_check_nested_commands");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("descend_get_data");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("script");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("tree");
        const2.preserve(); const2.preserve();
        const3 = TclInteger.newInstance(0);
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("_descend_commands_push");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("parse_is_word_command");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("descend_nested_subtree");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("parse_is_word_variable");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("lindex");
        const8.preserve(); const8.preserve();
        const9 = TclInteger.newInstance(2);
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("descend_check_variable_for_nested_commands");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("parse_is_word");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("descend_check_word_for_nested_commands");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("_descend_commands_pop");
        const13.preserve(); const13.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;
    WrappedCommand cmdcache10;
    int cmdcache10_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                cmdcache10 = TJC.INVALID_COMMAND_CACHE;
                cmdcache10_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_get_data";
                break;
            }
            case 2: {
                cmdName = "_descend_commands_push";
                break;
            }
            case 3: {
                cmdName = "parse_is_word_command";
                break;
            }
            case 4: {
                cmdName = "descend_nested_subtree";
                break;
            }
            case 5: {
                cmdName = "parse_is_word_variable";
                break;
            }
            case 6: {
                cmdName = "lindex";
                break;
            }
            case 7: {
                cmdName = "descend_check_variable_for_nested_commands";
                break;
            }
            case 8: {
                cmdName = "parse_is_word";
                break;
            }
            case 9: {
                cmdName = "descend_check_word_for_nested_commands";
                break;
            }
            case 10: {
                cmdName = "_descend_commands_pop";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
            case 10: {
                cmdcache10 = lwcmd;
                cmdcache10_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_descend",
        "script",
        "tree",
        "num_args",
        "argument_keys",
        "i",
        "stree",
        "var_subtree"
    };
} // end class DescendCheckNestedCommandsCmd

