// TJC implementation of procedure descend_check_variable_for_nested_commands_iterator
package tjc;
import tcl.lang.*;

public class DescendCheckVariableForNestedCommandsIteratorCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 6, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 6) {
            throw new TclNumArgsException(interp, 1, objv, "script stree type values ranges");
        }
        setVarScalar(interp, "script", objv[1], compiledLocals, 0);
        setVarScalar(interp, "stree", objv[2], compiledLocals, 1);
        setVarScalar(interp, "type", objv[3], compiledLocals, 2);
        setVarScalar(interp, "values", objv[4], compiledLocals, 3);
        setVarScalar(interp, "ranges", objv[5], compiledLocals, 4);
        { // Invoke: switch -exact -- $type {scalar} - {array text} - {array scalar} - {array word} - {word begin} - {word end} - {word text} - {word scalar} - {word array text} - {word array scalar} - {word array word} ... {array command} - {word command} - {word array command} ... default ...
            TclObject tmp0 = getVarScalar(interp, "type", compiledLocals, 2);
            String tmp1 = tmp0.toString();
            int tmp1_length = tmp1.length();
            char tmp1_first = '\n';
            if ( tmp1_length > 0 ) {
                tmp1_first = tmp1.charAt(0);
            }
            interp.resetResult();
            if ( ( tmp1_length == 6 && tmp1_first == 's'
                    && tmp1.compareTo("scalar") == 0 ) ||
                ( tmp1_length == 10 && tmp1_first == 'a'
                    && tmp1.compareTo("array text") == 0 ) ||
                ( tmp1_length == 12 && tmp1_first == 'a'
                    && tmp1.compareTo("array scalar") == 0 ) ||
                ( tmp1_length == 10 && tmp1_first == 'a'
                    && tmp1.compareTo("array word") == 0 ) ||
                ( tmp1_length == 10 && tmp1_first == 'w'
                    && tmp1.compareTo("word begin") == 0 ) ||
                ( tmp1_length == 8 && tmp1_first == 'w'
                    && tmp1.compareTo("word end") == 0 ) ||
                ( tmp1_length == 9 && tmp1_first == 'w'
                    && tmp1.compareTo("word text") == 0 ) ||
                ( tmp1_length == 11 && tmp1_first == 'w'
                    && tmp1.compareTo("word scalar") == 0 ) ||
                ( tmp1_length == 15 && tmp1_first == 'w'
                    && tmp1.compareTo("word array text") == 0 ) ||
                ( tmp1_length == 17 && tmp1_first == 'w'
                    && tmp1.compareTo("word array scalar") == 0 ) ||
                ( tmp1_length == 15 && tmp1_first == 'w'
                    && tmp1.compareTo("word array word") == 0 ) ) {
                // Pattern {word array word}
            } else if ( ( tmp1_length == 13 && tmp1_first == 'a'
                    && tmp1.compareTo("array command") == 0 ) ||
                ( tmp1_length == 12 && tmp1_first == 'w'
                    && tmp1.compareTo("word command") == 0 ) ||
                ( tmp1_length == 18 && tmp1_first == 'w'
                    && tmp1.compareTo("word array command") == 0 ) ) {
                // Pattern {word array command}
                { // Invoke: if ... ... elseif ... ... else ...
                    // Binary operator: () || ()
                    // Binary operator: $type == "array command"
                    TclObject tmp2 = getVarScalar(interp, "type", compiledLocals, 2);
                    boolean tmp3 = tmp2.toString().equals("array command");
                    ExprValue tmp4 = evs0;
                    tmp4.setIntValue(tmp3);
                    // End Binary operator: ==
                    if (!tmp4.getBooleanValue(interp)) {
                    // Binary operator: $type == "word array command"
                    TclObject tmp5 = getVarScalar(interp, "type", compiledLocals, 2);
                    boolean tmp6 = tmp5.toString().equals("word array command");
                    ExprValue tmp7 = evs1;
                    tmp7.setIntValue(tmp6);
                    // End Binary operator: ==
                    tmp4.setIntValue(tmp7.getBooleanValue(interp));
                    } else {
                    tmp4.setIntValue(1);
                    } // End if: !()
                    // End Binary operator: ||
                    boolean tmp8 = ( tmp4.getIntValue() != 0 );
                    if ( tmp8 ) {
                        { // Invoke: set cmd_stree [...]
                            TclObject tmp9;
                            { // Invoke: lindex $stree 2 1
                                TclObject[] objv10 = TJC.grabObjv(interp, 4);
                                TclObject tmp11;
                                try {
                                    // Arg 0 constant: lindex
                                    objv10[0] = const0;
                                    // Arg 1 variable: $stree
                                    tmp11 = getVarScalar(interp, "stree", compiledLocals, 1);
                                    tmp11.preserve();
                                    objv10[1] = tmp11;
                                    // Arg 2 constant: 2
                                    objv10[2] = const1;
                                    // Arg 3 constant: 1
                                    objv10[3] = const2;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                        ? cmdcache1.cmd : null), objv10, 0);
                                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                        updateCmdCache(interp, 1);
                                    }
                                } finally {
                                    tmp11 = objv10[1];
                                    if ( tmp11 != null ) {
                                        tmp11.release();
                                    }
                                    TJC.releaseObjv(interp, objv10, 4);
                                }
                            } // End Invoke: lindex
                            tmp9 = interp.getResult();
                            setVarScalar(interp, "cmd_stree", tmp9, compiledLocals, 5);
                        } // End Invoke: set
                    } else {
                        // Binary operator: $type == "word command"
                        TclObject tmp12 = getVarScalar(interp, "type", compiledLocals, 2);
                        boolean tmp13 = tmp12.toString().equals("word command");
                        ExprValue tmp14 = evs0;
                        tmp14.setIntValue(tmp13);
                        // End Binary operator: ==
                        boolean tmp15 = ( tmp14.getIntValue() != 0 );
                        if ( tmp15 ) {
                            { // Invoke: set cmd_stree $stree
                                TclObject tmp16;
                                tmp16 = getVarScalar(interp, "stree", compiledLocals, 1);
                                setVarScalar(interp, "cmd_stree", tmp16, compiledLocals, 5);
                            } // End Invoke: set
                        } else {
                            { // Invoke: error "..."
                                TclObject[] objv17 = TJC.grabObjv(interp, 2);
                                TclObject tmp18;
                                try {
                                    // Arg 0 constant: error
                                    objv17[0] = const3;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp19 = new StringBuffer(64);
                                    sbtmp19.append("unknown type ");
                                    sbtmp19.append("\"");
                                    tmp18 = getVarScalar(interp, "type", compiledLocals, 2);
                                    sbtmp19.append(tmp18.toString());
                                    sbtmp19.append("\"");
                                    tmp18 = TclString.newInstance(sbtmp19);
                                    tmp18.preserve();
                                    objv17[1] = tmp18;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                        ? cmdcache2.cmd : null), objv17, 0);
                                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                        updateCmdCache(interp, 2);
                                    }
                                } finally {
                                    tmp18 = objv17[1];
                                    if ( tmp18 != null ) {
                                        tmp18.release();
                                    }
                                    TJC.releaseObjv(interp, objv17, 2);
                                }
                            } // End Invoke: error
                        }
                    }
                } // End Invoke: if
                { // Invoke: ...
                    TclObject[] objv20 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: ...
                        objv20[0] = const4;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv20, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv20, 1);
                    }
                } // End Invoke: ...
                { // Invoke: ... $script $cmd_stree
                    TclObject[] objv21 = TJC.grabObjv(interp, 3);
                    TclObject tmp22;
                    try {
                        // Arg 0 constant: ...
                        objv21[0] = const5;
                        // Arg 1 variable: $script
                        tmp22 = getVarScalar(interp, "script", compiledLocals, 0);
                        tmp22.preserve();
                        objv21[1] = tmp22;
                        // Arg 2 variable: $cmd_stree
                        tmp22 = getVarScalar(interp, "cmd_stree", compiledLocals, 5);
                        tmp22.preserve();
                        objv21[2] = tmp22;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv21, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        tmp22 = objv21[1];
                        if ( tmp22 != null ) {
                            tmp22.release();
                        }
                        tmp22 = objv21[2];
                        if ( tmp22 != null ) {
                            tmp22.release();
                        }
                        TJC.releaseObjv(interp, objv21, 3);
                    }
                } // End Invoke: ...
                { // Invoke: ... [...]
                    TclObject[] objv23 = TJC.grabObjv(interp, 2);
                    TclObject tmp24;
                    try {
                        // Arg 0 constant: ...
                        objv23[0] = const6;
                        // Arg 1 command: [...]
                        { // Invoke: ...
                            TclObject[] objv25 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: ...
                                objv25[0] = const7;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                    ? cmdcache5.cmd : null), objv25, 0);
                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                    updateCmdCache(interp, 5);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv25, 1);
                            }
                        } // End Invoke: ...
                        tmp24 = interp.getResult();
                        tmp24.preserve();
                        objv23[1] = tmp24;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                            ? cmdcache6.cmd : null), objv23, 0);
                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                            updateCmdCache(interp, 6);
                        }
                    } finally {
                        tmp24 = objv23[1];
                        if ( tmp24 != null ) {
                            tmp24.release();
                        }
                        TJC.releaseObjv(interp, objv23, 2);
                    }
                } // End Invoke: ...
            } else {
                // Pattern default
                { // Invoke: error "..."
                    TclObject[] objv26 = TJC.grabObjv(interp, 2);
                    TclObject tmp27;
                    try {
                        // Arg 0 constant: error
                        objv26[0] = const3;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp28 = new StringBuffer(64);
                        sbtmp28.append("unknown type ");
                        sbtmp28.append("{");
                        tmp27 = getVarScalar(interp, "type", compiledLocals, 2);
                        sbtmp28.append(tmp27.toString());
                        sbtmp28.append("}");
                        tmp27 = TclString.newInstance(sbtmp28);
                        tmp27.preserve();
                        objv26[1] = tmp27;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv26, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp27 = objv26[1];
                        if ( tmp27 != null ) {
                            tmp27.release();
                        }
                        TJC.releaseObjv(interp, objv26, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: switch
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_check_variable_for_nested_commands_iterator");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("lindex");
        const0.preserve(); const0.preserve();
        const1 = TclInteger.newInstance(2);
        const1.preserve(); const1.preserve();
        const2 = TclInteger.newInstance(1);
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("error");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("_descend_commands_push");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("descend_nested_subtree");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("_descend_commands_add");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("_descend_commands_pop");
        const7.preserve(); const7.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "lindex";
                break;
            }
            case 2: {
                cmdName = "error";
                break;
            }
            case 3: {
                cmdName = "_descend_commands_push";
                break;
            }
            case 4: {
                cmdName = "descend_nested_subtree";
                break;
            }
            case 5: {
                cmdName = "_descend_commands_pop";
                break;
            }
            case 6: {
                cmdName = "_descend_commands_add";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "script",
        "stree",
        "type",
        "values",
        "ranges",
        "cmd_stree"
    };
} // end class DescendCheckVariableForNestedCommandsIteratorCmd

