// TJC implementation of procedure descend_container_expr_argument_validate
package tjc;
import tcl.lang.*;

public class DescendContainerExprArgumentValidateCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 9, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "key argindex");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        setVarScalar(interp, "argindex", objv[2], compiledLocals, 1);
        { // Invoke: global _descend
            TJC.makeGlobalLinkVar(interp, "_descend", "_descend", 2);
        } // End Invoke: global
        { // Invoke: set script [...]
            TclObject tmp0;
            { // Invoke: descend_get_data $key script
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: descend_get_data
                    objv1[0] = const0;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 constant: script
                    objv1[2] = const1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: descend_get_data
            tmp0 = interp.getResult();
            setVarScalar(interp, "script", tmp0, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set tree [...]
            TclObject tmp3;
            { // Invoke: descend_get_data $key tree
                TclObject[] objv4 = TJC.grabObjv(interp, 3);
                TclObject tmp5;
                try {
                    // Arg 0 constant: descend_get_data
                    objv4[0] = const0;
                    // Arg 1 variable: $key
                    tmp5 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp5.preserve();
                    objv4[1] = tmp5;
                    // Arg 2 constant: tree
                    objv4[2] = const2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv4, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp5 = objv4[1];
                    if ( tmp5 != null ) {
                        tmp5.release();
                    }
                    TJC.releaseObjv(interp, objv4, 3);
                }
            } // End Invoke: descend_get_data
            tmp3 = interp.getResult();
            setVarScalar(interp, "tree", tmp3, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set stree [...]
            TclObject tmp6;
            { // Invoke: lindex $tree $argindex
                TclObject tmp7 = null;
                TclObject tmp8;
                try {
                    tmp7 = getVarScalar(interp, "tree", compiledLocals, 4);
                    tmp7.preserve();
                    tmp8 = getVarScalar(interp, "argindex", compiledLocals, 1);
                    TJC.lindexNonconst(interp, tmp7, tmp8);
                } finally {
                    if ( tmp7 != null ) {
                        tmp7.release();
                    }
                }
            } // End Invoke: lindex
            tmp6 = interp.getResult();
            setVarScalar(interp, "stree", tmp6, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: parse_is_simple_text $stree
                TclObject[] objv9 = TJC.grabObjv(interp, 2);
                TclObject tmp10;
                try {
                    // Arg 0 constant: parse_is_simple_text
                    objv9[0] = const3;
                    // Arg 1 variable: $stree
                    tmp10 = getVarScalar(interp, "stree", compiledLocals, 5);
                    tmp10.preserve();
                    objv9[1] = tmp10;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv9, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp10 = objv9[1];
                    if ( tmp10 != null ) {
                        tmp10.release();
                    }
                    TJC.releaseObjv(interp, objv9, 2);
                }
            } // End Invoke: parse_is_simple_text
            TclObject tmp11 = interp.getResult();
            ExprValue tmp12 = evs0;
            if ( tmp11.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp12, tmp11);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp12, tmp11);
            }
            // End Unary operator: !
            boolean tmp13 = ( tmp12.getIntValue() != 0 );
            if ( tmp13 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const4);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set range [...]
            TclObject tmp14;
            { // Invoke: ... $stree simple
                TclObject[] objv15 = TJC.grabObjv(interp, 3);
                TclObject tmp16;
                try {
                    // Arg 0 constant: ...
                    objv15[0] = const5;
                    // Arg 1 variable: $stree
                    tmp16 = getVarScalar(interp, "stree", compiledLocals, 5);
                    tmp16.preserve();
                    objv15[1] = tmp16;
                    // Arg 2 constant: simple
                    objv15[2] = const6;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv15, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp16 = objv15[1];
                    if ( tmp16 != null ) {
                        tmp16.release();
                    }
                    TJC.releaseObjv(interp, objv15, 3);
                }
            } // End Invoke: ...
            tmp14 = interp.getResult();
            setVarScalar(interp, "range", tmp14, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: parse_is_braced $script $range
                TclObject[] objv17 = TJC.grabObjv(interp, 3);
                TclObject tmp18;
                try {
                    // Arg 0 constant: parse_is_braced
                    objv17[0] = const7;
                    // Arg 1 variable: $script
                    tmp18 = getVarScalar(interp, "script", compiledLocals, 3);
                    tmp18.preserve();
                    objv17[1] = tmp18;
                    // Arg 2 variable: $range
                    tmp18 = getVarScalar(interp, "range", compiledLocals, 6);
                    tmp18.preserve();
                    objv17[2] = tmp18;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                        ? cmdcache4.cmd : null), objv17, 0);
                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                        updateCmdCache(interp, 4);
                    }
                } finally {
                    tmp18 = objv17[1];
                    if ( tmp18 != null ) {
                        tmp18.release();
                    }
                    tmp18 = objv17[2];
                    if ( tmp18 != null ) {
                        tmp18.release();
                    }
                    TJC.releaseObjv(interp, objv17, 3);
                }
            } // End Invoke: parse_is_braced
            TclObject tmp19 = interp.getResult();
            ExprValue tmp20 = evs0;
            if ( tmp19.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp20, tmp19);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp20, tmp19);
            }
            // End Unary operator: !
            boolean tmp21 = ( tmp20.getIntValue() != 0 );
            if ( tmp21 ) {
                { // Invoke: set simple [...]
                    TclObject tmp22;
                    { // Invoke: ... $script $stree
                        TclObject[] objv23 = TJC.grabObjv(interp, 3);
                        TclObject tmp24;
                        try {
                            // Arg 0 constant: ...
                            objv23[0] = const8;
                            // Arg 1 variable: $script
                            tmp24 = getVarScalar(interp, "script", compiledLocals, 3);
                            tmp24.preserve();
                            objv23[1] = tmp24;
                            // Arg 2 variable: $stree
                            tmp24 = getVarScalar(interp, "stree", compiledLocals, 5);
                            tmp24.preserve();
                            objv23[2] = tmp24;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                ? cmdcache5.cmd : null), objv23, 0);
                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                updateCmdCache(interp, 5);
                            }
                        } finally {
                            tmp24 = objv23[1];
                            if ( tmp24 != null ) {
                                tmp24.release();
                            }
                            tmp24 = objv23[2];
                            if ( tmp24 != null ) {
                                tmp24.release();
                            }
                            TJC.releaseObjv(interp, objv23, 3);
                        }
                    } // End Invoke: ...
                    tmp22 = interp.getResult();
                    setVarScalar(interp, "simple", tmp22, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: switch -exact -- $simple {1} - {0} - {true} - {false} ... default ...
                    TclObject tmp25 = getVarScalar(interp, "simple", compiledLocals, 7);
                    String tmp26 = tmp25.toString();
                    int tmp26_length = tmp26.length();
                    char tmp26_first = '\n';
                    if ( tmp26_length > 0 ) {
                        tmp26_first = tmp26.charAt(0);
                    }
                    if ( ( tmp26_length == 1 && tmp26_first == '1' ) ||
                        ( tmp26_length == 1 && tmp26_first == '0' ) ||
                        ( tmp26_length == 4 && tmp26_first == 't'
                            && tmp26.compareTo("true") == 0 ) ||
                        ( tmp26_length == 5 && tmp26_first == 'f'
                            && tmp26.compareTo("false") == 0 ) ) {
                        // Pattern {false}
                        { // Invoke: return 1
                            interp.resetResult();
                            interp.setResult(const9);
                            if ( true ) { return; }
                        } // End Invoke: return
                    } else {
                        // Pattern default
                        { // Invoke: return 0
                            interp.resetResult();
                            interp.setResult(const4);
                            if ( true ) { return; }
                        } // End Invoke: return
                    }
                } // End Invoke: switch
            }
        } // End Invoke: if
        { // Invoke: set range [...]
            TclObject tmp27;
            { // Invoke: ... $stree text
                TclObject[] objv28 = TJC.grabObjv(interp, 3);
                TclObject tmp29;
                try {
                    // Arg 0 constant: ...
                    objv28[0] = const5;
                    // Arg 1 variable: $stree
                    tmp29 = getVarScalar(interp, "stree", compiledLocals, 5);
                    tmp29.preserve();
                    objv28[1] = tmp29;
                    // Arg 2 constant: text
                    objv28[2] = const10;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv28, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp29 = objv28[1];
                    if ( tmp29 != null ) {
                        tmp29.release();
                    }
                    TJC.releaseObjv(interp, objv28, 3);
                }
            } // End Invoke: ...
            tmp27 = interp.getResult();
            setVarScalar(interp, "range", tmp27, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: if ... ...
            { // Invoke: catch ... err
                int code30 = TCL.OK;
                try {
                if ( false ) { throw (TclException) null; }
                { // Invoke: parse expr $script $range
                    TclObject[] objv31 = TJC.grabObjv(interp, 4);
                    TclObject tmp32;
                    try {
                        // Arg 0 constant: parse
                        objv31[0] = const11;
                        // Arg 1 constant: expr
                        objv31[1] = const12;
                        // Arg 2 variable: $script
                        tmp32 = getVarScalar(interp, "script", compiledLocals, 3);
                        tmp32.preserve();
                        objv31[2] = tmp32;
                        // Arg 3 variable: $range
                        tmp32 = getVarScalar(interp, "range", compiledLocals, 6);
                        tmp32.preserve();
                        objv31[3] = tmp32;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                            ? cmdcache6.cmd : null), objv31, 0);
                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                            updateCmdCache(interp, 6);
                        }
                    } finally {
                        tmp32 = objv31[2];
                        if ( tmp32 != null ) {
                            tmp32.release();
                        }
                        tmp32 = objv31[3];
                        if ( tmp32 != null ) {
                            tmp32.release();
                        }
                        TJC.releaseObjv(interp, objv31, 4);
                    }
                } // End Invoke: parse
                } catch (TclException ex) {
                    code30 = ex.getCompletionCode();
                }
                TclObject result = interp.getResult();
                try {
                    setVarScalar(interp, "err", result, compiledLocals, 8);
                } catch (TclException ex) {
                    TJC.catchVarErr(interp);
                }
                interp.resetResult();
                interp.setResult(code30);
            } // End Invoke: catch
            TclObject tmp33 = interp.getResult();
            ExprValue tmp34 = evs0;
            TJC.exprInitValue(interp, tmp34, tmp33);
            boolean tmp35 = tmp34.getBooleanValue(interp);
            if ( tmp35 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const4);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: return 1
            interp.resetResult();
            interp.setResult(const9);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_container_expr_argument_validate");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("descend_get_data");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("script");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("tree");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("parse_is_simple_text");
        const3.preserve(); const3.preserve();
        const4 = TclInteger.newInstance(0);
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("parse_get_simple_text_range");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("simple");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("parse_is_braced");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("parse_get_simple_text");
        const8.preserve(); const8.preserve();
        const9 = TclInteger.newInstance(1);
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("text");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("parse");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("expr");
        const12.preserve(); const12.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_get_data";
                break;
            }
            case 2: {
                cmdName = "parse_is_simple_text";
                break;
            }
            case 3: {
                cmdName = "parse_get_simple_text_range";
                break;
            }
            case 4: {
                cmdName = "parse_is_braced";
                break;
            }
            case 5: {
                cmdName = "parse_get_simple_text";
                break;
            }
            case 6: {
                cmdName = "parse";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "argindex",
        "_descend",
        "script",
        "tree",
        "stree",
        "range",
        "simple",
        "err"
    };
} // end class DescendContainerExprArgumentValidateCmd

