// TJC implementation of procedure descend_container_expr
package tjc;
import tcl.lang.*;

public class DescendContainerExprCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 6, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _descend
            TJC.makeGlobalLinkVar(interp, "_descend", "_descend", 1);
        } // End Invoke: global
        { // Invoke: set result [...]
            TclObject tmp0;
            { // Invoke: ... $key
                TclObject[] objv1 = TJC.grabObjv(interp, 2);
                TclObject tmp2;
                try {
                    // Arg 0 constant: ...
                    objv1[0] = const0;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 2);
                }
            } // End Invoke: ...
            tmp0 = interp.getResult();
            setVarScalar(interp, "result", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: if {$result != "OK"} ...
            // Binary operator: $result != "OK"
            TclObject tmp3 = getVarScalar(interp, "result", compiledLocals, 2);
            boolean tmp4 = ! tmp3.toString().equals("OK");
            ExprValue tmp5 = evs0;
            tmp5.setIntValue(tmp4);
            // End Binary operator: !=
            boolean tmp6 = ( tmp5.getIntValue() != 0 );
            if ( tmp6 ) {
                { // Invoke: if ... ...
                    { // Invoke: descend_get_data $key usage
                        TclObject[] objv7 = TJC.grabObjv(interp, 3);
                        TclObject tmp8;
                        try {
                            // Arg 0 constant: descend_get_data
                            objv7[0] = const1;
                            // Arg 1 variable: $key
                            tmp8 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp8.preserve();
                            objv7[1] = tmp8;
                            // Arg 2 constant: usage
                            objv7[2] = const2;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv7, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp8 = objv7[1];
                            if ( tmp8 != null ) {
                                tmp8.release();
                            }
                            TJC.releaseObjv(interp, objv7, 3);
                        }
                    } // End Invoke: descend_get_data
                    TclObject tmp9 = interp.getResult();
                    ExprValue tmp10 = evs0;
                    TJC.exprInitValue(interp, tmp10, tmp9);
                    boolean tmp11 = tmp10.getBooleanValue(interp);
                    if ( tmp11 ) {
                        { // Invoke: descend_report_usage $key $result
                            TclObject[] objv12 = TJC.grabObjv(interp, 3);
                            TclObject tmp13;
                            try {
                                // Arg 0 constant: descend_report_usage
                                objv12[0] = const3;
                                // Arg 1 variable: $key
                                tmp13 = getVarScalar(interp, "key", compiledLocals, 0);
                                tmp13.preserve();
                                objv12[1] = tmp13;
                                // Arg 2 variable: $result
                                tmp13 = getVarScalar(interp, "result", compiledLocals, 2);
                                tmp13.preserve();
                                objv12[2] = tmp13;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv12, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                tmp13 = objv12[1];
                                if ( tmp13 != null ) {
                                    tmp13.release();
                                }
                                tmp13 = objv12[2];
                                if ( tmp13 != null ) {
                                    tmp13.release();
                                }
                                TJC.releaseObjv(interp, objv12, 3);
                            }
                        } // End Invoke: descend_report_usage
                    }
                } // End Invoke: if
                { // Invoke: return
                    interp.resetResult();
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set script [...]
            TclObject tmp14;
            { // Invoke: descend_get_data $key script
                TclObject[] objv15 = TJC.grabObjv(interp, 3);
                TclObject tmp16;
                try {
                    // Arg 0 constant: descend_get_data
                    objv15[0] = const1;
                    // Arg 1 variable: $key
                    tmp16 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp16.preserve();
                    objv15[1] = tmp16;
                    // Arg 2 constant: script
                    objv15[2] = const4;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv15, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp16 = objv15[1];
                    if ( tmp16 != null ) {
                        tmp16.release();
                    }
                    TJC.releaseObjv(interp, objv15, 3);
                }
            } // End Invoke: descend_get_data
            tmp14 = interp.getResult();
            setVarScalar(interp, "script", tmp14, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set tree [...]
            TclObject tmp17;
            { // Invoke: descend_get_data $key tree
                TclObject[] objv18 = TJC.grabObjv(interp, 3);
                TclObject tmp19;
                try {
                    // Arg 0 constant: descend_get_data
                    objv18[0] = const1;
                    // Arg 1 variable: $key
                    tmp19 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp19.preserve();
                    objv18[1] = tmp19;
                    // Arg 2 constant: tree
                    objv18[2] = const5;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv18, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp19 = objv18[1];
                    if ( tmp19 != null ) {
                        tmp19.release();
                    }
                    TJC.releaseObjv(interp, objv18, 3);
                }
            } // End Invoke: descend_get_data
            tmp17 = interp.getResult();
            setVarScalar(interp, "tree", tmp17, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set arg [...]
            TclObject tmp20;
            { // Invoke: ... $key
                TclObject[] objv21 = TJC.grabObjv(interp, 2);
                TclObject tmp22;
                try {
                    // Arg 0 constant: ...
                    objv21[0] = const6;
                    // Arg 1 variable: $key
                    tmp22 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp22.preserve();
                    objv21[1] = tmp22;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                        ? cmdcache4.cmd : null), objv21, 0);
                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                        updateCmdCache(interp, 4);
                    }
                } finally {
                    tmp22 = objv21[1];
                    if ( tmp22 != null ) {
                        tmp22.release();
                    }
                    TJC.releaseObjv(interp, objv21, 2);
                }
            } // End Invoke: ...
            tmp20 = interp.getResult();
            setVarScalar(interp, "arg", tmp20, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: ...
            TclObject[] objv23 = TJC.grabObjv(interp, 1);
            try {
                // Arg 0 constant: ...
                objv23[0] = const7;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                    ? cmdcache5.cmd : null), objv23, 0);
                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                    updateCmdCache(interp, 5);
                }
            } finally {
                TJC.releaseObjv(interp, objv23, 1);
            }
        } // End Invoke: ...
        { // Invoke: ... $key $arg
            TclObject[] objv24 = TJC.grabObjv(interp, 3);
            TclObject tmp25;
            try {
                // Arg 0 constant: ...
                objv24[0] = const8;
                // Arg 1 variable: $key
                tmp25 = getVarScalar(interp, "key", compiledLocals, 0);
                tmp25.preserve();
                objv24[1] = tmp25;
                // Arg 2 variable: $arg
                tmp25 = getVarScalar(interp, "arg", compiledLocals, 5);
                tmp25.preserve();
                objv24[2] = tmp25;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                    ? cmdcache6.cmd : null), objv24, 0);
                if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                    updateCmdCache(interp, 6);
                }
            } finally {
                tmp25 = objv24[1];
                if ( tmp25 != null ) {
                    tmp25.release();
                }
                tmp25 = objv24[2];
                if ( tmp25 != null ) {
                    tmp25.release();
                }
                TJC.releaseObjv(interp, objv24, 3);
            }
        } // End Invoke: ...
        { // Invoke: set "..." [...]
            TclObject tmp26;
            String tmp28;
            StringBuffer sbtmp29 = new StringBuffer(64);
            tmp26 = getVarScalar(interp, "key", compiledLocals, 0);
            sbtmp29.append(tmp26.toString());
            sbtmp29.append(",container_commands");
            tmp28 = sbtmp29.toString();
            { // Invoke: ...
                TclObject[] objv27 = TJC.grabObjv(interp, 1);
                try {
                    // Arg 0 constant: ...
                    objv27[0] = const9;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                        ? cmdcache7.cmd : null), objv27, 0);
                    if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                        updateCmdCache(interp, 7);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv27, 1);
                }
            } // End Invoke: ...
            tmp26 = interp.getResult();
            tmp26 = setVarArray(interp, "_descend", tmp28, tmp26, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: return
            interp.resetResult();
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_container_expr");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("descend_container_expr_validate");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("descend_get_data");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("usage");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("descend_report_usage");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("script");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("tree");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("descend_container_expr_arg");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("_descend_commands_push");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("descend_container_expr_argument");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("_descend_commands_pop");
        const9.preserve(); const9.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_container_expr_validate";
                break;
            }
            case 2: {
                cmdName = "descend_get_data";
                break;
            }
            case 3: {
                cmdName = "descend_report_usage";
                break;
            }
            case 4: {
                cmdName = "descend_container_expr_arg";
                break;
            }
            case 5: {
                cmdName = "_descend_commands_push";
                break;
            }
            case 6: {
                cmdName = "descend_container_expr_argument";
                break;
            }
            case 7: {
                cmdName = "_descend_commands_pop";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_descend",
        "result",
        "script",
        "tree",
        "arg"
    };
} // end class DescendContainerExprCmd

