// TJC implementation of procedure descend_container_while_validate
package tjc;
import tcl.lang.*;

public class DescendContainerWhileValidateCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 5, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _descend
            TJC.makeGlobalLinkVar(interp, "_descend", "_descend", 1);
        } // End Invoke: global
        { // Invoke: set script [...]
            TclObject tmp0;
            { // Invoke: descend_get_data $key script
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: descend_get_data
                    objv1[0] = const0;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 constant: script
                    objv1[2] = const1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: descend_get_data
            tmp0 = interp.getResult();
            setVarScalar(interp, "script", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set tree [...]
            TclObject tmp3;
            { // Invoke: descend_get_data $key tree
                TclObject[] objv4 = TJC.grabObjv(interp, 3);
                TclObject tmp5;
                try {
                    // Arg 0 constant: descend_get_data
                    objv4[0] = const0;
                    // Arg 1 variable: $key
                    tmp5 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp5.preserve();
                    objv4[1] = tmp5;
                    // Arg 2 constant: tree
                    objv4[2] = const2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv4, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp5 = objv4[1];
                    if ( tmp5 != null ) {
                        tmp5.release();
                    }
                    TJC.releaseObjv(interp, objv4, 3);
                }
            } // End Invoke: descend_get_data
            tmp3 = interp.getResult();
            setVarScalar(interp, "tree", tmp3, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set num_args [...]
            TclObject tmp6;
            { // Invoke: llength $tree
                TclObject tmp7 = getVarScalar(interp, "tree", compiledLocals, 3);
                int tmp8 = TclList.getLength(interp, tmp7);
                interp.setResult(tmp8);
            } // End Invoke: llength
            tmp6 = interp.getResult();
            setVarScalar(interp, "num_args", tmp6, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: if {$num_args != 3} ...
            // Binary operator: $num_args != 3
            TclObject tmp9 = getVarScalar(interp, "num_args", compiledLocals, 4);
            ExprValue tmp10 = evs0;
            TJC.exprInitValue(interp, tmp10, tmp9);
            ExprValue tmp11 = evs1;
            tmp11.setIntValue(3);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp10, tmp11);
            // End Binary operator: !=
            boolean tmp12 = ( tmp10.getIntValue() != 0 );
            if ( tmp12 ) {
                { // Invoke: set _descend($key,usage) 1
                    TclObject tmp13;
                    String tmp14;
                    StringBuffer sbtmp15 = new StringBuffer(64);
                    tmp13 = getVarScalar(interp, "key", compiledLocals, 0);
                    sbtmp15.append(tmp13.toString());
                    sbtmp15.append(",usage");
                    tmp14 = sbtmp15.toString();
                    setVarArray(interp, "_descend", tmp14, const3, compiledLocals, 1);
                } // End Invoke: set
                { // Invoke: return [...]
                    { // Invoke: list numArgs "while" $num_args 3
                        TclObject tmp16 = TclList.newInstance();
                        TclObject tmp17;
                        try {
                            TclList.append(interp, tmp16, const4);
                            TclList.append(interp, tmp16, const5);
                            tmp17 = getVarScalar(interp, "num_args", compiledLocals, 4);
                            TclList.append(interp, tmp16, tmp17);
                            TclList.append(interp, tmp16, const6);
                        } catch (TclException ex) {
                            tmp16.release();
                            throw ex;
                        }
                        interp.setResult(tmp16);
                    } // End Invoke: list
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: ... $key 1
                TclObject[] objv18 = TJC.grabObjv(interp, 3);
                TclObject tmp19;
                try {
                    // Arg 0 constant: ...
                    objv18[0] = const7;
                    // Arg 1 variable: $key
                    tmp19 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp19.preserve();
                    objv18[1] = tmp19;
                    // Arg 2 constant: 1
                    objv18[2] = const3;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv18, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp19 = objv18[1];
                    if ( tmp19 != null ) {
                        tmp19.release();
                    }
                    TJC.releaseObjv(interp, objv18, 3);
                }
            } // End Invoke: ...
            TclObject tmp20 = interp.getResult();
            ExprValue tmp21 = evs0;
            if ( tmp20.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp21, tmp20);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp21, tmp20);
            }
            // End Unary operator: !
            boolean tmp22 = ( tmp21.getIntValue() != 0 );
            if ( tmp22 ) {
                { // Invoke: set _descend($key,usage) 1
                    TclObject tmp23;
                    String tmp24;
                    StringBuffer sbtmp25 = new StringBuffer(64);
                    tmp23 = getVarScalar(interp, "key", compiledLocals, 0);
                    sbtmp25.append(tmp23.toString());
                    sbtmp25.append(",usage");
                    tmp24 = sbtmp25.toString();
                    setVarArray(interp, "_descend", tmp24, const3, compiledLocals, 1);
                } // End Invoke: set
                { // Invoke: return [...]
                    { // Invoke: list invalidArg 1 "expr" ...
                        TclObject tmp26 = TclList.newInstance();
                        try {
                            TclList.append(interp, tmp26, const8);
                            TclList.append(interp, tmp26, const3);
                            TclList.append(interp, tmp26, const9);
                            TclList.append(interp, tmp26, const10);
                        } catch (TclException ex) {
                            tmp26.release();
                            throw ex;
                        }
                        interp.setResult(tmp26);
                    } // End Invoke: list
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            { // Invoke: ... $key 2
                TclObject[] objv27 = TJC.grabObjv(interp, 3);
                TclObject tmp28;
                try {
                    // Arg 0 constant: ...
                    objv27[0] = const11;
                    // Arg 1 variable: $key
                    tmp28 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp28.preserve();
                    objv27[1] = tmp28;
                    // Arg 2 constant: 2
                    objv27[2] = const12;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv27, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp28 = objv27[1];
                    if ( tmp28 != null ) {
                        tmp28.release();
                    }
                    TJC.releaseObjv(interp, objv27, 3);
                }
            } // End Invoke: ...
            TclObject tmp29 = interp.getResult();
            ExprValue tmp30 = evs0;
            TJC.exprInitValue(interp, tmp30, tmp29);
            boolean tmp31 = tmp30.getBooleanValue(interp);
            if ( tmp31 ) {
                { // Invoke: set "..." 1
                    TclObject tmp32;
                    String tmp33;
                    StringBuffer sbtmp34 = new StringBuffer(64);
                    tmp32 = getVarScalar(interp, "key", compiledLocals, 0);
                    sbtmp34.append(tmp32.toString());
                    sbtmp34.append(",static_container");
                    tmp33 = sbtmp34.toString();
                    setVarArray(interp, "_descend", tmp33, const3, compiledLocals, 1);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: set "..." [...]
            TclObject tmp35;
            String tmp37;
            StringBuffer sbtmp38 = new StringBuffer(64);
            tmp35 = getVarScalar(interp, "key", compiledLocals, 0);
            sbtmp38.append(tmp35.toString());
            sbtmp38.append(",validated");
            tmp37 = sbtmp38.toString();
            { // Invoke: list 1 2
                TclObject tmp36 = TclList.newInstance();
                try {
                    TclList.append(interp, tmp36, const3);
                    TclList.append(interp, tmp36, const12);
                } catch (TclException ex) {
                    tmp36.release();
                    throw ex;
                }
                interp.setResult(tmp36);
            } // End Invoke: list
            tmp35 = interp.getResult();
            tmp35 = setVarArray(interp, "_descend", tmp37, tmp35, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: return "OK"
            interp.resetResult();
            interp.setResult(const13);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_container_while_validate");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("descend_get_data");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("script");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("tree");
        const2.preserve(); const2.preserve();
        const3 = TclInteger.newInstance(1);
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("numArgs");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("while");
        const5.preserve(); const5.preserve();
        const6 = TclInteger.newInstance(3);
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("descend_container_expr_argument_validate");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("invalidArg");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("expr");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("braced expr argument required");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("descend_container_argument_body_is_static");
        const11.preserve(); const11.preserve();
        const12 = TclInteger.newInstance(2);
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("OK");
        const13.preserve(); const13.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_get_data";
                break;
            }
            case 2: {
                cmdName = "descend_container_expr_argument_validate";
                break;
            }
            case 3: {
                cmdName = "descend_container_argument_body_is_static";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_descend",
        "script",
        "tree",
        "num_args"
    };
} // end class DescendContainerWhileValidateCmd

