// TJC implementation of procedure emitter_container_for_end
package tjc;
import tcl.lang.*;

public class EmitterContainerForEndCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 2, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "omit_reset");
        }
        setVarScalar(interp, "omit_reset", objv[1], compiledLocals, 0);
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: emitter_indent_level -1
            TclObject[] objv0 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv0[0] = const1;
                // Arg 1 constant: -1
                objv0[1] = const2;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                    ? cmdcache1.cmd : null), objv0, 0);
                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                    updateCmdCache(interp, 1);
                }
            } finally {
                TJC.releaseObjv(interp, objv0, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: append buffer [...] ...
            TclObject[] objv1 = TJC.grabObjv(interp, 2);
            TclObject tmp2;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv3 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv3[0] = const3;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv3, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv3, 1);
                    }
                } // End Invoke: emitter_indent
                tmp2 = interp.getResult();
                tmp2.preserve();
                objv1[0] = tmp2;
                // Arg 3 constant: ...
                objv1[1] = const4;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv1, compiledLocals, 1);
            } finally {
                tmp2 = objv1[0];
                if ( tmp2 != null ) {
                    tmp2.release();
                }
                TJC.releaseObjv(interp, objv1, 2);
            }
        } // End Invoke: append
        { // Invoke: if {!$omit_reset} ...
            // Unary operator: ! $omit_reset
            TclObject tmp4 = getVarScalar(interp, "omit_reset", compiledLocals, 0);
            ExprValue tmp5 = evs0;
            if ( tmp4.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp5, tmp4);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp5, tmp4);
            }
            // End Unary operator: !
            boolean tmp6 = ( tmp5.getIntValue() != 0 );
            if ( tmp6 ) {
                { // Invoke: append buffer [...]
                    TclObject[] objv7 = TJC.grabObjv(interp, 1);
                    TclObject tmp8;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: emitter_reset_result
                            TclObject[] objv9 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: emitter_reset_result
                                objv9[0] = const5;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv9, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv9, 1);
                            }
                        } // End Invoke: emitter_reset_result
                        tmp8 = interp.getResult();
                        tmp8.preserve();
                        objv7[0] = tmp8;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv7, compiledLocals, 1);
                    } finally {
                        TJC.releaseObjvElems(interp, objv7, 1);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: return $buffer
            TclObject tmp10 = getVarScalar(interp, "buffer", compiledLocals, 1);
            interp.resetResult();
            interp.setResult(tmp10);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "emitter_container_for_end");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("emitter_indent_level");
        const1.preserve(); const1.preserve();
        const2 = TclInteger.newInstance(-1);
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("emitter_indent");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("}\n");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("emitter_reset_result");
        const5.preserve(); const5.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "emitter_indent_level";
                break;
            }
            case 2: {
                cmdName = "emitter_indent";
                break;
            }
            case 3: {
                cmdName = "emitter_reset_result";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "omit_reset",
        "buffer"
    };
} // end class EmitterContainerForEndCmd

