// TJC implementation of procedure emitter_container_for_start
package tjc;
import tcl.lang.*;

public class EmitterContainerForStartCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 7, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length < 3 || objv.length > 4) {
            throw new TclNumArgsException(interp, 1, objv, "init_buffer expr_symbol ?incr_buffer?");
        }
        setVarScalar(interp, "init_buffer", objv[1], compiledLocals, 0);
        setVarScalar(interp, "expr_symbol", objv[2], compiledLocals, 1);
        setVarScalar(interp, "incr_buffer", 
            ((objv.length <= 3) ? const0 : objv[3]), compiledLocals, 2);
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set added_indent 0
            setVarScalar(interp, "added_indent", const1, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set init_str " "
            setVarScalar(interp, "init_str", const2, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: if {$init_buffer != ""} ...
            // Binary operator: $init_buffer != ""
            TclObject tmp0 = getVarScalar(interp, "init_buffer", compiledLocals, 0);
            ExprValue tmp1 = evs0;
            TJC.exprEqualsEmptyString(tmp1, tmp0, true);
            // End Binary operator: !=
            boolean tmp2 = ( tmp1.getIntValue() != 0 );
            if ( tmp2 ) {
                { // Invoke: set init_str " $init_buffer "
                    TclObject tmp3;
                    StringBuffer sbtmp4 = new StringBuffer(64);
                    sbtmp4.append(" ");
                    tmp3 = getVarScalar(interp, "init_buffer", compiledLocals, 0);
                    sbtmp4.append(tmp3.toString());
                    sbtmp4.append(" ");
                    tmp3 = TclString.newInstance(sbtmp4);
                    setVarScalar(interp, "init_str", tmp3, compiledLocals, 5);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: set incr_str " "
            setVarScalar(interp, "incr_str", const2, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: if {$incr_buffer != ""} ...
            // Binary operator: $incr_buffer != ""
            TclObject tmp5 = getVarScalar(interp, "incr_buffer", compiledLocals, 2);
            ExprValue tmp6 = evs0;
            TJC.exprEqualsEmptyString(tmp6, tmp5, true);
            // End Binary operator: !=
            boolean tmp7 = ( tmp6.getIntValue() != 0 );
            if ( tmp7 ) {
                { // Invoke: set incr_str " $incr_buffer "
                    TclObject tmp8;
                    StringBuffer sbtmp9 = new StringBuffer(64);
                    sbtmp9.append(" ");
                    tmp8 = getVarScalar(interp, "incr_buffer", compiledLocals, 2);
                    sbtmp9.append(tmp8.toString());
                    sbtmp9.append(" ");
                    tmp8 = TclString.newInstance(sbtmp9);
                    setVarScalar(interp, "incr_str", tmp8, compiledLocals, 6);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: append buffer [...] "for (" $init_str ... $expr_symbol ... $incr_str ...
            TclObject[] objv10 = TJC.grabObjv(interp, 8);
            TclObject tmp11;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv12 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv12[0] = const3;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv12, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv12, 1);
                    }
                } // End Invoke: emitter_indent
                tmp11 = interp.getResult();
                tmp11.preserve();
                objv10[0] = tmp11;
                // Arg 3 constant: "for ("
                objv10[1] = const4;
                // Arg 4 variable: $init_str
                tmp11 = getVarScalar(interp, "init_str", compiledLocals, 5);
                tmp11.preserve();
                objv10[2] = tmp11;
                // Arg 5 constant: ...
                objv10[3] = const5;
                // Arg 6 variable: $expr_symbol
                tmp11 = getVarScalar(interp, "expr_symbol", compiledLocals, 1);
                tmp11.preserve();
                objv10[4] = tmp11;
                // Arg 7 constant: ...
                objv10[5] = const6;
                // Arg 8 variable: $incr_str
                tmp11 = getVarScalar(interp, "incr_str", compiledLocals, 6);
                tmp11.preserve();
                objv10[6] = tmp11;
                // Arg 9 constant: ...
                objv10[7] = const7;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv10, compiledLocals, 3);
            } finally {
                tmp11 = objv10[0];
                if ( tmp11 != null ) {
                    tmp11.release();
                }
                tmp11 = objv10[2];
                if ( tmp11 != null ) {
                    tmp11.release();
                }
                tmp11 = objv10[4];
                if ( tmp11 != null ) {
                    tmp11.release();
                }
                tmp11 = objv10[6];
                if ( tmp11 != null ) {
                    tmp11.release();
                }
                TJC.releaseObjv(interp, objv10, 8);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level +1
            TclObject[] objv13 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv13[0] = const8;
                // Arg 1 constant: +1
                objv13[1] = const9;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv13, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                TJC.releaseObjv(interp, objv13, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: return $buffer
            TclObject tmp14 = getVarScalar(interp, "buffer", compiledLocals, 3);
            interp.resetResult();
            interp.setResult(tmp14);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "emitter_container_for_start");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclInteger.newInstance(0);
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance(" ");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("emitter_indent");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("for (");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("; ");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance(" ;");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance(") {\n");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("emitter_indent_level");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("+1");
        TclInteger.get(interp, const9);
        const9.preserve(); const9.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "emitter_indent";
                break;
            }
            case 2: {
                cmdName = "emitter_indent_level";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "init_buffer",
        "expr_symbol",
        "incr_buffer",
        "buffer",
        "added_indent",
        "init_str",
        "incr_str"
    };
} // end class EmitterContainerForStartCmd

