// TJC implementation of procedure jdk_package_library
package tjc;
import tcl.lang.*;

public class JdkPackageLibraryCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 3, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "pkg in_srcjar");
        }
        setVarScalar(interp, "pkg", objv[1], compiledLocals, 0);
        setVarScalar(interp, "in_srcjar", objv[2], compiledLocals, 1);
        { // Invoke: if {$pkg == "default"} ... else ...
            // Binary operator: $pkg == "default"
            TclObject tmp0 = getVarScalar(interp, "pkg", compiledLocals, 0);
            boolean tmp1 = tmp0.toString().equals("default");
            ExprValue tmp2 = evs0;
            tmp2.setIntValue(tmp1);
            // End Binary operator: ==
            boolean tmp3 = ( tmp2.getIntValue() != 0 );
            if ( tmp3 ) {
                { // Invoke: if {$in_srcjar} ... else ...
                    TclObject tmp4 = getVarScalar(interp, "in_srcjar", compiledLocals, 1);
                    boolean tmp5 = TJC.getBoolean(interp, tmp4);
                    if ( tmp5 ) {
                        { // Invoke: return "default/library"
                            interp.resetResult();
                            interp.setResult(const0);
                            if ( true ) { return; }
                        } // End Invoke: return
                    } else {
                        { // Invoke: return "library"
                            interp.resetResult();
                            interp.setResult(const1);
                            if ( true ) { return; }
                        } // End Invoke: return
                    }
                } // End Invoke: if
            } else {
                { // Invoke: set elems [...]
                    TclObject tmp6;
                    { // Invoke: split $pkg .
                        TclObject[] objv7 = TJC.grabObjv(interp, 3);
                        TclObject tmp8;
                        try {
                            // Arg 0 constant: split
                            objv7[0] = const2;
                            // Arg 1 variable: $pkg
                            tmp8 = getVarScalar(interp, "pkg", compiledLocals, 0);
                            tmp8.preserve();
                            objv7[1] = tmp8;
                            // Arg 2 constant: .
                            objv7[2] = const3;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv7, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            tmp8 = objv7[1];
                            if ( tmp8 != null ) {
                                tmp8.release();
                            }
                            TJC.releaseObjv(interp, objv7, 3);
                        }
                    } // End Invoke: split
                    tmp6 = interp.getResult();
                    setVarScalar(interp, "elems", tmp6, compiledLocals, 2);
                } // End Invoke: set
                { // Invoke: return [...]
                    { // Invoke: eval {file join} $elems library
                        TclObject[] objv9 = TJC.grabObjv(interp, 4);
                        TclObject tmp10;
                        try {
                            // Arg 0 constant: eval
                            objv9[0] = const4;
                            // Arg 1 constant: {file join}
                            objv9[1] = const5;
                            // Arg 2 variable: $elems
                            tmp10 = getVarScalar(interp, "elems", compiledLocals, 2);
                            tmp10.preserve();
                            objv9[2] = tmp10;
                            // Arg 3 constant: library
                            objv9[3] = const1;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv9, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp10 = objv9[2];
                            if ( tmp10 != null ) {
                                tmp10.release();
                            }
                            TJC.releaseObjv(interp, objv9, 4);
                        }
                    } // End Invoke: eval
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "jdk_package_library");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("default/library");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("library");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("split");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance(".");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("eval");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("file join");
        const5.preserve(); const5.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "split";
                break;
            }
            case 2: {
                cmdName = "eval";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "pkg",
        "in_srcjar",
        "elems"
    };
} // end class JdkPackageLibraryCmd

