// TJC implementation of procedure module_space_split
package tjc;
import tcl.lang.*;

public class ModuleSpaceSplitCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 6, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "str");
        }
        setVarScalar(interp, "str", objv[1], compiledLocals, 0);
        { // Invoke: set pat {[^ ]+}
            setVarScalar(interp, "pat", const0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: set results [...]
            TclObject tmp0;
            { // Invoke: list
                TclObject tmp1 = TclList.newInstance();
                interp.setResult(tmp1);
            } // End Invoke: list
            tmp0 = interp.getResult();
            setVarScalar(interp, "results", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: while {1} ...
            for ( ; true ; ) {
                try {
                if ( false ) { throw (TclException) null; }
                { // Invoke: if ... ...
                    // Unary operator: ! [...]
                    { // Invoke: regexp -indices $pat $str whole
                        TclObject[] objv2 = TJC.grabObjv(interp, 5);
                        TclObject tmp3;
                        try {
                            // Arg 0 constant: regexp
                            objv2[0] = const1;
                            // Arg 1 constant: -indices
                            objv2[1] = const2;
                            // Arg 2 variable: $pat
                            tmp3 = getVarScalar(interp, "pat", compiledLocals, 1);
                            tmp3.preserve();
                            objv2[2] = tmp3;
                            // Arg 3 variable: $str
                            tmp3 = getVarScalar(interp, "str", compiledLocals, 0);
                            tmp3.preserve();
                            objv2[3] = tmp3;
                            // Arg 4 constant: whole
                            objv2[4] = const3;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv2, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            tmp3 = objv2[2];
                            if ( tmp3 != null ) {
                                tmp3.release();
                            }
                            tmp3 = objv2[3];
                            if ( tmp3 != null ) {
                                tmp3.release();
                            }
                            TJC.releaseObjv(interp, objv2, 5);
                        }
                    } // End Invoke: regexp
                    TclObject tmp4 = interp.getResult();
                    ExprValue tmp5 = evs0;
                    if ( tmp4.isIntType() ) {
                        TJC.exprUnaryNotOperatorKnownInt(tmp5, tmp4);
                    } else {
                        TJC.exprUnaryNotOperator(interp, tmp5, tmp4);
                    }
                    // End Unary operator: !
                    boolean tmp6 = ( tmp5.getIntValue() != 0 );
                    if ( tmp6 ) {
                        { // Invoke: break
                            if ( true ) { break; }
                        } // End Invoke: break
                    }
                } // End Invoke: if
                { // Invoke: set i1 [...]
                    TclObject tmp7;
                    { // Invoke: lindex $whole 0
                        TclObject tmp8 = getVarScalar(interp, "whole", compiledLocals, 3);
                        tmp8 = TclList.index(interp, tmp8, 0);
                        if ( tmp8 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp8);
                        }
                    } // End Invoke: lindex
                    tmp7 = interp.getResult();
                    setVarScalar(interp, "i1", tmp7, compiledLocals, 4);
                } // End Invoke: set
                { // Invoke: set i2 [...]
                    TclObject tmp9;
                    { // Invoke: lindex $whole 1
                        TclObject tmp10 = getVarScalar(interp, "whole", compiledLocals, 3);
                        tmp10 = TclList.index(interp, tmp10, 1);
                        if ( tmp10 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp10);
                        }
                    } // End Invoke: lindex
                    tmp9 = interp.getResult();
                    setVarScalar(interp, "i2", tmp9, compiledLocals, 5);
                } // End Invoke: set
                { // Invoke: lappend results [...]
                    TclObject[] objv11 = TJC.grabObjv(interp, 1);
                    TclObject tmp12;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: string range $str $i1 $i2
                            TclObject tmp13 = getVarScalar(interp, "str", compiledLocals, 0);
                            String tmp14 = tmp13.toString();
                            TclObject tmp15 = getVarScalar(interp, "i1", compiledLocals, 4);
                            tmp15.preserve();
                            TclObject tmp16 = getVarScalar(interp, "i2", compiledLocals, 5);
                            TclObject tmp17 = TJC.stringRange(interp, tmp14, tmp15, tmp16);
                            interp.setResult(tmp17);
                        } // End Invoke: string
                        tmp12 = interp.getResult();
                        tmp12.preserve();
                        objv11[0] = tmp12;
                        interp.resetResult();
                        lappendVarScalar(interp, "results", objv11, compiledLocals, 2);
                    } finally {
                        TJC.releaseObjvElems(interp, objv11, 1);
                    }
                } // End Invoke: lappend
                { // Invoke: set str [...]
                    TclObject tmp18;
                    { // Invoke: string range $str [...] end
                        TclObject tmp19 = getVarScalar(interp, "str", compiledLocals, 0);
                        String tmp20 = tmp19.toString();
                        { // Invoke: expr {$i2 + 1}
                            // Binary operator: $i2 + 1
                            TclObject tmp22 = getVarScalar(interp, "i2", compiledLocals, 5);
                            ExprValue tmp23 = evs0;
                            TJC.exprInitValue(interp, tmp23, tmp22);
                            ExprValue tmp24 = evs1;
                            tmp24.setIntValue(1);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp23, tmp24);
                            // End Binary operator: +
                            TJC.exprSetResult(interp, tmp23);
                        } // End Invoke: expr
                        TclObject tmp21 = interp.getResult();
                        tmp21.preserve();
                        TclObject tmp25 = const4;
                        TclObject tmp26 = TJC.stringRange(interp, tmp20, tmp21, tmp25);
                        interp.setResult(tmp26);
                    } // End Invoke: string
                    tmp18 = interp.getResult();
                    setVarScalar(interp, "str", tmp18, compiledLocals, 0);
                } // End Invoke: set
                } catch (TclException ex) {
                    int type = ex.getCompletionCode();
                    if (type == TCL.BREAK) {
                        break;
                    } else if (type == TCL.CONTINUE) {
                        continue;
                    } else {
                        throw ex;
                    }
                }
            }
        } // End Invoke: while
        { // Invoke: return $results
            TclObject tmp27 = getVarScalar(interp, "results", compiledLocals, 2);
            interp.resetResult();
            interp.setResult(tmp27);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "module_space_split");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("[^ ]+");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("regexp");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("-indices");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("whole");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("end");
        const4.preserve(); const4.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "regexp";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "str",
        "pat",
        "results",
        "whole",
        "i1",
        "i2"
    };
} // end class ModuleSpaceSplitCmd

