// TJC implementation of procedure parse_get_simple_text
package tjc;
import tcl.lang.*;

public class ParseGetSimpleTextCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 4, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length < 3 || objv.length > 4) {
            throw new TclNumArgsException(interp, 1, objv, "script stree ?rtype?");
        }
        setVarScalar(interp, "script", objv[1], compiledLocals, 0);
        setVarScalar(interp, "stree", objv[2], compiledLocals, 1);
        setVarScalar(interp, "rtype", 
            ((objv.length <= 3) ? const0 : objv[3]), compiledLocals, 2);
        { // Invoke: if {$rtype == "simple"} ... elseif {$rtype == "text"} ... else ...
            // Binary operator: $rtype == "simple"
            TclObject tmp0 = getVarScalar(interp, "rtype", compiledLocals, 2);
            boolean tmp1 = tmp0.toString().equals("simple");
            ExprValue tmp2 = evs0;
            tmp2.setIntValue(tmp1);
            // End Binary operator: ==
            boolean tmp3 = ( tmp2.getIntValue() != 0 );
            if ( tmp3 ) {
                { // Invoke: set range [...]
                    TclObject tmp4;
                    { // Invoke: lindex $stree 1
                        TclObject tmp5 = getVarScalar(interp, "stree", compiledLocals, 1);
                        tmp5 = TclList.index(interp, tmp5, 1);
                        if ( tmp5 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp5);
                        }
                    } // End Invoke: lindex
                    tmp4 = interp.getResult();
                    setVarScalar(interp, "range", tmp4, compiledLocals, 3);
                } // End Invoke: set
            } else {
                // Binary operator: $rtype == "text"
                TclObject tmp6 = getVarScalar(interp, "rtype", compiledLocals, 2);
                boolean tmp7 = tmp6.toString().equals("text");
                ExprValue tmp8 = evs0;
                tmp8.setIntValue(tmp7);
                // End Binary operator: ==
                boolean tmp9 = ( tmp8.getIntValue() != 0 );
                if ( tmp9 ) {
                    { // Invoke: set range [...]
                        TclObject tmp10;
                        { // Invoke: lindex $stree 2 0 1
                            TclObject[] objv11 = TJC.grabObjv(interp, 5);
                            TclObject tmp12;
                            try {
                                // Arg 0 constant: lindex
                                objv11[0] = const1;
                                // Arg 1 variable: $stree
                                tmp12 = getVarScalar(interp, "stree", compiledLocals, 1);
                                tmp12.preserve();
                                objv11[1] = tmp12;
                                // Arg 2 constant: 2
                                objv11[2] = const2;
                                // Arg 3 constant: 0
                                objv11[3] = const3;
                                // Arg 4 constant: 1
                                objv11[4] = const4;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv11, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                tmp12 = objv11[1];
                                if ( tmp12 != null ) {
                                    tmp12.release();
                                }
                                TJC.releaseObjv(interp, objv11, 5);
                            }
                        } // End Invoke: lindex
                        tmp10 = interp.getResult();
                        setVarScalar(interp, "range", tmp10, compiledLocals, 3);
                    } // End Invoke: set
                } else {
                    { // Invoke: error "..."
                        TclObject[] objv13 = TJC.grabObjv(interp, 2);
                        TclObject tmp14;
                        try {
                            // Arg 0 constant: error
                            objv13[0] = const5;
                            // Arg 1 word: "..."
                            StringBuffer sbtmp15 = new StringBuffer(64);
                            sbtmp15.append("unknown rtype ");
                            sbtmp15.append("\"");
                            tmp14 = getVarScalar(interp, "rtype", compiledLocals, 2);
                            sbtmp15.append(tmp14.toString());
                            sbtmp15.append("\"");
                            tmp14 = TclString.newInstance(sbtmp15);
                            tmp14.preserve();
                            objv13[1] = tmp14;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv13, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp14 = objv13[1];
                            if ( tmp14 != null ) {
                                tmp14.release();
                            }
                            TJC.releaseObjv(interp, objv13, 2);
                        }
                    } // End Invoke: error
                }
            }
        } // End Invoke: if
        { // Invoke: return [...]
            { // Invoke: parse getstring $script $range
                TclObject[] objv16 = TJC.grabObjv(interp, 4);
                TclObject tmp17;
                try {
                    // Arg 0 constant: parse
                    objv16[0] = const6;
                    // Arg 1 constant: getstring
                    objv16[1] = const7;
                    // Arg 2 variable: $script
                    tmp17 = getVarScalar(interp, "script", compiledLocals, 0);
                    tmp17.preserve();
                    objv16[2] = tmp17;
                    // Arg 3 variable: $range
                    tmp17 = getVarScalar(interp, "range", compiledLocals, 3);
                    tmp17.preserve();
                    objv16[3] = tmp17;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv16, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp17 = objv16[2];
                    if ( tmp17 != null ) {
                        tmp17.release();
                    }
                    tmp17 = objv16[3];
                    if ( tmp17 != null ) {
                        tmp17.release();
                    }
                    TJC.releaseObjv(interp, objv16, 4);
                }
            } // End Invoke: parse
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "parse_get_simple_text");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("simple");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("lindex");
        const1.preserve(); const1.preserve();
        const2 = TclInteger.newInstance(2);
        const2.preserve(); const2.preserve();
        const3 = TclInteger.newInstance(0);
        const3.preserve(); const3.preserve();
        const4 = TclInteger.newInstance(1);
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("error");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("parse");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("getstring");
        const7.preserve(); const7.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "lindex";
                break;
            }
            case 2: {
                cmdName = "error";
                break;
            }
            case 3: {
                cmdName = "parse";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "script",
        "stree",
        "rtype",
        "range"
    };
} // end class ParseGetSimpleTextCmd

