// TJC implementation of procedure parse_get_variable_list
package tjc;
import tcl.lang.*;

public class ParseGetVariableListCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 3, compiledLocalsNames);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "script stree");
        }
        setVarScalar(interp, "script", objv[1], compiledLocals, 0);
        setVarScalar(interp, "stree", objv[2], compiledLocals, 1);
        { // Invoke: global _parse
            TJC.makeGlobalLinkVar(interp, "_parse", "_parse", 2);
        } // End Invoke: global
        { // Invoke: set ... [...]
            TclObject tmp0;
            { // Invoke: list
                TclObject tmp1 = TclList.newInstance();
                interp.setResult(tmp1);
            } // End Invoke: list
            tmp0 = interp.getResult();
            setVarArray(interp, "_parse", "get_variable_list_results", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set ... [...]
            TclObject tmp2;
            { // Invoke: list
                TclObject tmp3 = TclList.newInstance();
                interp.setResult(tmp3);
            } // End Invoke: list
            tmp2 = interp.getResult();
            setVarArray(interp, "_parse", "get_variable_list_word", tmp2, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: ... $script $stree ...
            TclObject[] objv4 = TJC.grabObjv(interp, 4);
            TclObject tmp5;
            try {
                // Arg 0 constant: ...
                objv4[0] = const0;
                // Arg 1 variable: $script
                tmp5 = getVarScalar(interp, "script", compiledLocals, 0);
                tmp5.preserve();
                objv4[1] = tmp5;
                // Arg 2 variable: $stree
                tmp5 = getVarScalar(interp, "stree", compiledLocals, 1);
                tmp5.preserve();
                objv4[2] = tmp5;
                // Arg 3 constant: ...
                objv4[3] = const1;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                    ? cmdcache1.cmd : null), objv4, 0);
                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                    updateCmdCache(interp, 1);
                }
            } finally {
                tmp5 = objv4[1];
                if ( tmp5 != null ) {
                    tmp5.release();
                }
                tmp5 = objv4[2];
                if ( tmp5 != null ) {
                    tmp5.release();
                }
                TJC.releaseObjv(interp, objv4, 4);
            }
        } // End Invoke: ...
        { // Invoke: return $...
            TclObject tmp6 = getVarArray(interp, "_parse", "get_variable_list_results", compiledLocals, 2);
            interp.resetResult();
            interp.setResult(tmp6);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "parse_get_variable_list");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("parse_variable_iterate");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("_parse_get_variable_list_callback");
        const1.preserve(); const1.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "parse_variable_iterate";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "script",
        "stree",
        "_parse"
    };
} // end class ParseGetVariableListCmd

