// TJC implementation of procedure parse_variable_iterate
package tjc;
import tcl.lang.*;

public class ParseVariableIterateCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 13, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 4) {
            throw new TclNumArgsException(interp, 1, objv, "script stree cmd");
        }
        setVarScalar(interp, "script", objv[1], compiledLocals, 0);
        setVarScalar(interp, "stree", objv[2], compiledLocals, 1);
        setVarScalar(interp, "cmd", objv[3], compiledLocals, 2);
        { // Invoke: global _parse
            TJC.makeGlobalLinkVar(interp, "_parse", "_parse", 3);
        } // End Invoke: global
        { // Invoke: set saved_word_value [...]
            TclObject tmp0;
            { // Invoke: ...
                TclObject[] objv1 = TJC.grabObjv(interp, 1);
                try {
                    // Arg 0 constant: ...
                    objv1[0] = const0;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv1, 1);
                }
            } // End Invoke: ...
            tmp0 = interp.getResult();
            setVarScalar(interp, "saved_word_value", tmp0, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: foreach key [...] ...
            TclObject tmp2 = null;
            try {
                { // Invoke: array names _parse key*
                    TclObject[] objv3 = TJC.grabObjv(interp, 4);
                    try {
                        // Arg 0 constant: array
                        objv3[0] = const1;
                        // Arg 1 constant: names
                        objv3[1] = const2;
                        // Arg 2 constant: _parse
                        objv3[2] = const3;
                        // Arg 3 constant: key*
                        objv3[3] = const4;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv3, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv3, 4);
                    }
                } // End Invoke: array
                tmp2 = interp.getResult();
                tmp2.preserve();
                final int tmp2_length = TclList.getLength(interp, tmp2);

                for ( int index4 = 0 ; index4 < tmp2_length ; index4++ ) {
                    TclObject tmp5 = TclList.index(interp, tmp2, index4);
                    try {
                        setVarScalar(interp, "key", tmp5, compiledLocals, 5);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "key");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: unset _parse($key)
                        TclObject[] objv6 = TJC.grabObjv(interp, 2);
                        TclObject tmp7;
                        try {
                            // Arg 0 constant: unset
                            objv6[0] = const5;
                            // Arg 1 word: _parse($key)
                            StringBuffer sbtmp8 = new StringBuffer(64);
                            sbtmp8.append("_parse(");
                            tmp7 = getVarScalar(interp, "key", compiledLocals, 5);
                            sbtmp8.append(tmp7.toString());
                            sbtmp8.append(")");
                            tmp7 = TclString.newInstance(sbtmp8);
                            tmp7.preserve();
                            objv6[1] = tmp7;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv6, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp7 = objv6[1];
                            if ( tmp7 != null ) {
                                tmp7.release();
                            }
                            TJC.releaseObjv(interp, objv6, 2);
                        }
                    } // End Invoke: unset
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp2 != null ) {
                    tmp2.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: set key key0
            setVarScalar(interp, "key", const6, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set _parse($key) [...]
            TclObject tmp9;
            tmp9 = getVarScalar(interp, "key", compiledLocals, 5);
            String tmp11 = tmp9.toString();
            { // Invoke: list
                TclObject tmp10 = TclList.newInstance();
                interp.setResult(tmp10);
            } // End Invoke: list
            tmp9 = interp.getResult();
            tmp9 = setVarArray(interp, "_parse", tmp11, tmp9, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set ... [...]
            TclObject tmp12;
            { // Invoke: list $key
                TclObject tmp13 = TclList.newInstance();
                TclObject tmp14;
                tmp14 = getVarScalar(interp, "key", compiledLocals, 5);
                TclList.append(interp, tmp13, tmp14);
                interp.setResult(tmp13);
            } // End Invoke: list
            tmp12 = interp.getResult();
            setVarArray(interp, "_parse", "parse_variable_iterate_stack", tmp12, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set ... 1
            setVarArray(interp, "_parse", "parse_variable_iterate_key", const7, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: ... $script $stree $cmd [...]
            TclObject[] objv15 = TJC.grabObjv(interp, 5);
            TclObject tmp16;
            try {
                // Arg 0 constant: ...
                objv15[0] = const8;
                // Arg 1 variable: $script
                tmp16 = getVarScalar(interp, "script", compiledLocals, 0);
                tmp16.preserve();
                objv15[1] = tmp16;
                // Arg 2 variable: $stree
                tmp16 = getVarScalar(interp, "stree", compiledLocals, 1);
                tmp16.preserve();
                objv15[2] = tmp16;
                // Arg 3 variable: $cmd
                tmp16 = getVarScalar(interp, "cmd", compiledLocals, 2);
                tmp16.preserve();
                objv15[3] = tmp16;
                // Arg 4 command: [...]
                { // Invoke: list 0 $key
                    TclObject tmp17 = TclList.newInstance();
                    TclObject tmp18;
                    try {
                        TclList.append(interp, tmp17, const9);
                        tmp18 = getVarScalar(interp, "key", compiledLocals, 5);
                        TclList.append(interp, tmp17, tmp18);
                    } catch (TclException ex) {
                        tmp17.release();
                        throw ex;
                    }
                    interp.setResult(tmp17);
                } // End Invoke: list
                tmp16 = interp.getResult();
                tmp16.preserve();
                objv15[4] = tmp16;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                    ? cmdcache4.cmd : null), objv15, 0);
                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                    updateCmdCache(interp, 4);
                }
            } finally {
                tmp16 = objv15[1];
                if ( tmp16 != null ) {
                    tmp16.release();
                }
                tmp16 = objv15[2];
                if ( tmp16 != null ) {
                    tmp16.release();
                }
                tmp16 = objv15[3];
                if ( tmp16 != null ) {
                    tmp16.release();
                }
                tmp16 = objv15[4];
                if ( tmp16 != null ) {
                    tmp16.release();
                }
                TJC.releaseObjv(interp, objv15, 5);
            }
        } // End Invoke: ...
        { // Invoke: set cmdstack [...]
            TclObject tmp19;
            { // Invoke: list
                TclObject tmp20 = TclList.newInstance();
                interp.setResult(tmp20);
            } // End Invoke: list
            tmp19 = interp.getResult();
            setVarScalar(interp, "cmdstack", tmp19, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: foreach key $... ...
            TclObject tmp21 = null;
            try {
                tmp21 = getVarArray(interp, "_parse", "parse_variable_iterate_stack", compiledLocals, 3);
                tmp21.preserve();
                final int tmp21_length = TclList.getLength(interp, tmp21);

                for ( int index22 = 0 ; index22 < tmp21_length ; index22++ ) {
                    TclObject tmp23 = TclList.index(interp, tmp21, index22);
                    try {
                        setVarScalar(interp, "key", tmp23, compiledLocals, 5);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "key");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: set cmdlist $_parse($key)
                        TclObject tmp24;
                        tmp24 = getVarScalar(interp, "key", compiledLocals, 5);
                        tmp24 = getVarArray(interp, "_parse", tmp24.toString(), compiledLocals, 3);
                        setVarScalar(interp, "cmdlist", tmp24, compiledLocals, 7);
                    } // End Invoke: set
                    { // Invoke: lappend cmdstack $cmdlist
                        TclObject[] objv25 = TJC.grabObjv(interp, 1);
                        TclObject tmp26;
                        try {
                            // Arg 2 variable: $cmdlist
                            tmp26 = getVarScalar(interp, "cmdlist", compiledLocals, 7);
                            tmp26.preserve();
                            objv25[0] = tmp26;
                            interp.resetResult();
                            lappendVarScalar(interp, "cmdstack", objv25, compiledLocals, 6);
                        } finally {
                            TJC.releaseObjvElems(interp, objv25, 1);
                        }
                    } // End Invoke: lappend
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp21 != null ) {
                    tmp21.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: foreach key [...] ...
            TclObject tmp27 = null;
            try {
                { // Invoke: array names _parse key*
                    TclObject[] objv28 = TJC.grabObjv(interp, 4);
                    try {
                        // Arg 0 constant: array
                        objv28[0] = const1;
                        // Arg 1 constant: names
                        objv28[1] = const2;
                        // Arg 2 constant: _parse
                        objv28[2] = const3;
                        // Arg 3 constant: key*
                        objv28[3] = const4;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv28, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv28, 4);
                    }
                } // End Invoke: array
                tmp27 = interp.getResult();
                tmp27.preserve();
                final int tmp27_length = TclList.getLength(interp, tmp27);

                for ( int index29 = 0 ; index29 < tmp27_length ; index29++ ) {
                    TclObject tmp30 = TclList.index(interp, tmp27, index29);
                    try {
                        setVarScalar(interp, "key", tmp30, compiledLocals, 5);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "key");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: unset _parse($key)
                        TclObject[] objv31 = TJC.grabObjv(interp, 2);
                        TclObject tmp32;
                        try {
                            // Arg 0 constant: unset
                            objv31[0] = const5;
                            // Arg 1 word: _parse($key)
                            StringBuffer sbtmp33 = new StringBuffer(64);
                            sbtmp33.append("_parse(");
                            tmp32 = getVarScalar(interp, "key", compiledLocals, 5);
                            sbtmp33.append(tmp32.toString());
                            sbtmp33.append(")");
                            tmp32 = TclString.newInstance(sbtmp33);
                            tmp32.preserve();
                            objv31[1] = tmp32;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv31, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp32 = objv31[1];
                            if ( tmp32 != null ) {
                                tmp32.release();
                            }
                            TJC.releaseObjv(interp, objv31, 2);
                        }
                    } // End Invoke: unset
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp27 != null ) {
                    tmp27.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: set ... [...]
            TclObject tmp34;
            { // Invoke: list
                TclObject tmp35 = TclList.newInstance();
                interp.setResult(tmp35);
            } // End Invoke: list
            tmp34 = interp.getResult();
            setVarArray(interp, "_parse", "parse_variable_iterate_stack", tmp34, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set ... 0
            setVarArray(interp, "_parse", "parse_variable_iterate_key", const9, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: foreach cmdlist $cmdstack ...
            TclObject tmp36 = null;
            try {
                tmp36 = getVarScalar(interp, "cmdstack", compiledLocals, 6);
                tmp36.preserve();
                final int tmp36_length = TclList.getLength(interp, tmp36);

                for ( int index37 = 0 ; index37 < tmp36_length ; index37++ ) {
                    TclObject tmp38 = TclList.index(interp, tmp36, index37);
                    try {
                        setVarScalar(interp, "cmdlist", tmp38, compiledLocals, 7);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "cmdlist");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: foreach cmd $cmdlist ...
                        TclObject tmp39 = null;
                        try {
                            tmp39 = getVarScalar(interp, "cmdlist", compiledLocals, 7);
                            tmp39.preserve();
                            final int tmp39_length = TclList.getLength(interp, tmp39);

                            for ( int index40 = 0 ; index40 < tmp39_length ; index40++ ) {
                                TclObject tmp41 = TclList.index(interp, tmp39, index40);
                                try {
                                    setVarScalar(interp, "cmd", tmp41, compiledLocals, 2);
                                } catch (TclException ex) {
                                    TJC.foreachVarErr(interp, "cmd");
                                }

                                try {
                                if ( false ) { throw (TclException) null; }
                                { // Invoke: if ... ...
                                    // Binary operator: [...] != 6
                                    { // Invoke: llength $cmd
                                        TclObject tmp42 = getVarScalar(interp, "cmd", compiledLocals, 2);
                                        int tmp43 = TclList.getLength(interp, tmp42);
                                        interp.setResult(tmp43);
                                    } // End Invoke: llength
                                    TclObject tmp44 = interp.getResult();
                                    ExprValue tmp45 = evs0;
                                    TJC.exprInitValue(interp, tmp45, tmp44);
                                    ExprValue tmp46 = evs1;
                                    tmp46.setIntValue(6);
                                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp45, tmp46);
                                    // End Binary operator: !=
                                    boolean tmp47 = ( tmp45.getIntValue() != 0 );
                                    if ( tmp47 ) {
                                        { // Invoke: error "..."
                                            TclObject[] objv48 = TJC.grabObjv(interp, 2);
                                            TclObject tmp49;
                                            try {
                                                // Arg 0 constant: error
                                                objv48[0] = const10;
                                                // Arg 1 word: "..."
                                                StringBuffer sbtmp50 = new StringBuffer(64);
                                                sbtmp50.append("expected 6 arguments, callback format is CMD SCRIPT STREE TYPE VALUES RANGES but cmd was ");
                                                sbtmp50.append("{");
                                                tmp49 = getVarScalar(interp, "cmd", compiledLocals, 2);
                                                sbtmp50.append(tmp49.toString());
                                                sbtmp50.append("}");
                                                tmp49 = TclString.newInstance(sbtmp50);
                                                tmp49.preserve();
                                                objv48[1] = tmp49;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                                    ? cmdcache5.cmd : null), objv48, 0);
                                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                                    updateCmdCache(interp, 5);
                                                }
                                            } finally {
                                                tmp49 = objv48[1];
                                                if ( tmp49 != null ) {
                                                    tmp49.release();
                                                }
                                                TJC.releaseObjv(interp, objv48, 2);
                                            }
                                        } // End Invoke: error
                                    }
                                } // End Invoke: if
                                { // Invoke: set atype [...]
                                    TclObject tmp51;
                                    { // Invoke: lindex $cmd 3
                                        TclObject tmp52 = getVarScalar(interp, "cmd", compiledLocals, 2);
                                        tmp52 = TclList.index(interp, tmp52, 3);
                                        if ( tmp52 == null ) {
                                            interp.resetResult();
                                        } else {
                                            interp.setResult(tmp52);
                                        }
                                    } // End Invoke: lindex
                                    tmp51 = interp.getResult();
                                    setVarScalar(interp, "atype", tmp51, compiledLocals, 8);
                                } // End Invoke: set
                                { // Invoke: set avalues [...]
                                    TclObject tmp53;
                                    { // Invoke: lindex $cmd 4
                                        TclObject tmp54 = getVarScalar(interp, "cmd", compiledLocals, 2);
                                        tmp54 = TclList.index(interp, tmp54, 4);
                                        if ( tmp54 == null ) {
                                            interp.resetResult();
                                        } else {
                                            interp.setResult(tmp54);
                                        }
                                    } // End Invoke: lindex
                                    tmp53 = interp.getResult();
                                    setVarScalar(interp, "avalues", tmp53, compiledLocals, 9);
                                } // End Invoke: set
                                { // Invoke: if ... ... elseif ... ... elseif ... ...
                                    // Binary operator: $atype == "word begin"
                                    TclObject tmp55 = getVarScalar(interp, "atype", compiledLocals, 8);
                                    boolean tmp56 = tmp55.toString().equals("word begin");
                                    ExprValue tmp57 = evs0;
                                    tmp57.setIntValue(tmp56);
                                    // End Binary operator: ==
                                    boolean tmp58 = ( tmp57.getIntValue() != 0 );
                                    if ( tmp58 ) {
                                        { // Invoke: ... {}
                                            TclObject[] objv59 = TJC.grabObjv(interp, 2);
                                            try {
                                                // Arg 0 constant: ...
                                                objv59[0] = const0;
                                                // Arg 1 constant: {}
                                                objv59[1] = const11;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                                    ? cmdcache1.cmd : null), objv59, 0);
                                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                                    updateCmdCache(interp, 1);
                                                }
                                            } finally {
                                                TJC.releaseObjv(interp, objv59, 2);
                                            }
                                        } // End Invoke: ...
                                    } else {
                                        // Binary operator: $atype == "word end"
                                        TclObject tmp60 = getVarScalar(interp, "atype", compiledLocals, 8);
                                        boolean tmp61 = tmp60.toString().equals("word end");
                                        ExprValue tmp62 = evs0;
                                        tmp62.setIntValue(tmp61);
                                        // End Binary operator: ==
                                        boolean tmp63 = ( tmp62.getIntValue() != 0 );
                                        if ( tmp63 ) {
                                            { // Invoke: set word_value [...]
                                                TclObject tmp64;
                                                { // Invoke: ...
                                                    TclObject[] objv65 = TJC.grabObjv(interp, 1);
                                                    try {
                                                        // Arg 0 constant: ...
                                                        objv65[0] = const0;
                                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                            updateCmdCache(interp, 0);
                                                        }
                                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                                            ? cmdcache1.cmd : null), objv65, 0);
                                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                                            updateCmdCache(interp, 1);
                                                        }
                                                    } finally {
                                                        TJC.releaseObjv(interp, objv65, 1);
                                                    }
                                                } // End Invoke: ...
                                                tmp64 = interp.getResult();
                                                setVarScalar(interp, "word_value", tmp64, compiledLocals, 10);
                                            } // End Invoke: set
                                        } else {
                                            // Binary operator: [...] != ()
                                            { // Invoke: string first __WORD_VALUE__ $avalues
                                                String tmp66 = "__WORD_VALUE__";
                                                TclObject tmp67 = getVarScalar(interp, "avalues", compiledLocals, 9);
                                                String tmp68 = tmp67.toString();
                                                int tmp69 = tmp68.indexOf(tmp66);
                                                interp.setResult(tmp69);
                                            } // End Invoke: string
                                            TclObject tmp70 = interp.getResult();
                                            ExprValue tmp71 = evs0;
                                            TJC.exprInitValue(interp, tmp71, tmp70);
                                            // Unary operator: - 1
                                            ExprValue tmp72 = evs1;
                                            tmp72.setIntValue(-1);
                                            // End Unary operator: -
                                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp71, tmp72);
                                            // End Binary operator: !=
                                            boolean tmp73 = ( tmp71.getIntValue() != 0 );
                                            if ( tmp73 ) {
                                                { // Invoke: if ... ...
                                                    // Unary operator: ! [...]
                                                    { // Invoke: info exists word_value
                                                        TclObject[] objv74 = TJC.grabObjv(interp, 3);
                                                        try {
                                                            // Arg 0 constant: info
                                                            objv74[0] = const12;
                                                            // Arg 1 constant: exists
                                                            objv74[1] = const13;
                                                            // Arg 2 constant: word_value
                                                            objv74[2] = const14;
                                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                updateCmdCache(interp, 0);
                                                            }
                                                            TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                                                ? cmdcache6.cmd : null), objv74, 0);
                                                            if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                                                updateCmdCache(interp, 6);
                                                            }
                                                        } finally {
                                                            TJC.releaseObjv(interp, objv74, 3);
                                                        }
                                                    } // End Invoke: info
                                                    TclObject tmp75 = interp.getResult();
                                                    ExprValue tmp76 = evs0;
                                                    if ( tmp75.isIntType() ) {
                                                        TJC.exprUnaryNotOperatorKnownInt(tmp76, tmp75);
                                                    } else {
                                                        TJC.exprUnaryNotOperator(interp, tmp76, tmp75);
                                                    }
                                                    // End Unary operator: !
                                                    boolean tmp77 = ( tmp76.getIntValue() != 0 );
                                                    if ( tmp77 ) {
                                                        { // Invoke: error ...
                                                            TclObject[] objv78 = TJC.grabObjv(interp, 2);
                                                            try {
                                                                // Arg 0 constant: error
                                                                objv78[0] = const10;
                                                                // Arg 1 constant: ...
                                                                objv78[1] = const15;
                                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                    updateCmdCache(interp, 0);
                                                                }
                                                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                                                    ? cmdcache5.cmd : null), objv78, 0);
                                                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                                                    updateCmdCache(interp, 5);
                                                                }
                                                            } finally {
                                                                TJC.releaseObjv(interp, objv78, 2);
                                                            }
                                                        } // End Invoke: error
                                                    }
                                                } // End Invoke: if
                                                { // Invoke: if {$word_value == {}} ... else ...
                                                    // Binary operator: $word_value == ""
                                                    TclObject tmp79 = getVarScalar(interp, "word_value", compiledLocals, 10);
                                                    ExprValue tmp80 = evs0;
                                                    TJC.exprEqualsEmptyString(tmp80, tmp79, false);
                                                    // End Binary operator: ==
                                                    boolean tmp81 = ( tmp80.getIntValue() != 0 );
                                                    if ( tmp81 ) {
                                                        { // Invoke: set new_avalues [...]
                                                            TclObject tmp82;
                                                            { // Invoke: string map ... $avalues
                                                                TclObject[] objv83 = TJC.grabObjv(interp, 4);
                                                                TclObject tmp84;
                                                                try {
                                                                    // Arg 0 constant: string
                                                                    objv83[0] = const16;
                                                                    // Arg 1 constant: map
                                                                    objv83[1] = const17;
                                                                    // Arg 2 constant: ...
                                                                    objv83[2] = const18;
                                                                    // Arg 3 variable: $avalues
                                                                    tmp84 = getVarScalar(interp, "avalues", compiledLocals, 9);
                                                                    tmp84.preserve();
                                                                    objv83[3] = tmp84;
                                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                        updateCmdCache(interp, 0);
                                                                    }
                                                                    TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                                                        ? cmdcache7.cmd : null), objv83, 0);
                                                                    if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                                                        updateCmdCache(interp, 7);
                                                                    }
                                                                } finally {
                                                                    tmp84 = objv83[3];
                                                                    if ( tmp84 != null ) {
                                                                        tmp84.release();
                                                                    }
                                                                    TJC.releaseObjv(interp, objv83, 4);
                                                                }
                                                            } // End Invoke: string
                                                            tmp82 = interp.getResult();
                                                            setVarScalar(interp, "new_avalues", tmp82, compiledLocals, 11);
                                                        } // End Invoke: set
                                                    } else {
                                                        { // Invoke: set word_value [...]
                                                            TclObject tmp85;
                                                            { // Invoke: list $word_value
                                                                TclObject tmp86 = TclList.newInstance();
                                                                TclObject tmp87;
                                                                tmp87 = getVarScalar(interp, "word_value", compiledLocals, 10);
                                                                TclList.append(interp, tmp86, tmp87);
                                                                interp.setResult(tmp86);
                                                            } // End Invoke: list
                                                            tmp85 = interp.getResult();
                                                            setVarScalar(interp, "word_value", tmp85, compiledLocals, 10);
                                                        } // End Invoke: set
                                                        { // Invoke: set new_avalues [...]
                                                            TclObject tmp88;
                                                            { // Invoke: string map [...] $avalues
                                                                TclObject[] objv89 = TJC.grabObjv(interp, 4);
                                                                TclObject tmp90;
                                                                try {
                                                                    // Arg 0 constant: string
                                                                    objv89[0] = const16;
                                                                    // Arg 1 constant: map
                                                                    objv89[1] = const17;
                                                                    // Arg 2 command: [...]
                                                                    { // Invoke: list __WORD_VALUE__ $word_value
                                                                        TclObject tmp91 = TclList.newInstance();
                                                                        TclObject tmp92;
                                                                        try {
                                                                            TclList.append(interp, tmp91, const19);
                                                                            tmp92 = getVarScalar(interp, "word_value", compiledLocals, 10);
                                                                            TclList.append(interp, tmp91, tmp92);
                                                                        } catch (TclException ex) {
                                                                            tmp91.release();
                                                                            throw ex;
                                                                        }
                                                                        interp.setResult(tmp91);
                                                                    } // End Invoke: list
                                                                    tmp90 = interp.getResult();
                                                                    tmp90.preserve();
                                                                    objv89[2] = tmp90;
                                                                    // Arg 3 variable: $avalues
                                                                    tmp90 = getVarScalar(interp, "avalues", compiledLocals, 9);
                                                                    tmp90.preserve();
                                                                    objv89[3] = tmp90;
                                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                        updateCmdCache(interp, 0);
                                                                    }
                                                                    TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                                                        ? cmdcache7.cmd : null), objv89, 0);
                                                                    if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                                                        updateCmdCache(interp, 7);
                                                                    }
                                                                } finally {
                                                                    tmp90 = objv89[2];
                                                                    if ( tmp90 != null ) {
                                                                        tmp90.release();
                                                                    }
                                                                    tmp90 = objv89[3];
                                                                    if ( tmp90 != null ) {
                                                                        tmp90.release();
                                                                    }
                                                                    TJC.releaseObjv(interp, objv89, 4);
                                                                }
                                                            } // End Invoke: string
                                                            tmp88 = interp.getResult();
                                                            setVarScalar(interp, "new_avalues", tmp88, compiledLocals, 11);
                                                        } // End Invoke: set
                                                    }
                                                } // End Invoke: if
                                                { // Invoke: set new_cmd [...]
                                                    TclObject tmp93;
                                                    { // Invoke: lrange $cmd 0 3
                                                        TclObject[] objv94 = TJC.grabObjv(interp, 4);
                                                        TclObject tmp95;
                                                        try {
                                                            // Arg 0 constant: lrange
                                                            objv94[0] = const20;
                                                            // Arg 1 variable: $cmd
                                                            tmp95 = getVarScalar(interp, "cmd", compiledLocals, 2);
                                                            tmp95.preserve();
                                                            objv94[1] = tmp95;
                                                            // Arg 2 constant: 0
                                                            objv94[2] = const9;
                                                            // Arg 3 constant: 3
                                                            objv94[3] = const21;
                                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                updateCmdCache(interp, 0);
                                                            }
                                                            TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                                                ? cmdcache8.cmd : null), objv94, 0);
                                                            if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                                                updateCmdCache(interp, 8);
                                                            }
                                                        } finally {
                                                            tmp95 = objv94[1];
                                                            if ( tmp95 != null ) {
                                                                tmp95.release();
                                                            }
                                                            TJC.releaseObjv(interp, objv94, 4);
                                                        }
                                                    } // End Invoke: lrange
                                                    tmp93 = interp.getResult();
                                                    setVarScalar(interp, "new_cmd", tmp93, compiledLocals, 12);
                                                } // End Invoke: set
                                                { // Invoke: lappend new_cmd $new_avalues
                                                    TclObject[] objv96 = TJC.grabObjv(interp, 1);
                                                    TclObject tmp97;
                                                    try {
                                                        // Arg 2 variable: $new_avalues
                                                        tmp97 = getVarScalar(interp, "new_avalues", compiledLocals, 11);
                                                        tmp97.preserve();
                                                        objv96[0] = tmp97;
                                                        interp.resetResult();
                                                        lappendVarScalar(interp, "new_cmd", objv96, compiledLocals, 12);
                                                    } finally {
                                                        TJC.releaseObjvElems(interp, objv96, 1);
                                                    }
                                                } // End Invoke: lappend
                                                { // Invoke: lappend new_cmd [...]
                                                    TclObject[] objv98 = TJC.grabObjv(interp, 1);
                                                    TclObject tmp99;
                                                    try {
                                                        // Arg 2 command: [...]
                                                        { // Invoke: lindex $cmd 5
                                                            TclObject tmp100 = getVarScalar(interp, "cmd", compiledLocals, 2);
                                                            tmp100 = TclList.index(interp, tmp100, 5);
                                                            if ( tmp100 == null ) {
                                                                interp.resetResult();
                                                            } else {
                                                                interp.setResult(tmp100);
                                                            }
                                                        } // End Invoke: lindex
                                                        tmp99 = interp.getResult();
                                                        tmp99.preserve();
                                                        objv98[0] = tmp99;
                                                        interp.resetResult();
                                                        lappendVarScalar(interp, "new_cmd", objv98, compiledLocals, 12);
                                                    } finally {
                                                        TJC.releaseObjvElems(interp, objv98, 1);
                                                    }
                                                } // End Invoke: lappend
                                                { // Invoke: set cmd $new_cmd
                                                    TclObject tmp101;
                                                    tmp101 = getVarScalar(interp, "new_cmd", compiledLocals, 12);
                                                    setVarScalar(interp, "cmd", tmp101, compiledLocals, 2);
                                                } // End Invoke: set
                                            }
                                        }
                                    }
                                } // End Invoke: if
                                { // Invoke: namespace eval :: [...]
                                    TclObject[] objv102 = TJC.grabObjv(interp, 4);
                                    TclObject tmp103;
                                    try {
                                        // Arg 0 constant: namespace
                                        objv102[0] = const22;
                                        // Arg 1 constant: eval
                                        objv102[1] = const23;
                                        // Arg 2 constant: ::
                                        objv102[2] = const24;
                                        // Arg 3 command: [...]
                                        { // Invoke: lrange $cmd 0 end
                                            TclObject[] objv104 = TJC.grabObjv(interp, 4);
                                            TclObject tmp105;
                                            try {
                                                // Arg 0 constant: lrange
                                                objv104[0] = const20;
                                                // Arg 1 variable: $cmd
                                                tmp105 = getVarScalar(interp, "cmd", compiledLocals, 2);
                                                tmp105.preserve();
                                                objv104[1] = tmp105;
                                                // Arg 2 constant: 0
                                                objv104[2] = const9;
                                                // Arg 3 constant: end
                                                objv104[3] = const25;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                                    ? cmdcache8.cmd : null), objv104, 0);
                                                if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                                    updateCmdCache(interp, 8);
                                                }
                                            } finally {
                                                tmp105 = objv104[1];
                                                if ( tmp105 != null ) {
                                                    tmp105.release();
                                                }
                                                TJC.releaseObjv(interp, objv104, 4);
                                            }
                                        } // End Invoke: lrange
                                        tmp103 = interp.getResult();
                                        tmp103.preserve();
                                        objv102[3] = tmp103;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                            ? cmdcache9.cmd : null), objv102, 0);
                                        if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                            updateCmdCache(interp, 9);
                                        }
                                    } finally {
                                        tmp103 = objv102[3];
                                        if ( tmp103 != null ) {
                                            tmp103.release();
                                        }
                                        TJC.releaseObjv(interp, objv102, 4);
                                    }
                                } // End Invoke: namespace
                                } catch (TclException ex) {
                                    int type = ex.getCompletionCode();
                                    if (type == TCL.BREAK) {
                                        break;
                                    } else if (type == TCL.CONTINUE) {
                                        continue;
                                    } else {
                                        throw ex;
                                    }
                                }
                            }
                        } finally {
                            if ( tmp39 != null ) {
                                tmp39.release();
                            }
                        }
                    } // End Invoke: foreach
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp36 != null ) {
                    tmp36.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: ... $saved_word_value
            TclObject[] objv106 = TJC.grabObjv(interp, 2);
            TclObject tmp107;
            try {
                // Arg 0 constant: ...
                objv106[0] = const0;
                // Arg 1 variable: $saved_word_value
                tmp107 = getVarScalar(interp, "saved_word_value", compiledLocals, 4);
                tmp107.preserve();
                objv106[1] = tmp107;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                    ? cmdcache1.cmd : null), objv106, 0);
                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                    updateCmdCache(interp, 1);
                }
            } finally {
                tmp107 = objv106[1];
                if ( tmp107 != null ) {
                    tmp107.release();
                }
                TJC.releaseObjv(interp, objv106, 2);
            }
        } // End Invoke: ...
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "parse_variable_iterate");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;
    TclObject const21;
    TclObject const22;
    TclObject const23;
    TclObject const24;
    TclObject const25;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("parse_variable_iterate_word_value");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("array");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("names");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("_parse");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("key*");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("unset");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("key0");
        const6.preserve(); const6.preserve();
        const7 = TclInteger.newInstance(1);
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("_parse_variable_iterate");
        const8.preserve(); const8.preserve();
        const9 = TclInteger.newInstance(0);
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("error");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("info");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("exists");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("word_value");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("__WORD_VALUE__ placeholder found with no previous {word begin/end}");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("string");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("map");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("__WORD_VALUE__ {{}}");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance("__WORD_VALUE__");
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance("lrange");
        const20.preserve(); const20.preserve();
        const21 = TclInteger.newInstance(3);
        const21.preserve(); const21.preserve();
        const22 = TclString.newInstance("namespace");
        const22.preserve(); const22.preserve();
        const23 = TclString.newInstance("eval");
        const23.preserve(); const23.preserve();
        const24 = TclString.newInstance("::");
        const24.preserve(); const24.preserve();
        const25 = TclString.newInstance("end");
        const25.preserve(); const25.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "parse_variable_iterate_word_value";
                break;
            }
            case 2: {
                cmdName = "array";
                break;
            }
            case 3: {
                cmdName = "unset";
                break;
            }
            case 4: {
                cmdName = "_parse_variable_iterate";
                break;
            }
            case 5: {
                cmdName = "error";
                break;
            }
            case 6: {
                cmdName = "info";
                break;
            }
            case 7: {
                cmdName = "string";
                break;
            }
            case 8: {
                cmdName = "lrange";
                break;
            }
            case 9: {
                cmdName = "namespace";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "script",
        "stree",
        "cmd",
        "_parse",
        "saved_word_value",
        "key",
        "cmdstack",
        "cmdlist",
        "atype",
        "avalues",
        "word_value",
        "new_avalues",
        "new_cmd"
    };
} // end class ParseVariableIterateCmd

