// TJC implementation of procedure parse_variable_iterate_word_value
package tjc;
import tcl.lang.*;

public class ParseVariableIterateWordValueCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 2, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length > 2) {
            throw new TclNumArgsException(interp, 1, objv, "?value?");
        }
        setVarScalar(interp, "value", 
            ((objv.length <= 1) ? const0 : objv[1]), compiledLocals, 0);
        { // Invoke: global _parse
            TJC.makeGlobalLinkVar(interp, "_parse", "_parse", 1);
        } // End Invoke: global
        { // Invoke: if ... ...
            // Binary operator: $value == "pviwv_QUERY"
            TclObject tmp0 = getVarScalar(interp, "value", compiledLocals, 0);
            boolean tmp1 = tmp0.toString().equals("pviwv_QUERY");
            ExprValue tmp2 = evs0;
            tmp2.setIntValue(tmp1);
            // End Binary operator: ==
            boolean tmp3 = ( tmp2.getIntValue() != 0 );
            if ( tmp3 ) {
                { // Invoke: if ... ...
                    // Unary operator: ! [...]
                    { // Invoke: info exists ...
                        TclObject[] objv4 = TJC.grabObjv(interp, 3);
                        try {
                            // Arg 0 constant: info
                            objv4[0] = const1;
                            // Arg 1 constant: exists
                            objv4[1] = const2;
                            // Arg 2 constant: ...
                            objv4[2] = const3;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv4, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv4, 3);
                        }
                    } // End Invoke: info
                    TclObject tmp5 = interp.getResult();
                    ExprValue tmp6 = evs0;
                    if ( tmp5.isIntType() ) {
                        TJC.exprUnaryNotOperatorKnownInt(tmp6, tmp5);
                    } else {
                        TJC.exprUnaryNotOperator(interp, tmp6, tmp5);
                    }
                    // End Unary operator: !
                    boolean tmp7 = ( tmp6.getIntValue() != 0 );
                    if ( tmp7 ) {
                        { // Invoke: set ... {}
                            setVarArray(interp, "_parse", "parse_variable_iterate_word_value", const4, compiledLocals, 1);
                        } // End Invoke: set
                    }
                } // End Invoke: if
                { // Invoke: return $...
                    TclObject tmp8 = getVarArray(interp, "_parse", "parse_variable_iterate_word_value", compiledLocals, 1);
                    interp.resetResult();
                    interp.setResult(tmp8);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set ... $value
            TclObject tmp9;
            tmp9 = getVarScalar(interp, "value", compiledLocals, 0);
            setVarArray(interp, "_parse", "parse_variable_iterate_word_value", tmp9, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: return
            interp.resetResult();
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "parse_variable_iterate_word_value");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("pviwv_QUERY");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("info");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("exists");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("_parse(parse_variable_iterate_word_value)");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("");
        const4.preserve(); const4.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "info";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "value",
        "_parse"
    };
} // end class ParseVariableIterateWordValueCmd

