// TJC implementation of procedure pizzaCompile
package tjc;
import tcl.lang.*;

public class PizzaCompileCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 30, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "filename srccode");
        }
        setVarScalar(interp, "filename", objv[1], compiledLocals, 0);
        setVarScalar(interp, "srccode", objv[2], compiledLocals, 1);
        { // Invoke: global JAVA_INIT
            TJC.makeGlobalLinkVar(interp, "JAVA_INIT", "JAVA_INIT", 2);
        } // End Invoke: global
        { // Invoke: global env
            TJC.makeGlobalLinkVar(interp, "env", "env", 3);
        } // End Invoke: global
        { // Invoke: if {!$JAVA_INIT} ...
            // Unary operator: ! $JAVA_INIT
            TclObject tmp0 = getVarScalar(interp, "JAVA_INIT", compiledLocals, 2);
            ExprValue tmp1 = evs0;
            if ( tmp0.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp1, tmp0);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp1, tmp0);
            }
            // End Unary operator: !
            boolean tmp2 = ( tmp1.getIntValue() != 0 );
            if ( tmp2 ) {
                { // Invoke: error ...
                    TclObject[] objv3 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv3[0] = const0;
                        // Arg 1 constant: ...
                        objv3[1] = const1;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv3, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv3, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: if {$filename == ""} ...
            // Binary operator: $filename == ""
            TclObject tmp4 = getVarScalar(interp, "filename", compiledLocals, 0);
            ExprValue tmp5 = evs0;
            TJC.exprEqualsEmptyString(tmp5, tmp4, false);
            // End Binary operator: ==
            boolean tmp6 = ( tmp5.getIntValue() != 0 );
            if ( tmp6 ) {
                { // Invoke: error ...
                    TclObject[] objv7 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv7[0] = const0;
                        // Arg 1 constant: ...
                        objv7[1] = const2;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv7, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv7, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set pizza ...
            setVarScalar(interp, "pizza", const3, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set util java.util
            setVarScalar(interp, "util", const4, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set io java.io
            setVarScalar(interp, "io", const5, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set tcl tcl.lang
            setVarScalar(interp, "tcl", const6, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: set sourceHash [...]
            TclObject tmp8;
            { // Invoke: java::new $util.HashMap
                TclObject[] objv9 = TJC.grabObjv(interp, 2);
                TclObject tmp10;
                try {
                    // Arg 0 constant: java::new
                    objv9[0] = const7;
                    // Arg 1 word: $util.HashMap
                    StringBuffer sbtmp11 = new StringBuffer(64);
                    tmp10 = getVarScalar(interp, "util", compiledLocals, 5);
                    sbtmp11.append(tmp10.toString());
                    sbtmp11.append(".HashMap");
                    tmp10 = TclString.newInstance(sbtmp11);
                    tmp10.preserve();
                    objv9[1] = tmp10;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv9, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp10 = objv9[1];
                    if ( tmp10 != null ) {
                        tmp10.release();
                    }
                    TJC.releaseObjv(interp, objv9, 2);
                }
            } // End Invoke: java::new
            tmp8 = interp.getResult();
            setVarScalar(interp, "sourceHash", tmp8, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: $sourceHash put $filename $srccode
            TclObject[] objv12 = TJC.grabObjv(interp, 4);
            TclObject tmp13;
            try {
                // Arg 0 variable: $sourceHash
                tmp13 = getVarScalar(interp, "sourceHash", compiledLocals, 8);
                tmp13.preserve();
                objv12[0] = tmp13;
                // Arg 1 constant: put
                objv12[1] = const8;
                // Arg 2 variable: $filename
                tmp13 = getVarScalar(interp, "filename", compiledLocals, 0);
                tmp13.preserve();
                objv12[2] = tmp13;
                // Arg 3 variable: $srccode
                tmp13 = getVarScalar(interp, "srccode", compiledLocals, 1);
                tmp13.preserve();
                objv12[3] = tmp13;
                TJC.invoke(interp, null, objv12, 0);
            } finally {
                tmp13 = objv12[0];
                if ( tmp13 != null ) {
                    tmp13.release();
                }
                tmp13 = objv12[2];
                if ( tmp13 != null ) {
                    tmp13.release();
                }
                tmp13 = objv12[3];
                if ( tmp13 != null ) {
                    tmp13.release();
                }
                TJC.releaseObjv(interp, objv12, 4);
            }
        } // End Invoke: ...
        { // Invoke: set compilerSource [...]
            TclObject tmp14;
            { // Invoke: java::new "..." $sourceHash
                TclObject[] objv15 = TJC.grabObjv(interp, 3);
                TclObject tmp16;
                try {
                    // Arg 0 constant: java::new
                    objv15[0] = const7;
                    // Arg 1 word: "..."
                    StringBuffer sbtmp17 = new StringBuffer(64);
                    tmp16 = getVarScalar(interp, "pizza", compiledLocals, 4);
                    sbtmp17.append(tmp16.toString());
                    sbtmp17.append(".MapSourceReader");
                    tmp16 = TclString.newInstance(sbtmp17);
                    tmp16.preserve();
                    objv15[1] = tmp16;
                    // Arg 2 variable: $sourceHash
                    tmp16 = getVarScalar(interp, "sourceHash", compiledLocals, 8);
                    tmp16.preserve();
                    objv15[2] = tmp16;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv15, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp16 = objv15[1];
                    if ( tmp16 != null ) {
                        tmp16.release();
                    }
                    tmp16 = objv15[2];
                    if ( tmp16 != null ) {
                        tmp16.release();
                    }
                    TJC.releaseObjv(interp, objv15, 3);
                }
            } // End Invoke: java::new
            tmp14 = interp.getResult();
            setVarScalar(interp, "compilerSource", tmp14, compiledLocals, 9);
        } // End Invoke: set
        { // Invoke: set compilerOutput [...]
            TclObject tmp18;
            { // Invoke: java::new "..."
                TclObject[] objv19 = TJC.grabObjv(interp, 2);
                TclObject tmp20;
                try {
                    // Arg 0 constant: java::new
                    objv19[0] = const7;
                    // Arg 1 word: "..."
                    StringBuffer sbtmp21 = new StringBuffer(64);
                    tmp20 = getVarScalar(interp, "pizza", compiledLocals, 4);
                    sbtmp21.append(tmp20.toString());
                    sbtmp21.append(".ByteArrayCompilerOutput");
                    tmp20 = TclString.newInstance(sbtmp21);
                    tmp20.preserve();
                    objv19[1] = tmp20;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv19, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp20 = objv19[1];
                    if ( tmp20 != null ) {
                        tmp20.release();
                    }
                    TJC.releaseObjv(interp, objv19, 2);
                }
            } // End Invoke: java::new
            tmp18 = interp.getResult();
            setVarScalar(interp, "compilerOutput", tmp18, compiledLocals, 10);
        } // End Invoke: set
        { // Invoke: set print [...]
            TclObject tmp22;
            { // Invoke: java::new $io.PrintStream [...]
                TclObject[] objv23 = TJC.grabObjv(interp, 3);
                TclObject tmp24;
                try {
                    // Arg 0 constant: java::new
                    objv23[0] = const7;
                    // Arg 1 word: $io.PrintStream
                    StringBuffer sbtmp25 = new StringBuffer(64);
                    tmp24 = getVarScalar(interp, "io", compiledLocals, 6);
                    sbtmp25.append(tmp24.toString());
                    sbtmp25.append(".PrintStream");
                    tmp24 = TclString.newInstance(sbtmp25);
                    tmp24.preserve();
                    objv23[1] = tmp24;
                    // Arg 2 command: [...]
                    { // Invoke: java::new "..."
                        TclObject[] objv26 = TJC.grabObjv(interp, 2);
                        TclObject tmp27;
                        try {
                            // Arg 0 constant: java::new
                            objv26[0] = const7;
                            // Arg 1 word: "..."
                            StringBuffer sbtmp28 = new StringBuffer(64);
                            tmp27 = getVarScalar(interp, "io", compiledLocals, 6);
                            sbtmp28.append(tmp27.toString());
                            sbtmp28.append(".ByteArrayOutputStream");
                            tmp27 = TclString.newInstance(sbtmp28);
                            tmp27.preserve();
                            objv26[1] = tmp27;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv26, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp27 = objv26[1];
                            if ( tmp27 != null ) {
                                tmp27.release();
                            }
                            TJC.releaseObjv(interp, objv26, 2);
                        }
                    } // End Invoke: java::new
                    tmp24 = interp.getResult();
                    tmp24.preserve();
                    objv23[2] = tmp24;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv23, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp24 = objv23[1];
                    if ( tmp24 != null ) {
                        tmp24.release();
                    }
                    tmp24 = objv23[2];
                    if ( tmp24 != null ) {
                        tmp24.release();
                    }
                    TJC.releaseObjv(interp, objv23, 3);
                }
            } // End Invoke: java::new
            tmp22 = interp.getResult();
            setVarScalar(interp, "print", tmp22, compiledLocals, 11);
        } // End Invoke: set
        { // Invoke: java::call $pizza.Main init
            TclObject[] objv29 = TJC.grabObjv(interp, 3);
            TclObject tmp30;
            try {
                // Arg 0 constant: java::call
                objv29[0] = const9;
                // Arg 1 word: $pizza.Main
                StringBuffer sbtmp31 = new StringBuffer(64);
                tmp30 = getVarScalar(interp, "pizza", compiledLocals, 4);
                sbtmp31.append(tmp30.toString());
                sbtmp31.append(".Main");
                tmp30 = TclString.newInstance(sbtmp31);
                tmp30.preserve();
                objv29[1] = tmp30;
                // Arg 2 constant: init
                objv29[2] = const10;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                    ? cmdcache3.cmd : null), objv29, 0);
                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                    updateCmdCache(interp, 3);
                }
            } finally {
                tmp30 = objv29[1];
                if ( tmp30 != null ) {
                    tmp30.release();
                }
                TJC.releaseObjv(interp, objv29, 3);
            }
        } // End Invoke: java::call
        { // Invoke: java::call $pizza.Main argument -pizza
            TclObject[] objv32 = TJC.grabObjv(interp, 4);
            TclObject tmp33;
            try {
                // Arg 0 constant: java::call
                objv32[0] = const9;
                // Arg 1 word: $pizza.Main
                StringBuffer sbtmp34 = new StringBuffer(64);
                tmp33 = getVarScalar(interp, "pizza", compiledLocals, 4);
                sbtmp34.append(tmp33.toString());
                sbtmp34.append(".Main");
                tmp33 = TclString.newInstance(sbtmp34);
                tmp33.preserve();
                objv32[1] = tmp33;
                // Arg 2 constant: argument
                objv32[2] = const11;
                // Arg 3 constant: -pizza
                objv32[3] = const12;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                    ? cmdcache3.cmd : null), objv32, 0);
                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                    updateCmdCache(interp, 3);
                }
            } finally {
                tmp33 = objv32[1];
                if ( tmp33 != null ) {
                    tmp33.release();
                }
                TJC.releaseObjv(interp, objv32, 4);
            }
        } // End Invoke: java::call
        { // Invoke: java::call $pizza.Main argument -nowarn
            TclObject[] objv35 = TJC.grabObjv(interp, 4);
            TclObject tmp36;
            try {
                // Arg 0 constant: java::call
                objv35[0] = const9;
                // Arg 1 word: $pizza.Main
                StringBuffer sbtmp37 = new StringBuffer(64);
                tmp36 = getVarScalar(interp, "pizza", compiledLocals, 4);
                sbtmp37.append(tmp36.toString());
                sbtmp37.append(".Main");
                tmp36 = TclString.newInstance(sbtmp37);
                tmp36.preserve();
                objv35[1] = tmp36;
                // Arg 2 constant: argument
                objv35[2] = const11;
                // Arg 3 constant: -nowarn
                objv35[3] = const13;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                    ? cmdcache3.cmd : null), objv35, 0);
                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                    updateCmdCache(interp, 3);
                }
            } finally {
                tmp36 = objv35[1];
                if ( tmp36 != null ) {
                    tmp36.release();
                }
                TJC.releaseObjv(interp, objv35, 4);
            }
        } // End Invoke: java::call
        { // Invoke: java::call $pizza.Main setClassReader [...]
            TclObject[] objv38 = TJC.grabObjv(interp, 4);
            TclObject tmp39;
            try {
                // Arg 0 constant: java::call
                objv38[0] = const9;
                // Arg 1 word: $pizza.Main
                StringBuffer sbtmp40 = new StringBuffer(64);
                tmp39 = getVarScalar(interp, "pizza", compiledLocals, 4);
                sbtmp40.append(tmp39.toString());
                sbtmp40.append(".Main");
                tmp39 = TclString.newInstance(sbtmp40);
                tmp39.preserve();
                objv38[1] = tmp39;
                // Arg 2 constant: setClassReader
                objv38[2] = const14;
                // Arg 3 command: [...]
                { // Invoke: java::new $pizza.ClassReader $env(CLASSPATH) [...]
                    TclObject[] objv41 = TJC.grabObjv(interp, 4);
                    TclObject tmp42;
                    try {
                        // Arg 0 constant: java::new
                        objv41[0] = const7;
                        // Arg 1 word: $pizza.ClassReader
                        StringBuffer sbtmp43 = new StringBuffer(64);
                        tmp42 = getVarScalar(interp, "pizza", compiledLocals, 4);
                        sbtmp43.append(tmp42.toString());
                        sbtmp43.append(".ClassReader");
                        tmp42 = TclString.newInstance(sbtmp43);
                        tmp42.preserve();
                        objv41[1] = tmp42;
                        // Arg 2 variable: $env(CLASSPATH)
                        tmp42 = getVarArray(interp, "env", "CLASSPATH", compiledLocals, 3);
                        tmp42.preserve();
                        objv41[2] = tmp42;
                        // Arg 3 command: [...]
                        { // Invoke: java::null
                            TclObject[] objv44 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: java::null
                                objv44[0] = const15;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv44, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv44, 1);
                            }
                        } // End Invoke: java::null
                        tmp42 = interp.getResult();
                        tmp42.preserve();
                        objv41[3] = tmp42;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv41, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp42 = objv41[1];
                        if ( tmp42 != null ) {
                            tmp42.release();
                        }
                        tmp42 = objv41[2];
                        if ( tmp42 != null ) {
                            tmp42.release();
                        }
                        tmp42 = objv41[3];
                        if ( tmp42 != null ) {
                            tmp42.release();
                        }
                        TJC.releaseObjv(interp, objv41, 4);
                    }
                } // End Invoke: java::new
                tmp39 = interp.getResult();
                tmp39.preserve();
                objv38[3] = tmp39;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                    ? cmdcache3.cmd : null), objv38, 0);
                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                    updateCmdCache(interp, 3);
                }
            } finally {
                tmp39 = objv38[1];
                if ( tmp39 != null ) {
                    tmp39.release();
                }
                tmp39 = objv38[3];
                if ( tmp39 != null ) {
                    tmp39.release();
                }
                TJC.releaseObjv(interp, objv38, 4);
            }
        } // End Invoke: java::call
        { // Invoke: set allFiles [...]
            TclObject tmp45;
            { // Invoke: java::new {String[]} 1 $filename
                TclObject[] objv46 = TJC.grabObjv(interp, 4);
                TclObject tmp47;
                try {
                    // Arg 0 constant: java::new
                    objv46[0] = const7;
                    // Arg 1 constant: {String[]}
                    objv46[1] = const16;
                    // Arg 2 constant: 1
                    objv46[2] = const17;
                    // Arg 3 variable: $filename
                    tmp47 = getVarScalar(interp, "filename", compiledLocals, 0);
                    tmp47.preserve();
                    objv46[3] = tmp47;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv46, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp47 = objv46[3];
                    if ( tmp47 != null ) {
                        tmp47.release();
                    }
                    TJC.releaseObjv(interp, objv46, 4);
                }
            } // End Invoke: java::new
            tmp45 = interp.getResult();
            setVarScalar(interp, "allFiles", tmp45, compiledLocals, 12);
        } // End Invoke: set
        { // Invoke: java::call $pizza.Main compile $allFiles $compilerSource $compilerOutput $print
            TclObject[] objv48 = TJC.grabObjv(interp, 7);
            TclObject tmp49;
            try {
                // Arg 0 constant: java::call
                objv48[0] = const9;
                // Arg 1 word: $pizza.Main
                StringBuffer sbtmp50 = new StringBuffer(64);
                tmp49 = getVarScalar(interp, "pizza", compiledLocals, 4);
                sbtmp50.append(tmp49.toString());
                sbtmp50.append(".Main");
                tmp49 = TclString.newInstance(sbtmp50);
                tmp49.preserve();
                objv48[1] = tmp49;
                // Arg 2 constant: compile
                objv48[2] = const18;
                // Arg 3 variable: $allFiles
                tmp49 = getVarScalar(interp, "allFiles", compiledLocals, 12);
                tmp49.preserve();
                objv48[3] = tmp49;
                // Arg 4 variable: $compilerSource
                tmp49 = getVarScalar(interp, "compilerSource", compiledLocals, 9);
                tmp49.preserve();
                objv48[4] = tmp49;
                // Arg 5 variable: $compilerOutput
                tmp49 = getVarScalar(interp, "compilerOutput", compiledLocals, 10);
                tmp49.preserve();
                objv48[5] = tmp49;
                // Arg 6 variable: $print
                tmp49 = getVarScalar(interp, "print", compiledLocals, 11);
                tmp49.preserve();
                objv48[6] = tmp49;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                    ? cmdcache3.cmd : null), objv48, 0);
                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                    updateCmdCache(interp, 3);
                }
            } finally {
                objv48[0] = null;
                objv48[2] = null;
                TJC.releaseObjvElems(interp, objv48, 7);
            }
        } // End Invoke: java::call
        { // Invoke: set errs [...]
            TclObject tmp51;
            { // Invoke: java::call $pizza.Report getErrorsAndWarnings
                TclObject[] objv52 = TJC.grabObjv(interp, 3);
                TclObject tmp53;
                try {
                    // Arg 0 constant: java::call
                    objv52[0] = const9;
                    // Arg 1 word: $pizza.Report
                    StringBuffer sbtmp54 = new StringBuffer(64);
                    tmp53 = getVarScalar(interp, "pizza", compiledLocals, 4);
                    sbtmp54.append(tmp53.toString());
                    sbtmp54.append(".Report");
                    tmp53 = TclString.newInstance(sbtmp54);
                    tmp53.preserve();
                    objv52[1] = tmp53;
                    // Arg 2 constant: getErrorsAndWarnings
                    objv52[2] = const19;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv52, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp53 = objv52[1];
                    if ( tmp53 != null ) {
                        tmp53.release();
                    }
                    TJC.releaseObjv(interp, objv52, 3);
                }
            } // End Invoke: java::call
            tmp51 = interp.getResult();
            setVarScalar(interp, "errs", tmp51, compiledLocals, 13);
        } // End Invoke: set
        { // Invoke: if {! [$errs isEmpty]} ...
            // Unary operator: ! [...]
            { // Invoke: $errs isEmpty
                TclObject[] objv55 = TJC.grabObjv(interp, 2);
                TclObject tmp56;
                try {
                    // Arg 0 variable: $errs
                    tmp56 = getVarScalar(interp, "errs", compiledLocals, 13);
                    tmp56.preserve();
                    objv55[0] = tmp56;
                    // Arg 1 constant: isEmpty
                    objv55[1] = const20;
                    TJC.invoke(interp, null, objv55, 0);
                } finally {
                    tmp56 = objv55[0];
                    if ( tmp56 != null ) {
                        tmp56.release();
                    }
                    TJC.releaseObjv(interp, objv55, 2);
                }
            } // End Invoke: ...
            TclObject tmp57 = interp.getResult();
            ExprValue tmp58 = evs0;
            if ( tmp57.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp58, tmp57);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp58, tmp57);
            }
            // End Unary operator: !
            boolean tmp59 = ( tmp58.getIntValue() != 0 );
            if ( tmp59 ) {
                { // Invoke: set iter [...]
                    TclObject tmp60;
                    { // Invoke: $errs iterator
                        TclObject[] objv61 = TJC.grabObjv(interp, 2);
                        TclObject tmp62;
                        try {
                            // Arg 0 variable: $errs
                            tmp62 = getVarScalar(interp, "errs", compiledLocals, 13);
                            tmp62.preserve();
                            objv61[0] = tmp62;
                            // Arg 1 constant: iterator
                            objv61[1] = const21;
                            TJC.invoke(interp, null, objv61, 0);
                        } finally {
                            tmp62 = objv61[0];
                            if ( tmp62 != null ) {
                                tmp62.release();
                            }
                            TJC.releaseObjv(interp, objv61, 2);
                        }
                    } // End Invoke: ...
                    tmp60 = interp.getResult();
                    setVarScalar(interp, "iter", tmp60, compiledLocals, 14);
                } // End Invoke: set
                { // Invoke: set msg ""
                    setVarScalar(interp, "msg", const22, compiledLocals, 15);
                } // End Invoke: set
                { // Invoke: while {[$iter hasNext]} ...
                    for ( ; true ; ) {
                        { // Invoke: $iter hasNext
                            TclObject[] objv63 = TJC.grabObjv(interp, 2);
                            TclObject tmp64;
                            try {
                                // Arg 0 variable: $iter
                                tmp64 = getVarScalar(interp, "iter", compiledLocals, 14);
                                tmp64.preserve();
                                objv63[0] = tmp64;
                                // Arg 1 constant: hasNext
                                objv63[1] = const23;
                                TJC.invoke(interp, null, objv63, 0);
                            } finally {
                                tmp64 = objv63[0];
                                if ( tmp64 != null ) {
                                    tmp64.release();
                                }
                                TJC.releaseObjv(interp, objv63, 2);
                            }
                        } // End Invoke: ...
                        TclObject tmp65 = interp.getResult();
                        ExprValue tmp66 = evs0;
                        TJC.exprInitValue(interp, tmp66, tmp65);
                        boolean tmp67 = tmp66.getBooleanValue(interp);
                        if ( ! tmp67 ) { break; }

                        try {
                        if ( false ) { throw (TclException) null; }
                        { // Invoke: lappend msg [...]
                            TclObject[] objv68 = TJC.grabObjv(interp, 1);
                            TclObject tmp69;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: [...] toString
                                    TclObject[] objv70 = TJC.grabObjv(interp, 2);
                                    TclObject tmp71;
                                    try {
                                        // Arg 0 command: [...]
                                        { // Invoke: $iter next
                                            TclObject[] objv72 = TJC.grabObjv(interp, 2);
                                            TclObject tmp73;
                                            try {
                                                // Arg 0 variable: $iter
                                                tmp73 = getVarScalar(interp, "iter", compiledLocals, 14);
                                                tmp73.preserve();
                                                objv72[0] = tmp73;
                                                // Arg 1 constant: next
                                                objv72[1] = const24;
                                                TJC.invoke(interp, null, objv72, 0);
                                            } finally {
                                                tmp73 = objv72[0];
                                                if ( tmp73 != null ) {
                                                    tmp73.release();
                                                }
                                                TJC.releaseObjv(interp, objv72, 2);
                                            }
                                        } // End Invoke: ...
                                        tmp71 = interp.getResult();
                                        tmp71.preserve();
                                        objv70[0] = tmp71;
                                        // Arg 1 constant: toString
                                        objv70[1] = const25;
                                        TJC.invoke(interp, null, objv70, 0);
                                    } finally {
                                        tmp71 = objv70[0];
                                        if ( tmp71 != null ) {
                                            tmp71.release();
                                        }
                                        TJC.releaseObjv(interp, objv70, 2);
                                    }
                                } // End Invoke: ...
                                tmp69 = interp.getResult();
                                tmp69.preserve();
                                objv68[0] = tmp69;
                                interp.resetResult();
                                lappendVarScalar(interp, "msg", objv68, compiledLocals, 15);
                            } finally {
                                TJC.releaseObjvElems(interp, objv68, 1);
                            }
                        } // End Invoke: lappend
                        } catch (TclException ex) {
                            int type = ex.getCompletionCode();
                            if (type == TCL.BREAK) {
                                break;
                            } else if (type == TCL.CONTINUE) {
                                continue;
                            } else {
                                throw ex;
                            }
                        }
                    }
                } // End Invoke: while
                { // Invoke: error $msg
                    TclObject[] objv74 = TJC.grabObjv(interp, 2);
                    TclObject tmp75;
                    try {
                        // Arg 0 constant: error
                        objv74[0] = const0;
                        // Arg 1 variable: $msg
                        tmp75 = getVarScalar(interp, "msg", compiledLocals, 15);
                        tmp75.preserve();
                        objv74[1] = tmp75;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv74, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp75 = objv74[1];
                        if ( tmp75 != null ) {
                            tmp75.release();
                        }
                        TJC.releaseObjv(interp, objv74, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: if {0} ...
            if ( false ) {
                { // Invoke: set map [...]
                    TclObject tmp76;
                    { // Invoke: $compilerOutput getFilesToBytecode
                        TclObject[] objv77 = TJC.grabObjv(interp, 2);
                        TclObject tmp78;
                        try {
                            // Arg 0 variable: $compilerOutput
                            tmp78 = getVarScalar(interp, "compilerOutput", compiledLocals, 10);
                            tmp78.preserve();
                            objv77[0] = tmp78;
                            // Arg 1 constant: getFilesToBytecode
                            objv77[1] = const26;
                            TJC.invoke(interp, null, objv77, 0);
                        } finally {
                            tmp78 = objv77[0];
                            if ( tmp78 != null ) {
                                tmp78.release();
                            }
                            TJC.releaseObjv(interp, objv77, 2);
                        }
                    } // End Invoke: ...
                    tmp76 = interp.getResult();
                    setVarScalar(interp, "map", tmp76, compiledLocals, 16);
                } // End Invoke: set
                { // Invoke: set iter [...]
                    TclObject tmp79;
                    { // Invoke: [...] iterator
                        TclObject[] objv80 = TJC.grabObjv(interp, 2);
                        TclObject tmp81;
                        try {
                            // Arg 0 command: [...]
                            { // Invoke: $map entrySet
                                TclObject[] objv82 = TJC.grabObjv(interp, 2);
                                TclObject tmp83;
                                try {
                                    // Arg 0 variable: $map
                                    tmp83 = getVarScalar(interp, "map", compiledLocals, 16);
                                    tmp83.preserve();
                                    objv82[0] = tmp83;
                                    // Arg 1 constant: entrySet
                                    objv82[1] = const27;
                                    TJC.invoke(interp, null, objv82, 0);
                                } finally {
                                    tmp83 = objv82[0];
                                    if ( tmp83 != null ) {
                                        tmp83.release();
                                    }
                                    TJC.releaseObjv(interp, objv82, 2);
                                }
                            } // End Invoke: ...
                            tmp81 = interp.getResult();
                            tmp81.preserve();
                            objv80[0] = tmp81;
                            // Arg 1 constant: iterator
                            objv80[1] = const21;
                            TJC.invoke(interp, null, objv80, 0);
                        } finally {
                            tmp81 = objv80[0];
                            if ( tmp81 != null ) {
                                tmp81.release();
                            }
                            TJC.releaseObjv(interp, objv80, 2);
                        }
                    } // End Invoke: ...
                    tmp79 = interp.getResult();
                    setVarScalar(interp, "iter", tmp79, compiledLocals, 14);
                } // End Invoke: set
                { // Invoke: set results [...]
                    TclObject tmp84;
                    { // Invoke: list
                        TclObject tmp85 = TclList.newInstance();
                        interp.setResult(tmp85);
                    } // End Invoke: list
                    tmp84 = interp.getResult();
                    setVarScalar(interp, "results", tmp84, compiledLocals, 17);
                } // End Invoke: set
                { // Invoke: set inner [...]
                    TclObject tmp86;
                    { // Invoke: list
                        TclObject tmp87 = TclList.newInstance();
                        interp.setResult(tmp87);
                    } // End Invoke: list
                    tmp86 = interp.getResult();
                    setVarScalar(interp, "inner", tmp86, compiledLocals, 18);
                } // End Invoke: set
                { // Invoke: for ... {[$iter hasNext]} {} ...
                    { // Invoke: set iter [...]
                        TclObject tmp88;
                        { // Invoke: [...] iterator
                            TclObject[] objv89 = TJC.grabObjv(interp, 2);
                            TclObject tmp90;
                            try {
                                // Arg 0 command: [...]
                                { // Invoke: $map entrySet
                                    TclObject[] objv91 = TJC.grabObjv(interp, 2);
                                    TclObject tmp92;
                                    try {
                                        // Arg 0 variable: $map
                                        tmp92 = getVarScalar(interp, "map", compiledLocals, 16);
                                        tmp92.preserve();
                                        objv91[0] = tmp92;
                                        // Arg 1 constant: entrySet
                                        objv91[1] = const27;
                                        TJC.invoke(interp, null, objv91, 0);
                                    } finally {
                                        tmp92 = objv91[0];
                                        if ( tmp92 != null ) {
                                            tmp92.release();
                                        }
                                        TJC.releaseObjv(interp, objv91, 2);
                                    }
                                } // End Invoke: ...
                                tmp90 = interp.getResult();
                                tmp90.preserve();
                                objv89[0] = tmp90;
                                // Arg 1 constant: iterator
                                objv89[1] = const21;
                                TJC.invoke(interp, null, objv89, 0);
                            } finally {
                                tmp90 = objv89[0];
                                if ( tmp90 != null ) {
                                    tmp90.release();
                                }
                                TJC.releaseObjv(interp, objv89, 2);
                            }
                        } // End Invoke: ...
                        tmp88 = interp.getResult();
                        setVarScalar(interp, "iter", tmp88, compiledLocals, 14);
                    } // End Invoke: set
                    for ( ; true ; ) {
                        { // Invoke: $iter hasNext
                            TclObject[] objv93 = TJC.grabObjv(interp, 2);
                            TclObject tmp94;
                            try {
                                // Arg 0 variable: $iter
                                tmp94 = getVarScalar(interp, "iter", compiledLocals, 14);
                                tmp94.preserve();
                                objv93[0] = tmp94;
                                // Arg 1 constant: hasNext
                                objv93[1] = const23;
                                TJC.invoke(interp, null, objv93, 0);
                            } finally {
                                tmp94 = objv93[0];
                                if ( tmp94 != null ) {
                                    tmp94.release();
                                }
                                TJC.releaseObjv(interp, objv93, 2);
                            }
                        } // End Invoke: ...
                        TclObject tmp95 = interp.getResult();
                        ExprValue tmp96 = evs0;
                        TJC.exprInitValue(interp, tmp96, tmp95);
                        boolean tmp97 = tmp96.getBooleanValue(interp);
                        if ( ! tmp97 ) { break; }

                        try {
                        if ( false ) { throw (TclException) null; }
                        { // Invoke: set entry [...]
                            TclObject tmp98;
                            { // Invoke: java::cast ... [...]
                                TclObject[] objv99 = TJC.grabObjv(interp, 3);
                                TclObject tmp100;
                                try {
                                    // Arg 0 constant: java::cast
                                    objv99[0] = const28;
                                    // Arg 1 constant: ...
                                    objv99[1] = const29;
                                    // Arg 2 command: [...]
                                    { // Invoke: $iter next
                                        TclObject[] objv101 = TJC.grabObjv(interp, 2);
                                        TclObject tmp102;
                                        try {
                                            // Arg 0 variable: $iter
                                            tmp102 = getVarScalar(interp, "iter", compiledLocals, 14);
                                            tmp102.preserve();
                                            objv101[0] = tmp102;
                                            // Arg 1 constant: next
                                            objv101[1] = const24;
                                            TJC.invoke(interp, null, objv101, 0);
                                        } finally {
                                            tmp102 = objv101[0];
                                            if ( tmp102 != null ) {
                                                tmp102.release();
                                            }
                                            TJC.releaseObjv(interp, objv101, 2);
                                        }
                                    } // End Invoke: ...
                                    tmp100 = interp.getResult();
                                    tmp100.preserve();
                                    objv99[2] = tmp100;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                        ? cmdcache5.cmd : null), objv99, 0);
                                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                        updateCmdCache(interp, 5);
                                    }
                                } finally {
                                    tmp100 = objv99[2];
                                    if ( tmp100 != null ) {
                                        tmp100.release();
                                    }
                                    TJC.releaseObjv(interp, objv99, 3);
                                }
                            } // End Invoke: java::cast
                            tmp98 = interp.getResult();
                            setVarScalar(interp, "entry", tmp98, compiledLocals, 19);
                        } // End Invoke: set
                        { // Invoke: set key [...]
                            TclObject tmp103;
                            { // Invoke: java::cast {String} [...]
                                TclObject[] objv104 = TJC.grabObjv(interp, 3);
                                TclObject tmp105;
                                try {
                                    // Arg 0 constant: java::cast
                                    objv104[0] = const28;
                                    // Arg 1 constant: {String}
                                    objv104[1] = const30;
                                    // Arg 2 command: [...]
                                    { // Invoke: $entry getKey
                                        TclObject[] objv106 = TJC.grabObjv(interp, 2);
                                        TclObject tmp107;
                                        try {
                                            // Arg 0 variable: $entry
                                            tmp107 = getVarScalar(interp, "entry", compiledLocals, 19);
                                            tmp107.preserve();
                                            objv106[0] = tmp107;
                                            // Arg 1 constant: getKey
                                            objv106[1] = const31;
                                            TJC.invoke(interp, null, objv106, 0);
                                        } finally {
                                            tmp107 = objv106[0];
                                            if ( tmp107 != null ) {
                                                tmp107.release();
                                            }
                                            TJC.releaseObjv(interp, objv106, 2);
                                        }
                                    } // End Invoke: ...
                                    tmp105 = interp.getResult();
                                    tmp105.preserve();
                                    objv104[2] = tmp105;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                        ? cmdcache5.cmd : null), objv104, 0);
                                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                        updateCmdCache(interp, 5);
                                    }
                                } finally {
                                    tmp105 = objv104[2];
                                    if ( tmp105 != null ) {
                                        tmp105.release();
                                    }
                                    TJC.releaseObjv(interp, objv104, 3);
                                }
                            } // End Invoke: java::cast
                            tmp103 = interp.getResult();
                            setVarScalar(interp, "key", tmp103, compiledLocals, 20);
                        } // End Invoke: set
                        { // Invoke: set value [...]
                            TclObject tmp108;
                            { // Invoke: java::cast {byte[]} [...]
                                TclObject[] objv109 = TJC.grabObjv(interp, 3);
                                TclObject tmp110;
                                try {
                                    // Arg 0 constant: java::cast
                                    objv109[0] = const28;
                                    // Arg 1 constant: {byte[]}
                                    objv109[1] = const32;
                                    // Arg 2 command: [...]
                                    { // Invoke: $entry getValue
                                        TclObject[] objv111 = TJC.grabObjv(interp, 2);
                                        TclObject tmp112;
                                        try {
                                            // Arg 0 variable: $entry
                                            tmp112 = getVarScalar(interp, "entry", compiledLocals, 19);
                                            tmp112.preserve();
                                            objv111[0] = tmp112;
                                            // Arg 1 constant: getValue
                                            objv111[1] = const33;
                                            TJC.invoke(interp, null, objv111, 0);
                                        } finally {
                                            tmp112 = objv111[0];
                                            if ( tmp112 != null ) {
                                                tmp112.release();
                                            }
                                            TJC.releaseObjv(interp, objv111, 2);
                                        }
                                    } // End Invoke: ...
                                    tmp110 = interp.getResult();
                                    tmp110.preserve();
                                    objv109[2] = tmp110;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                        ? cmdcache5.cmd : null), objv109, 0);
                                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                        updateCmdCache(interp, 5);
                                    }
                                } finally {
                                    tmp110 = objv109[2];
                                    if ( tmp110 != null ) {
                                        tmp110.release();
                                    }
                                    TJC.releaseObjv(interp, objv109, 3);
                                }
                            } // End Invoke: java::cast
                            tmp108 = interp.getResult();
                            setVarScalar(interp, "value", tmp108, compiledLocals, 21);
                        } // End Invoke: set
                        { // Invoke: if ... ... else ...
                            // Binary operator: [...] == ()
                            { // Invoke: string first ... $key
                                char tmp113 = '$';
                                TclObject tmp114 = getVarScalar(interp, "key", compiledLocals, 20);
                                String tmp115 = tmp114.toString();
                                int tmp116 = tmp115.indexOf(tmp113);
                                interp.setResult(tmp116);
                            } // End Invoke: string
                            TclObject tmp117 = interp.getResult();
                            ExprValue tmp118 = evs0;
                            TJC.exprInitValue(interp, tmp118, tmp117);
                            // Unary operator: - 1
                            ExprValue tmp119 = evs1;
                            tmp119.setIntValue(-1);
                            // End Unary operator: -
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp118, tmp119);
                            // End Binary operator: ==
                            boolean tmp120 = ( tmp118.getIntValue() != 0 );
                            if ( tmp120 ) {
                                { // Invoke: lappend results $key $value
                                    TclObject[] objv121 = TJC.grabObjv(interp, 2);
                                    TclObject tmp122;
                                    try {
                                        // Arg 2 variable: $key
                                        tmp122 = getVarScalar(interp, "key", compiledLocals, 20);
                                        tmp122.preserve();
                                        objv121[0] = tmp122;
                                        // Arg 3 variable: $value
                                        tmp122 = getVarScalar(interp, "value", compiledLocals, 21);
                                        tmp122.preserve();
                                        objv121[1] = tmp122;
                                        interp.resetResult();
                                        lappendVarScalar(interp, "results", objv121, compiledLocals, 17);
                                    } finally {
                                        TJC.releaseObjvElems(interp, objv121, 2);
                                    }
                                } // End Invoke: lappend
                            } else {
                                { // Invoke: lappend inner $key $value
                                    TclObject[] objv123 = TJC.grabObjv(interp, 2);
                                    TclObject tmp124;
                                    try {
                                        // Arg 2 variable: $key
                                        tmp124 = getVarScalar(interp, "key", compiledLocals, 20);
                                        tmp124.preserve();
                                        objv123[0] = tmp124;
                                        // Arg 3 variable: $value
                                        tmp124 = getVarScalar(interp, "value", compiledLocals, 21);
                                        tmp124.preserve();
                                        objv123[1] = tmp124;
                                        interp.resetResult();
                                        lappendVarScalar(interp, "inner", objv123, compiledLocals, 18);
                                    } finally {
                                        TJC.releaseObjvElems(interp, objv123, 2);
                                    }
                                } // End Invoke: lappend
                            }
                        } // End Invoke: if
                        } catch (TclException ex) {
                            int type = ex.getCompletionCode();
                            if (type == TCL.BREAK) {
                                break;
                            } else if (type == TCL.CONTINUE) {
                                continue;
                            } else {
                                throw ex;
                            }
                        }
                    }
                } // End Invoke: for
                { // Invoke: if {$inner != {}} ...
                    // Binary operator: $inner != ""
                    TclObject tmp125 = getVarScalar(interp, "inner", compiledLocals, 18);
                    ExprValue tmp126 = evs0;
                    TJC.exprEqualsEmptyString(tmp126, tmp125, true);
                    // End Binary operator: !=
                    boolean tmp127 = ( tmp126.getIntValue() != 0 );
                    if ( tmp127 ) {
                        { // Invoke: foreach {cname cdata} $inner ...
                            TclObject tmp128 = null;
                            try {
                                tmp128 = getVarScalar(interp, "inner", compiledLocals, 18);
                                tmp128.preserve();
                                final int tmp128_length = TclList.getLength(interp, tmp128);

                                for ( int index129 = 0 ; index129 < tmp128_length ; index129 += 2 ) {
                                    TclObject tmp130 = null;
                                    if ( index129 < tmp128_length ) {
                                        tmp130 = TclList.index(interp, tmp128, index129);
                                    }
                                    TclObject tmp131 = null;
                                    if ( index129 + 1 < tmp128_length ) {
                                        tmp131 = TclList.index(interp, tmp128, index129 + 1);
                                    }
                                    try {
                                        if ( tmp130 == null ) {
                                            setVarScalar(interp, "cname", "", compiledLocals, 22);
                                        } else {
                                            setVarScalar(interp, "cname", tmp130, compiledLocals, 22);
                                        }
                                    } catch (TclException ex) {
                                        TJC.foreachVarErr(interp, "cname");
                                    }
                                    try {
                                        if ( tmp131 == null ) {
                                            setVarScalar(interp, "cdata", "", compiledLocals, 23);
                                        } else {
                                            setVarScalar(interp, "cdata", tmp131, compiledLocals, 23);
                                        }
                                    } catch (TclException ex) {
                                        TJC.foreachVarErr(interp, "cdata");
                                    }

                                    try {
                                    if ( false ) { throw (TclException) null; }
                                    { // Invoke: set cnames($cname) $cdata
                                        TclObject tmp132;
                                        tmp132 = getVarScalar(interp, "cname", compiledLocals, 22);
                                        String tmp133 = tmp132.toString();
                                        tmp132 = getVarScalar(interp, "cdata", compiledLocals, 23);
                                        tmp132 = setVarArray(interp, "cnames", tmp133, tmp132, compiledLocals, 24);
                                    } // End Invoke: set
                                    } catch (TclException ex) {
                                        int type = ex.getCompletionCode();
                                        if (type == TCL.BREAK) {
                                            break;
                                        } else if (type == TCL.CONTINUE) {
                                            continue;
                                        } else {
                                            throw ex;
                                        }
                                    }
                                }
                            } finally {
                                if ( tmp128 != null ) {
                                    tmp128.release();
                                }
                            }
                        } // End Invoke: foreach
                        { // Invoke: set sorted_cnames [...]
                            TclObject tmp134;
                            { // Invoke: lsort -dictionary [...]
                                TclObject[] objv135 = TJC.grabObjv(interp, 3);
                                TclObject tmp136;
                                try {
                                    // Arg 0 constant: lsort
                                    objv135[0] = const34;
                                    // Arg 1 constant: -dictionary
                                    objv135[1] = const35;
                                    // Arg 2 command: [...]
                                    { // Invoke: array names cnames
                                        TclObject[] objv137 = TJC.grabObjv(interp, 3);
                                        try {
                                            // Arg 0 constant: array
                                            objv137[0] = const36;
                                            // Arg 1 constant: names
                                            objv137[1] = const37;
                                            // Arg 2 constant: cnames
                                            objv137[2] = const38;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                                ? cmdcache6.cmd : null), objv137, 0);
                                            if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                                updateCmdCache(interp, 6);
                                            }
                                        } finally {
                                            TJC.releaseObjv(interp, objv137, 3);
                                        }
                                    } // End Invoke: array
                                    tmp136 = interp.getResult();
                                    tmp136.preserve();
                                    objv135[2] = tmp136;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                        ? cmdcache7.cmd : null), objv135, 0);
                                    if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                        updateCmdCache(interp, 7);
                                    }
                                } finally {
                                    tmp136 = objv135[2];
                                    if ( tmp136 != null ) {
                                        tmp136.release();
                                    }
                                    TJC.releaseObjv(interp, objv135, 3);
                                }
                            } // End Invoke: lsort
                            tmp134 = interp.getResult();
                            setVarScalar(interp, "sorted_cnames", tmp134, compiledLocals, 25);
                        } // End Invoke: set
                        { // Invoke: foreach cname $sorted_cnames ...
                            TclObject tmp138 = null;
                            try {
                                tmp138 = getVarScalar(interp, "sorted_cnames", compiledLocals, 25);
                                tmp138.preserve();
                                final int tmp138_length = TclList.getLength(interp, tmp138);

                                for ( int index139 = 0 ; index139 < tmp138_length ; index139++ ) {
                                    TclObject tmp140 = TclList.index(interp, tmp138, index139);
                                    try {
                                        setVarScalar(interp, "cname", tmp140, compiledLocals, 22);
                                    } catch (TclException ex) {
                                        TJC.foreachVarErr(interp, "cname");
                                    }

                                    try {
                                    if ( false ) { throw (TclException) null; }
                                    { // Invoke: lappend results $cname $cnames($cname)
                                        TclObject[] objv141 = TJC.grabObjv(interp, 2);
                                        TclObject tmp142;
                                        try {
                                            // Arg 2 variable: $cname
                                            tmp142 = getVarScalar(interp, "cname", compiledLocals, 22);
                                            tmp142.preserve();
                                            objv141[0] = tmp142;
                                            // Arg 3 variable: $cnames($cname)
                                            tmp142 = getVarScalar(interp, "cname", compiledLocals, 22);
                                            tmp142 = getVarArray(interp, "cnames", tmp142.toString(), compiledLocals, 24);
                                            tmp142.preserve();
                                            objv141[1] = tmp142;
                                            interp.resetResult();
                                            lappendVarScalar(interp, "results", objv141, compiledLocals, 17);
                                        } finally {
                                            TJC.releaseObjvElems(interp, objv141, 2);
                                        }
                                    } // End Invoke: lappend
                                    } catch (TclException ex) {
                                        int type = ex.getCompletionCode();
                                        if (type == TCL.BREAK) {
                                            break;
                                        } else if (type == TCL.CONTINUE) {
                                            continue;
                                        } else {
                                            throw ex;
                                        }
                                    }
                                }
                            } finally {
                                if ( tmp138 != null ) {
                                    tmp138.release();
                                }
                            }
                        } // End Invoke: foreach
                    }
                } // End Invoke: if
                { // Invoke: return $results
                    TclObject tmp143 = getVarScalar(interp, "results", compiledLocals, 17);
                    interp.resetResult();
                    interp.setResult(tmp143);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: if {1} ...
            if ( true ) {
                { // Invoke: set byteArrayList [...]
                    TclObject tmp144;
                    { // Invoke: java::cast $util.ArrayList [...]
                        TclObject[] objv145 = TJC.grabObjv(interp, 3);
                        TclObject tmp146;
                        try {
                            // Arg 0 constant: java::cast
                            objv145[0] = const28;
                            // Arg 1 word: $util.ArrayList
                            StringBuffer sbtmp147 = new StringBuffer(64);
                            tmp146 = getVarScalar(interp, "util", compiledLocals, 5);
                            sbtmp147.append(tmp146.toString());
                            sbtmp147.append(".ArrayList");
                            tmp146 = TclString.newInstance(sbtmp147);
                            tmp146.preserve();
                            objv145[1] = tmp146;
                            // Arg 2 command: [...]
                            { // Invoke: $compilerOutput getBytecode
                                TclObject[] objv148 = TJC.grabObjv(interp, 2);
                                TclObject tmp149;
                                try {
                                    // Arg 0 variable: $compilerOutput
                                    tmp149 = getVarScalar(interp, "compilerOutput", compiledLocals, 10);
                                    tmp149.preserve();
                                    objv148[0] = tmp149;
                                    // Arg 1 constant: getBytecode
                                    objv148[1] = const39;
                                    TJC.invoke(interp, null, objv148, 0);
                                } finally {
                                    tmp149 = objv148[0];
                                    if ( tmp149 != null ) {
                                        tmp149.release();
                                    }
                                    TJC.releaseObjv(interp, objv148, 2);
                                }
                            } // End Invoke: ...
                            tmp146 = interp.getResult();
                            tmp146.preserve();
                            objv145[2] = tmp146;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                ? cmdcache5.cmd : null), objv145, 0);
                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                updateCmdCache(interp, 5);
                            }
                        } finally {
                            tmp146 = objv145[1];
                            if ( tmp146 != null ) {
                                tmp146.release();
                            }
                            tmp146 = objv145[2];
                            if ( tmp146 != null ) {
                                tmp146.release();
                            }
                            TJC.releaseObjv(interp, objv145, 3);
                        }
                    } // End Invoke: java::cast
                    tmp144 = interp.getResult();
                    setVarScalar(interp, "byteArrayList", tmp144, compiledLocals, 26);
                } // End Invoke: set
                { // Invoke: for {set i 0} ... {incr i} ...
                    { // Invoke: set i 0
                        setVarScalar(interp, "i", const40, compiledLocals, 27);
                    } // End Invoke: set
                    for ( boolean skip157 = true ; true ; ) {
                        if ( skip157 ) {
                            skip157 = false;
                        } else {
                            try {
                            if ( false ) { throw (TclException) null; }
                            { // Invoke: incr i
                                interp.resetResult();
                                incrVarScalar(interp, "i", 1, compiledLocals, 27);
                            } // End Invoke: incr
                            } catch (TclException ex) {
                                int type = ex.getCompletionCode();
                                if (type == TCL.BREAK) {
                                    break;
                                } else {
                                    throw ex;
                                }
                            }
                        }

                        // Binary operator: $i < [...]
                        TclObject tmp150 = getVarScalar(interp, "i", compiledLocals, 27);
                        ExprValue tmp151 = evs0;
                        TJC.exprInitValue(interp, tmp151, tmp150);
                        { // Invoke: $byteArrayList size
                            TclObject[] objv152 = TJC.grabObjv(interp, 2);
                            TclObject tmp153;
                            try {
                                // Arg 0 variable: $byteArrayList
                                tmp153 = getVarScalar(interp, "byteArrayList", compiledLocals, 26);
                                tmp153.preserve();
                                objv152[0] = tmp153;
                                // Arg 1 constant: size
                                objv152[1] = const41;
                                TJC.invoke(interp, null, objv152, 0);
                            } finally {
                                tmp153 = objv152[0];
                                if ( tmp153 != null ) {
                                    tmp153.release();
                                }
                                TJC.releaseObjv(interp, objv152, 2);
                            }
                        } // End Invoke: ...
                        TclObject tmp154 = interp.getResult();
                        ExprValue tmp155 = evs1;
                        TJC.exprInitValue(interp, tmp155, tmp154);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp151, tmp155);
                        // End Binary operator: <
                        boolean tmp156 = ( tmp151.getIntValue() != 0 );
                        if ( ! tmp156 ) { break; }

                        try {
                        if ( false ) { throw (TclException) null; }
                        { // Invoke: set class_name {}
                            setVarScalar(interp, "class_name", const22, compiledLocals, 28);
                        } // End Invoke: set
                        { // Invoke: if ... ...
                            // Binary operator: [...] == 1
                            { // Invoke: $byteArrayList size
                                TclObject[] objv158 = TJC.grabObjv(interp, 2);
                                TclObject tmp159;
                                try {
                                    // Arg 0 variable: $byteArrayList
                                    tmp159 = getVarScalar(interp, "byteArrayList", compiledLocals, 26);
                                    tmp159.preserve();
                                    objv158[0] = tmp159;
                                    // Arg 1 constant: size
                                    objv158[1] = const41;
                                    TJC.invoke(interp, null, objv158, 0);
                                } finally {
                                    tmp159 = objv158[0];
                                    if ( tmp159 != null ) {
                                        tmp159.release();
                                    }
                                    TJC.releaseObjv(interp, objv158, 2);
                                }
                            } // End Invoke: ...
                            TclObject tmp160 = interp.getResult();
                            ExprValue tmp161 = evs0;
                            TJC.exprInitValue(interp, tmp161, tmp160);
                            ExprValue tmp162 = evs1;
                            tmp162.setIntValue(1);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp161, tmp162);
                            // End Binary operator: ==
                            boolean tmp163 = ( tmp161.getIntValue() != 0 );
                            if ( tmp163 ) {
                                { // Invoke: set class_name [...]
                                    TclObject tmp164;
                                    { // Invoke: string map {.java "" / .} $filename
                                        TclObject[] objv165 = TJC.grabObjv(interp, 4);
                                        TclObject tmp166;
                                        try {
                                            // Arg 0 constant: string
                                            objv165[0] = const42;
                                            // Arg 1 constant: map
                                            objv165[1] = const43;
                                            // Arg 2 constant: {.java "" / .}
                                            objv165[2] = const44;
                                            // Arg 3 variable: $filename
                                            tmp166 = getVarScalar(interp, "filename", compiledLocals, 0);
                                            tmp166.preserve();
                                            objv165[3] = tmp166;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                                ? cmdcache8.cmd : null), objv165, 0);
                                            if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                                updateCmdCache(interp, 8);
                                            }
                                        } finally {
                                            tmp166 = objv165[3];
                                            if ( tmp166 != null ) {
                                                tmp166.release();
                                            }
                                            TJC.releaseObjv(interp, objv165, 4);
                                        }
                                    } // End Invoke: string
                                    tmp164 = interp.getResult();
                                    setVarScalar(interp, "class_name", tmp164, compiledLocals, 28);
                                } // End Invoke: set
                            }
                        } // End Invoke: if
                        { // Invoke: set class_bytes [...]
                            TclObject tmp167;
                            { // Invoke: java::cast {byte[]} [...]
                                TclObject[] objv168 = TJC.grabObjv(interp, 3);
                                TclObject tmp169;
                                try {
                                    // Arg 0 constant: java::cast
                                    objv168[0] = const28;
                                    // Arg 1 constant: {byte[]}
                                    objv168[1] = const32;
                                    // Arg 2 command: [...]
                                    { // Invoke: $byteArrayList get $i
                                        TclObject[] objv170 = TJC.grabObjv(interp, 3);
                                        TclObject tmp171;
                                        try {
                                            // Arg 0 variable: $byteArrayList
                                            tmp171 = getVarScalar(interp, "byteArrayList", compiledLocals, 26);
                                            tmp171.preserve();
                                            objv170[0] = tmp171;
                                            // Arg 1 constant: get
                                            objv170[1] = const45;
                                            // Arg 2 variable: $i
                                            tmp171 = getVarScalar(interp, "i", compiledLocals, 27);
                                            tmp171.preserve();
                                            objv170[2] = tmp171;
                                            TJC.invoke(interp, null, objv170, 0);
                                        } finally {
                                            tmp171 = objv170[0];
                                            if ( tmp171 != null ) {
                                                tmp171.release();
                                            }
                                            tmp171 = objv170[2];
                                            if ( tmp171 != null ) {
                                                tmp171.release();
                                            }
                                            TJC.releaseObjv(interp, objv170, 3);
                                        }
                                    } // End Invoke: ...
                                    tmp169 = interp.getResult();
                                    tmp169.preserve();
                                    objv168[2] = tmp169;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                        ? cmdcache5.cmd : null), objv168, 0);
                                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                        updateCmdCache(interp, 5);
                                    }
                                } finally {
                                    tmp169 = objv168[2];
                                    if ( tmp169 != null ) {
                                        tmp169.release();
                                    }
                                    TJC.releaseObjv(interp, objv168, 3);
                                }
                            } // End Invoke: java::cast
                            tmp167 = interp.getResult();
                            setVarScalar(interp, "class_bytes", tmp167, compiledLocals, 29);
                        } // End Invoke: set
                        { // Invoke: lappend results $class_name $class_bytes
                            TclObject[] objv172 = TJC.grabObjv(interp, 2);
                            TclObject tmp173;
                            try {
                                // Arg 2 variable: $class_name
                                tmp173 = getVarScalar(interp, "class_name", compiledLocals, 28);
                                tmp173.preserve();
                                objv172[0] = tmp173;
                                // Arg 3 variable: $class_bytes
                                tmp173 = getVarScalar(interp, "class_bytes", compiledLocals, 29);
                                tmp173.preserve();
                                objv172[1] = tmp173;
                                interp.resetResult();
                                lappendVarScalar(interp, "results", objv172, compiledLocals, 17);
                            } finally {
                                TJC.releaseObjvElems(interp, objv172, 2);
                            }
                        } // End Invoke: lappend
                        } catch (TclException ex) {
                            int type = ex.getCompletionCode();
                            if (type == TCL.BREAK) {
                                break;
                            } else if (type == TCL.CONTINUE) {
                                continue;
                            } else {
                                throw ex;
                            }
                        }
                    }
                } // End Invoke: for
                { // Invoke: return $results
                    TclObject tmp174 = getVarScalar(interp, "results", compiledLocals, 17);
                    interp.resetResult();
                    interp.setResult(tmp174);
                    if ( true ) { return; }
                } // End Invoke: return
            } else {
                interp.resetResult();
            }
        } // End Invoke: if
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "pizzaCompile");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;
    TclObject const21;
    TclObject const22;
    TclObject const23;
    TclObject const24;
    TclObject const25;
    TclObject const26;
    TclObject const27;
    TclObject const28;
    TclObject const29;
    TclObject const30;
    TclObject const31;
    TclObject const32;
    TclObject const33;
    TclObject const34;
    TclObject const35;
    TclObject const36;
    TclObject const37;
    TclObject const38;
    TclObject const39;
    TclObject const40;
    TclObject const41;
    TclObject const42;
    TclObject const43;
    TclObject const44;
    TclObject const45;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("error");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("JAVA_INIT not set, initJavaCompiler must have been invoked");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("empty string passed as filename");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("net.sf.pizzacompiler.compiler");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("java.util");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("java.io");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("tcl.lang");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("java::new");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("put");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("java::call");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("init");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("argument");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("-pizza");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("-nowarn");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("setClassReader");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("java::null");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("String[]");
        const16.preserve(); const16.preserve();
        const17 = TclInteger.newInstance(1);
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("compile");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance("getErrorsAndWarnings");
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance("isEmpty");
        const20.preserve(); const20.preserve();
        const21 = TclString.newInstance("iterator");
        const21.preserve(); const21.preserve();
        const22 = TclString.newInstance("");
        const22.preserve(); const22.preserve();
        const23 = TclString.newInstance("hasNext");
        const23.preserve(); const23.preserve();
        const24 = TclString.newInstance("next");
        const24.preserve(); const24.preserve();
        const25 = TclString.newInstance("toString");
        const25.preserve(); const25.preserve();
        const26 = TclString.newInstance("getFilesToBytecode");
        const26.preserve(); const26.preserve();
        const27 = TclString.newInstance("entrySet");
        const27.preserve(); const27.preserve();
        const28 = TclString.newInstance("java::cast");
        const28.preserve(); const28.preserve();
        const29 = TclString.newInstance("java.util.Map.Entry");
        const29.preserve(); const29.preserve();
        const30 = TclString.newInstance("String");
        const30.preserve(); const30.preserve();
        const31 = TclString.newInstance("getKey");
        const31.preserve(); const31.preserve();
        const32 = TclString.newInstance("byte[]");
        const32.preserve(); const32.preserve();
        const33 = TclString.newInstance("getValue");
        const33.preserve(); const33.preserve();
        const34 = TclString.newInstance("lsort");
        const34.preserve(); const34.preserve();
        const35 = TclString.newInstance("-dictionary");
        const35.preserve(); const35.preserve();
        const36 = TclString.newInstance("array");
        const36.preserve(); const36.preserve();
        const37 = TclString.newInstance("names");
        const37.preserve(); const37.preserve();
        const38 = TclString.newInstance("cnames");
        const38.preserve(); const38.preserve();
        const39 = TclString.newInstance("getBytecode");
        const39.preserve(); const39.preserve();
        const40 = TclInteger.newInstance(0);
        const40.preserve(); const40.preserve();
        const41 = TclString.newInstance("size");
        const41.preserve(); const41.preserve();
        const42 = TclString.newInstance("string");
        const42.preserve(); const42.preserve();
        const43 = TclString.newInstance("map");
        const43.preserve(); const43.preserve();
        const44 = TclString.newInstance(".java \"\" / .");
        const44.preserve(); const44.preserve();
        const45 = TclString.newInstance("get");
        const45.preserve(); const45.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "error";
                break;
            }
            case 2: {
                cmdName = "java::new";
                break;
            }
            case 3: {
                cmdName = "java::call";
                break;
            }
            case 4: {
                cmdName = "java::null";
                break;
            }
            case 5: {
                cmdName = "java::cast";
                break;
            }
            case 6: {
                cmdName = "array";
                break;
            }
            case 7: {
                cmdName = "lsort";
                break;
            }
            case 8: {
                cmdName = "string";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "filename",
        "srccode",
        "JAVA_INIT",
        "env",
        "pizza",
        "util",
        "io",
        "tcl",
        "sourceHash",
        "compilerSource",
        "compilerOutput",
        "print",
        "allFiles",
        "errs",
        "iter",
        "msg",
        "map",
        "results",
        "inner",
        "entry",
        "key",
        "value",
        "cname",
        "cdata",
        "cnames",
        "sorted_cnames",
        "byteArrayList",
        "i",
        "class_name",
        "class_bytes"
    };
} // end class PizzaCompileCmd

