// TJC implementation of procedure reload
package tjc;
import tcl.lang.*;

public class ReloadCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 8, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 1) {
            throw new TclNumArgsException(interp, 1, objv, "");
        }
        { // Invoke: global _tjc
            TJC.makeGlobalLinkVar(interp, "_tjc", "_tjc", 0);
        } // End Invoke: global
        { // Invoke: set debug 0
            setVarScalar(interp, "debug", const0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: if ... ... else ...
            // Unary operator: ! [...]
            { // Invoke: info exists _tjc(tjc_load_dir)
                TclObject[] objv0 = TJC.grabObjv(interp, 3);
                try {
                    // Arg 0 constant: info
                    objv0[0] = const1;
                    // Arg 1 constant: exists
                    objv0[1] = const2;
                    // Arg 2 constant: _tjc(tjc_load_dir)
                    objv0[2] = const3;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv0, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv0, 3);
                }
            } // End Invoke: info
            TclObject tmp1 = interp.getResult();
            ExprValue tmp2 = evs0;
            if ( tmp1.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp2, tmp1);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp2, tmp1);
            }
            // End Unary operator: !
            boolean tmp3 = ( tmp2.getIntValue() != 0 );
            if ( tmp3 ) {
                { // Invoke: set script [...]
                    TclObject tmp4;
                    { // Invoke: info script
                        TclObject[] objv5 = TJC.grabObjv(interp, 2);
                        try {
                            // Arg 0 constant: info
                            objv5[0] = const1;
                            // Arg 1 constant: script
                            objv5[1] = const4;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv5, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv5, 2);
                        }
                    } // End Invoke: info
                    tmp4 = interp.getResult();
                    setVarScalar(interp, "script", tmp4, compiledLocals, 2);
                } // End Invoke: set
                { // Invoke: set dir [...]
                    TclObject tmp6;
                    { // Invoke: file dirname $script
                        TclObject[] objv7 = TJC.grabObjv(interp, 3);
                        TclObject tmp8;
                        try {
                            // Arg 0 constant: file
                            objv7[0] = const5;
                            // Arg 1 constant: dirname
                            objv7[1] = const6;
                            // Arg 2 variable: $script
                            tmp8 = getVarScalar(interp, "script", compiledLocals, 2);
                            tmp8.preserve();
                            objv7[2] = tmp8;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv7, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp8 = objv7[2];
                            if ( tmp8 != null ) {
                                tmp8.release();
                            }
                            TJC.releaseObjv(interp, objv7, 3);
                        }
                    } // End Invoke: file
                    tmp6 = interp.getResult();
                    setVarScalar(interp, "dir", tmp6, compiledLocals, 3);
                } // End Invoke: set
                { // Invoke: if {$debug} ...
                    TclObject tmp9 = getVarScalar(interp, "debug", compiledLocals, 1);
                    boolean tmp10 = TJC.getBoolean(interp, tmp9);
                    if ( tmp10 ) {
                        { // Invoke: puts "..."
                            TclObject[] objv11 = TJC.grabObjv(interp, 2);
                            TclObject tmp12;
                            try {
                                // Arg 0 constant: puts
                                objv11[0] = const7;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp13 = new StringBuffer(64);
                                sbtmp13.append("info script reports ");
                                sbtmp13.append("\"");
                                tmp12 = getVarScalar(interp, "script", compiledLocals, 2);
                                sbtmp13.append(tmp12.toString());
                                sbtmp13.append("\"");
                                tmp12 = TclString.newInstance(sbtmp13);
                                tmp12.preserve();
                                objv11[1] = tmp12;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv11, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                tmp12 = objv11[1];
                                if ( tmp12 != null ) {
                                    tmp12.release();
                                }
                                TJC.releaseObjv(interp, objv11, 2);
                            }
                        } // End Invoke: puts
                        { // Invoke: puts "..."
                            TclObject[] objv14 = TJC.grabObjv(interp, 2);
                            TclObject tmp15;
                            try {
                                // Arg 0 constant: puts
                                objv14[0] = const7;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp16 = new StringBuffer(64);
                                sbtmp16.append("script dir is ");
                                sbtmp16.append("\"");
                                tmp15 = getVarScalar(interp, "dir", compiledLocals, 3);
                                sbtmp16.append(tmp15.toString());
                                sbtmp16.append("\"");
                                tmp15 = TclString.newInstance(sbtmp16);
                                tmp15.preserve();
                                objv14[1] = tmp15;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv14, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                tmp15 = objv14[1];
                                if ( tmp15 != null ) {
                                    tmp15.release();
                                }
                                TJC.releaseObjv(interp, objv14, 2);
                            }
                        } // End Invoke: puts
                    }
                } // End Invoke: if
                { // Invoke: set _tjc(tjc_load_dir) $dir
                    TclObject tmp17;
                    tmp17 = getVarScalar(interp, "dir", compiledLocals, 3);
                    setVarArray(interp, "_tjc", "tjc_load_dir", tmp17, compiledLocals, 0);
                } // End Invoke: set
            } else {
                { // Invoke: set dir $_tjc(tjc_load_dir)
                    TclObject tmp18;
                    tmp18 = getVarArray(interp, "_tjc", "tjc_load_dir", compiledLocals, 0);
                    setVarScalar(interp, "dir", tmp18, compiledLocals, 3);
                } // End Invoke: set
                { // Invoke: if {$debug} ...
                    TclObject tmp19 = getVarScalar(interp, "debug", compiledLocals, 1);
                    boolean tmp20 = TJC.getBoolean(interp, tmp19);
                    if ( tmp20 ) {
                        { // Invoke: puts "..."
                            TclObject[] objv21 = TJC.grabObjv(interp, 2);
                            TclObject tmp22;
                            try {
                                // Arg 0 constant: puts
                                objv21[0] = const7;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp23 = new StringBuffer(64);
                                sbtmp23.append("reloading from ");
                                tmp22 = getVarScalar(interp, "dir", compiledLocals, 3);
                                sbtmp23.append(tmp22.toString());
                                tmp22 = TclString.newInstance(sbtmp23);
                                tmp22.preserve();
                                objv21[1] = tmp22;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv21, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                tmp22 = objv21[1];
                                if ( tmp22 != null ) {
                                    tmp22.release();
                                }
                                TJC.releaseObjv(interp, objv21, 2);
                            }
                        } // End Invoke: puts
                    }
                } // End Invoke: if
            }
        } // End Invoke: if
        { // Invoke: set regular_files [...]
            TclObject tmp24;
            { // Invoke: list compileproc.tcl descend.tcl emitter.tcl jdk.tcl main.tcl module.tcl nameproc.tcl parse.tcl parseproc.tcl util.tcl
                TclObject tmp25 = TclList.newInstance();
                try {
                    TclList.append(interp, tmp25, const8);
                    TclList.append(interp, tmp25, const9);
                    TclList.append(interp, tmp25, const10);
                    TclList.append(interp, tmp25, const11);
                    TclList.append(interp, tmp25, const12);
                    TclList.append(interp, tmp25, const13);
                    TclList.append(interp, tmp25, const14);
                    TclList.append(interp, tmp25, const15);
                    TclList.append(interp, tmp25, const16);
                    TclList.append(interp, tmp25, const17);
                } catch (TclException ex) {
                    tmp25.release();
                    throw ex;
                }
                interp.setResult(tmp25);
            } // End Invoke: list
            tmp24 = interp.getResult();
            setVarScalar(interp, "regular_files", tmp24, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set embedded_files [...]
            TclObject tmp26;
            { // Invoke: list compileproc.tcl descend.tcl emitter.tcl module.tcl parse.tcl
                TclObject tmp27 = TclList.newInstance();
                try {
                    TclList.append(interp, tmp27, const8);
                    TclList.append(interp, tmp27, const9);
                    TclList.append(interp, tmp27, const10);
                    TclList.append(interp, tmp27, const13);
                    TclList.append(interp, tmp27, const15);
                } catch (TclException ex) {
                    tmp27.release();
                    throw ex;
                }
                interp.setResult(tmp27);
            } // End Invoke: list
            tmp26 = interp.getResult();
            setVarScalar(interp, "embedded_files", tmp26, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: if ... ... else ...
            // Binary operator: [...] && $_tjc(...)
            { // Invoke: info exists _tjc(embedded)
                TclObject[] objv28 = TJC.grabObjv(interp, 3);
                try {
                    // Arg 0 constant: info
                    objv28[0] = const1;
                    // Arg 1 constant: exists
                    objv28[1] = const2;
                    // Arg 2 constant: _tjc(embedded)
                    objv28[2] = const18;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv28, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv28, 3);
                }
            } // End Invoke: info
            TclObject tmp29 = interp.getResult();
            ExprValue tmp30 = evs0;
            TJC.exprInitValue(interp, tmp30, tmp29);
            if (tmp30.getBooleanValue(interp)) {
            TclObject tmp31 = getVarArray(interp, "_tjc", "embedded", compiledLocals, 0);
            ExprValue tmp32 = evs1;
            TJC.exprInitValue(interp, tmp32, tmp31);
            tmp30.setIntValue(tmp32.getBooleanValue(interp));
            } else {
            tmp30.setIntValue(0);
            } // End if: [...]
            // End Binary operator: &&
            boolean tmp33 = ( tmp30.getIntValue() != 0 );
            if ( tmp33 ) {
                { // Invoke: set files $embedded_files
                    TclObject tmp34;
                    tmp34 = getVarScalar(interp, "embedded_files", compiledLocals, 5);
                    setVarScalar(interp, "files", tmp34, compiledLocals, 6);
                } // End Invoke: set
            } else {
                { // Invoke: set files $regular_files
                    TclObject tmp35;
                    tmp35 = getVarScalar(interp, "regular_files", compiledLocals, 4);
                    setVarScalar(interp, "files", tmp35, compiledLocals, 6);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: foreach file $files ...
            TclObject tmp36 = null;
            try {
                tmp36 = getVarScalar(interp, "files", compiledLocals, 6);
                tmp36.preserve();
                final int tmp36_length = TclList.getLength(interp, tmp36);

                for ( int index37 = 0 ; index37 < tmp36_length ; index37++ ) {
                    TclObject tmp38 = TclList.index(interp, tmp36, index37);
                    try {
                        setVarScalar(interp, "file", tmp38, compiledLocals, 7);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "file");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: if {$debug} ...
                        TclObject tmp39 = getVarScalar(interp, "debug", compiledLocals, 1);
                        boolean tmp40 = TJC.getBoolean(interp, tmp39);
                        if ( tmp40 ) {
                            { // Invoke: puts "source $dir/$file"
                                TclObject[] objv41 = TJC.grabObjv(interp, 2);
                                TclObject tmp42;
                                try {
                                    // Arg 0 constant: puts
                                    objv41[0] = const7;
                                    // Arg 1 word: "source $dir/$file"
                                    StringBuffer sbtmp43 = new StringBuffer(64);
                                    sbtmp43.append("source ");
                                    tmp42 = getVarScalar(interp, "dir", compiledLocals, 3);
                                    sbtmp43.append(tmp42.toString());
                                    sbtmp43.append("/");
                                    tmp42 = getVarScalar(interp, "file", compiledLocals, 7);
                                    sbtmp43.append(tmp42.toString());
                                    tmp42 = TclString.newInstance(sbtmp43);
                                    tmp42.preserve();
                                    objv41[1] = tmp42;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                        ? cmdcache3.cmd : null), objv41, 0);
                                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                        updateCmdCache(interp, 3);
                                    }
                                } finally {
                                    tmp42 = objv41[1];
                                    if ( tmp42 != null ) {
                                        tmp42.release();
                                    }
                                    TJC.releaseObjv(interp, objv41, 2);
                                }
                            } // End Invoke: puts
                        }
                    } // End Invoke: if
                    { // Invoke: uplevel #0 [...]
                        TclObject[] objv44 = TJC.grabObjv(interp, 3);
                        TclObject tmp45;
                        try {
                            // Arg 0 constant: uplevel
                            objv44[0] = const19;
                            // Arg 1 constant: #0
                            objv44[1] = const20;
                            // Arg 2 command: [...]
                            { // Invoke: list source $dir/$file
                                TclObject tmp46 = TclList.newInstance();
                                TclObject tmp47;
                                try {
                                    TclList.append(interp, tmp46, const21);
                                    StringBuffer sbtmp48 = new StringBuffer(64);
                                    tmp47 = getVarScalar(interp, "dir", compiledLocals, 3);
                                    sbtmp48.append(tmp47.toString());
                                    sbtmp48.append("/");
                                    tmp47 = getVarScalar(interp, "file", compiledLocals, 7);
                                    sbtmp48.append(tmp47.toString());
                                    tmp47 = TclString.newInstance(sbtmp48);
                                    TclList.append(interp, tmp46, tmp47);
                                } catch (TclException ex) {
                                    tmp46.release();
                                    throw ex;
                                }
                                interp.setResult(tmp46);
                            } // End Invoke: list
                            tmp45 = interp.getResult();
                            tmp45.preserve();
                            objv44[2] = tmp45;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv44, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            tmp45 = objv44[2];
                            if ( tmp45 != null ) {
                                tmp45.release();
                            }
                            TJC.releaseObjv(interp, objv44, 3);
                        }
                    } // End Invoke: uplevel
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
                interp.resetResult();
            } finally {
                if ( tmp36 != null ) {
                    tmp36.release();
                }
            }
        } // End Invoke: foreach
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "reload");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;
    TclObject const21;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(0);
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("info");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("exists");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("_tjc(tjc_load_dir)");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("script");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("file");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("dirname");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("puts");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("compileproc.tcl");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("descend.tcl");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("emitter.tcl");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("jdk.tcl");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("main.tcl");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("module.tcl");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("nameproc.tcl");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("parse.tcl");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("parseproc.tcl");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("util.tcl");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("_tjc(embedded)");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance("uplevel");
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance("#0");
        const20.preserve(); const20.preserve();
        const21 = TclString.newInstance("source");
        const21.preserve(); const21.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "info";
                break;
            }
            case 2: {
                cmdName = "file";
                break;
            }
            case 3: {
                cmdName = "puts";
                break;
            }
            case 4: {
                cmdName = "uplevel";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "_tjc",
        "debug",
        "script",
        "dir",
        "regular_files",
        "embedded_files",
        "files",
        "file"
    };
} // end class ReloadCmd

