// TJC implementation of procedure validate_options
package tjc;
import tcl.lang.*;

public class ValidateOptionsCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 3, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 1) {
            throw new TclNumArgsException(interp, 1, objv, "");
        }
        { // Invoke: global _tjc
            TJC.makeGlobalLinkVar(interp, "_tjc", "_tjc", 0);
        } // End Invoke: global
        { // Invoke: global _cmdline
            TJC.makeGlobalLinkVar(interp, "_cmdline", "_cmdline", 1);
        } // End Invoke: global
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: info exists _tjc(debug)
                TclObject[] objv0 = TJC.grabObjv(interp, 3);
                try {
                    // Arg 0 constant: info
                    objv0[0] = const0;
                    // Arg 1 constant: exists
                    objv0[1] = const1;
                    // Arg 2 constant: _tjc(debug)
                    objv0[2] = const2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv0, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv0, 3);
                }
            } // End Invoke: info
            TclObject tmp1 = interp.getResult();
            ExprValue tmp2 = evs0;
            if ( tmp1.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp2, tmp1);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp2, tmp1);
            }
            // End Unary operator: !
            boolean tmp3 = ( tmp2.getIntValue() != 0 );
            if ( tmp3 ) {
                { // Invoke: set _tjc(debug) 0
                    setVarArray(interp, "_tjc", "debug", const3, compiledLocals, 0);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: info exists _tjc(progress)
                TclObject[] objv4 = TJC.grabObjv(interp, 3);
                try {
                    // Arg 0 constant: info
                    objv4[0] = const0;
                    // Arg 1 constant: exists
                    objv4[1] = const1;
                    // Arg 2 constant: _tjc(progress)
                    objv4[2] = const4;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv4, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv4, 3);
                }
            } // End Invoke: info
            TclObject tmp5 = interp.getResult();
            ExprValue tmp6 = evs0;
            if ( tmp5.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp6, tmp5);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp6, tmp5);
            }
            // End Unary operator: !
            boolean tmp7 = ( tmp6.getIntValue() != 0 );
            if ( tmp7 ) {
                { // Invoke: set _tjc(progress) 0
                    setVarArray(interp, "_tjc", "progress", const3, compiledLocals, 0);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: info exists _tjc(compiler)
                TclObject[] objv8 = TJC.grabObjv(interp, 3);
                try {
                    // Arg 0 constant: info
                    objv8[0] = const0;
                    // Arg 1 constant: exists
                    objv8[1] = const1;
                    // Arg 2 constant: _tjc(compiler)
                    objv8[2] = const5;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv8, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv8, 3);
                }
            } // End Invoke: info
            TclObject tmp9 = interp.getResult();
            ExprValue tmp10 = evs0;
            if ( tmp9.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp10, tmp9);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp10, tmp9);
            }
            // End Unary operator: !
            boolean tmp11 = ( tmp10.getIntValue() != 0 );
            if ( tmp11 ) {
                { // Invoke: set _tjc(compiler) "javac"
                    setVarArray(interp, "_tjc", "compiler", const6, compiledLocals, 0);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: foreach option $_cmdline(options) ...
            TclObject tmp12 = null;
            try {
                tmp12 = getVarArray(interp, "_cmdline", "options", compiledLocals, 1);
                tmp12.preserve();
                final int tmp12_length = TclList.getLength(interp, tmp12);

                for ( int index13 = 0 ; index13 < tmp12_length ; index13++ ) {
                    TclObject tmp14 = TclList.index(interp, tmp12, index13);
                    try {
                        setVarScalar(interp, "option", tmp14, compiledLocals, 2);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "option");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: if ... ... elseif ... ... else ...
                        { // Invoke: string match *.tcl $option
                            TclObject[] objv15 = TJC.grabObjv(interp, 4);
                            TclObject tmp16;
                            try {
                                // Arg 0 constant: string
                                objv15[0] = const7;
                                // Arg 1 constant: match
                                objv15[1] = const8;
                                // Arg 2 constant: *.tcl
                                objv15[2] = const9;
                                // Arg 3 variable: $option
                                tmp16 = getVarScalar(interp, "option", compiledLocals, 2);
                                tmp16.preserve();
                                objv15[3] = tmp16;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv15, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                tmp16 = objv15[3];
                                if ( tmp16 != null ) {
                                    tmp16.release();
                                }
                                TJC.releaseObjv(interp, objv15, 4);
                            }
                        } // End Invoke: string
                        TclObject tmp17 = interp.getResult();
                        ExprValue tmp18 = evs0;
                        TJC.exprInitValue(interp, tmp18, tmp17);
                        boolean tmp19 = tmp18.getBooleanValue(interp);
                        if ( tmp19 ) {
                            { // Invoke: error "..."
                                TclObject[] objv20 = TJC.grabObjv(interp, 2);
                                TclObject tmp21;
                                try {
                                    // Arg 0 constant: error
                                    objv20[0] = const10;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp22 = new StringBuffer(64);
                                    sbtmp22.append("Tcl source file ");
                                    tmp21 = getVarScalar(interp, "option", compiledLocals, 2);
                                    sbtmp22.append(tmp21.toString());
                                    sbtmp22.append(" is not a valid argument, pass TJC module file");
                                    tmp21 = TclString.newInstance(sbtmp22);
                                    tmp21.preserve();
                                    objv20[1] = tmp21;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                        ? cmdcache3.cmd : null), objv20, 0);
                                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                        updateCmdCache(interp, 3);
                                    }
                                } finally {
                                    tmp21 = objv20[1];
                                    if ( tmp21 != null ) {
                                        tmp21.release();
                                    }
                                    TJC.releaseObjv(interp, objv20, 2);
                                }
                            } // End Invoke: error
                        } else {
                            // Binary operator: [...] == "-"
                            { // Invoke: string index $option 0
                                TclObject tmp23 = getVarScalar(interp, "option", compiledLocals, 2);
                                String tmp24 = tmp23.toString();
                                TclObject tmp25 = TJC.stringIndex(interp, tmp24, const3);
                                interp.setResult(tmp25);
                            } // End Invoke: string
                            TclObject tmp26 = interp.getResult();
                            boolean tmp27 = tmp26.toString().equals("-");
                            ExprValue tmp28 = evs0;
                            tmp28.setIntValue(tmp27);
                            // End Binary operator: ==
                            boolean tmp29 = ( tmp28.getIntValue() != 0 );
                            if ( tmp29 ) {
                                { // Invoke: switch -- $option {-debug} ... {-nocompile} ... {-progress} ... {-javac} ... {-pizza} ... {-janino} ...
                                    TclObject tmp30 = getVarScalar(interp, "option", compiledLocals, 2);
                                    String tmp31 = tmp30.toString();
                                    int tmp31_length = tmp31.length();
                                    char tmp31_first = '\n';
                                    if ( tmp31_length > 0 ) {
                                        tmp31_first = tmp31.charAt(0);
                                    }
                                    if ( tmp31_length == 6 && tmp31_first == '-'
                                            && tmp31.compareTo("-debug") == 0 ) {
                                        // Pattern {-debug}
                                        { // Invoke: set _tjc(debug) 1
                                            setVarArray(interp, "_tjc", "debug", const11, compiledLocals, 0);
                                        } // End Invoke: set
                                    } else if ( tmp31_length == 10 && tmp31_first == '-'
                                            && tmp31.compareTo("-nocompile") == 0 ) {
                                        // Pattern {-nocompile}
                                        { // Invoke: set _tjc(nocompile) 1
                                            setVarArray(interp, "_tjc", "nocompile", const11, compiledLocals, 0);
                                        } // End Invoke: set
                                    } else if ( tmp31_length == 9 && tmp31_first == '-'
                                            && tmp31.compareTo("-progress") == 0 ) {
                                        // Pattern {-progress}
                                        { // Invoke: set _tjc(progress) 1
                                            setVarArray(interp, "_tjc", "progress", const11, compiledLocals, 0);
                                        } // End Invoke: set
                                    } else if ( tmp31_length == 6 && tmp31_first == '-'
                                            && tmp31.compareTo("-javac") == 0 ) {
                                        // Pattern {-javac}
                                        { // Invoke: set _tjc(compiler) javac
                                            setVarArray(interp, "_tjc", "compiler", const6, compiledLocals, 0);
                                        } // End Invoke: set
                                    } else if ( tmp31_length == 6 && tmp31_first == '-'
                                            && tmp31.compareTo("-pizza") == 0 ) {
                                        // Pattern {-pizza}
                                        { // Invoke: set _tjc(compiler) pizza
                                            setVarArray(interp, "_tjc", "compiler", const12, compiledLocals, 0);
                                        } // End Invoke: set
                                    } else if ( tmp31_length == 7 && tmp31_first == '-'
                                            && tmp31.compareTo("-janino") == 0 ) {
                                        // Pattern {-janino}
                                        { // Invoke: set _tjc(compiler) janino
                                            setVarArray(interp, "_tjc", "compiler", const13, compiledLocals, 0);
                                        } // End Invoke: set
                                    }
                                } // End Invoke: switch
                            } else {
                                { // Invoke: error "..."
                                    TclObject[] objv32 = TJC.grabObjv(interp, 2);
                                    TclObject tmp33;
                                    try {
                                        // Arg 0 constant: error
                                        objv32[0] = const10;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp34 = new StringBuffer(64);
                                        sbtmp34.append("option ");
                                        tmp33 = getVarScalar(interp, "option", compiledLocals, 2);
                                        sbtmp34.append(tmp33.toString());
                                        sbtmp34.append(" is invalid");
                                        tmp33 = TclString.newInstance(sbtmp34);
                                        tmp33.preserve();
                                        objv32[1] = tmp33;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                            ? cmdcache3.cmd : null), objv32, 0);
                                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                            updateCmdCache(interp, 3);
                                        }
                                    } finally {
                                        tmp33 = objv32[1];
                                        if ( tmp33 != null ) {
                                            tmp33.release();
                                        }
                                        TJC.releaseObjv(interp, objv32, 2);
                                    }
                                } // End Invoke: error
                            }
                        }
                    } // End Invoke: if
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
                interp.resetResult();
            } finally {
                if ( tmp12 != null ) {
                    tmp12.release();
                }
            }
        } // End Invoke: foreach
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "validate_options");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("info");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("exists");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("_tjc(debug)");
        const2.preserve(); const2.preserve();
        const3 = TclInteger.newInstance(0);
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("_tjc(progress)");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("_tjc(compiler)");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("javac");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("string");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("match");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("*.tcl");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("error");
        const10.preserve(); const10.preserve();
        const11 = TclInteger.newInstance(1);
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("pizza");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("janino");
        const13.preserve(); const13.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "info";
                break;
            }
            case 2: {
                cmdName = "string";
                break;
            }
            case 3: {
                cmdName = "error";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "_tjc",
        "_cmdline",
        "option"
    };
} // end class ValidateOptionsCmd

